jQuery( function( $ ) {

	$(document).ready(function() {
		var xorgcore_last_check_date = localStorage.getItem( "xorgcore_popup_displayed_next_time" );
		if ( null != xorgcore_last_check_date ) {
			if ( (new Date()).getTime() > xorgcore_last_check_date ) {
				localStorage.removeItem( "xorgcore_popup_displayed_next_time" );
				localStorage.removeItem( "xorgcore_popup_displayed" );
			}
		}

		
		localStorage.setItem( "xorgcore_avoid_multiple", "no" );
	});

	var xorgcore_product_id = "";
	var xorgcore_atc_modal_data = {
        xorgcore_heading_section_text_email: xorgcore_atc_modal_param.xorgcore_atc_head,
        xorgcore_text_section_text_field:    xorgcore_atc_modal_param.xorgcore_atc_text,
        xorgcore_email_placeholder_section_input_text: xorgcore_atc_modal_param.xorgcore_atc_email_place,
        xorgcore_button_section_input_text : xorgcore_atc_modal_param.xorgcore_atc_button,
        xorgcore_button_bg_color : xorgcore_atc_modal_param.xorgcore_atc_button_bg_color,
        xorgcore_button_text_color : xorgcore_atc_modal_param.xorgcore_atc_button_text_color,
        xorgcore_popup_text_color : xorgcore_atc_modal_param.xorgcore_atc_popup_text_color,
        xorgcore_popup_heading_color : xorgcore_atc_modal_param.xorgcore_atc_popup_heading_color,
        xorgcore_non_mandatory_modal_input_text : xorgcore_atc_modal_param.xorgcore_atc_non_mandatory_input_text,
        xorgcore_atc_button: {
            backgroundColor: xorgcore_atc_modal_param.xorgcore_atc_button_bg_color,
            color          : xorgcore_atc_modal_param.xorgcore_atc_button_text_color
        },
        xorgcore_atc_popup_text:{
            color          : xorgcore_atc_modal_param.xorgcore_atc_popup_text_color,
        },
        xorgcore_atc_popup_heading:{
            color          : xorgcore_atc_modal_param.xorgcore_atc_popup_heading_color,
        }
    };

    $( document.body ).on( 'wc_fragments_refreshed', function( response_dat ) {

		var xorgcore_response = response_dat.target.innerHTML;
		
		if ( xorgcore_response.indexOf('button wc-forward') >= 0 ){

			var xorgcore_is_popup_displayed = localStorage.getItem("xorgcore_popup_displayed");
			if ( ( typeof xorgcore_is_popup_displayed === undefined ) || ( xorgcore_is_popup_displayed != "yes" ) ) {
				localStorage.setItem("xorgcore_popup_displayed", "yes");

				var xorgcore_next_date = new Date();
				xorgcore_next_date.setHours( xorgcore_next_date.getHours() + 24);
				localStorage.setItem("xorgcore_popup_displayed_next_time", xorgcore_next_date.getTime() );

    	        var xorgcore_email_data = {
					xorgcore_atc_email       : localStorage.getItem("xorgcore_hidden_email_id"),
					xorgcore_atc_user_action : localStorage.getItem("xorgcore_atc_user_action"),
					action: 'xorgcore_atc_store_guest_email'
				}
				$.post( wc_cart_fragments_params.wc_ajax_url.toString().replace( '%%endpoint%%', 'xorgcore_atc_store_guest_email' ), xorgcore_email_data, function(response_dat , status, xhr ) {
					if ( status === 'success' && response_dat ) {
						close();
						localStorage.setItem( "xorgcore_abandoned_id", response_dat );
					}
		    	} );
			}
		}
    } );

	
	var xorgcore_single_simple_atc = function() {
		$( document )
			.on( 'click', '.single_add_to_cart_button', this.xorgcore_on_single_add_to_cart )
			.on( 'click', '.add_to_cart_button', this.xorgcore_on_single_add_to_cart )
			.on( 'added_to_cart', this.updateButton )
			.on( 'click', '.xorgcore_popup_button', this.xorgcore_add_to_cart_from_shop )
			.on( 'click', '.xorgcore_popup_non_mandatory_button', this.xorgcore_add_product_to_cart )
			.on( 'click', '.xorgcore_popup_close', close );

		$( document ).keydown(function(e) {
            if (e.keyCode == 27) {
                close();
            }
        });
	}

	
	xorgcore_single_simple_atc.prototype.xorgcore_on_single_add_to_cart = function( e ) {

		var xorgcore_is_popup_displayed = localStorage.getItem("xorgcore_popup_displayed");
		if( ( typeof xorgcore_is_popup_displayed === undefined  ||  xorgcore_is_popup_displayed != "yes" ) &&
			"" == xorgcore_atc_modal_param.xorgcore_populate_email &&
			'yes' !== localStorage.getItem( 'xorgcore_mailchimp_captured' ) &&
			'yes' !== localStorage.getItem( 'xorgcore_avoid_multiple' ) ) {
			e.preventDefault();

			if ( $(this).data( 'product_id' ) ){
				xorgcore_product_id = $(this).data( 'product_id' );
			} else {
				xorgcore_product_id = this.value;
			}

			
			if ( '' == xorgcore_product_id ) {
				xorgcore_product_id =  document.getElementsByName("add-to-cart")[0].value;
			}
			$("#xorgcore-add-to-cart").val(xorgcore_product_id);
			xorgcore_open_atc_modal();

			localStorage.setItem( "xorgcore_avoid_multiple", "yes" );
		}

		if ( "" != xorgcore_atc_modal_param.xorgcore_populate_email ) {
			localStorage.setItem( "xorgcore_hidden_email_id", xorgcore_atc_modal_param.xorgcore_populate_email );
			localStorage.setItem( "xorgcore_atc_user_action", "yes" );
		}
	};

	function  xorgcore_open_atc_modal (){

		$(document.body).addClass('xorgcore-atc-modal-open').append('<div class="xorgcore-modal-overlay"></div>');
        $(document.body).append('<div class="xorgcore-modal" style="overflow-y:auto; max-height:90%;"><div class="xorgcore-modal__contents"> '+ xorgcore_atc_modal_param.xorgcore_atc_modal_data+ ' </div> </div>');
        xorgcore_atc_position();

        $( document.body ).trigger( 'xorgcore_after_atc_load' );

        var myViewModel = new Vue({
        	el: '#xorgcore_popup_main_div',
        	data: xorgcore_atc_modal_data,
        });

        $(".xorgcore_popup_button").prop("disabled", true);

        $("#xorgcore_popup_input").on("input", function(e) {
		    var xorgcore_get_email_address = $('#xorgcore_popup_input').val();
		    var is_button_disabled = $(".xorgcore_popup_button").is(":disabled");
		    if ( xorgcore_get_email_address.length > 0 && is_button_disabled == true ) {
				$(".xorgcore_popup_button").prop("disabled", false);
		    } else if ( xorgcore_get_email_address.length == 0 && is_button_disabled == false ){
		    	$(".xorgcore_popup_button").prop("disabled", true );
		    }
		});
    }

	function close () {
        $(document.body).removeClass('xorgcore-atc-modal-open xorgcore-modal-loading');
		$('.xorgcore-modal, .xorgcore-modal-overlay').remove();

		localStorage.setItem( "xorgcore_avoid_multiple", "no" );
    }

	function xorgcore_atc_position() {

        $('.xorgcore-modal__body').removeProp('style');

        var modal_header_height = $('.xorgcore-modal__header').outerHeight();
        var modal_height = $('.xorgcore-modal').height();
        var modal_width = $('.xorgcore-modal').width();
        var modal_body_height = $('.xorgcore-modal__body').outerHeight();
        var modal_contents_height = modal_body_height + modal_header_height;

        $('.xorgcore-modal').css({
            'margin-left': -modal_width / 2,
            'margin-top': -modal_height / 2
        });

        if ( modal_height < modal_contents_height - 5 ) {
            $('.xorgcore-modal__body').height( modal_height - modal_header_height );
        }
    }

    
	xorgcore_single_simple_atc.prototype.xorgcore_add_to_cart_from_shop = function( e ) {

		e.preventDefault();
		var xorgcore_get_email_address = $('#xorgcore_popup_input').val();

		
		var pattern = new RegExp(/^09([0-9]{9})$/);

		if ( ! pattern.test( xorgcore_get_email_address  ) ) {
			$( '#xorgcore_placeholder_validated_msg' ).text(xorgcore_atc_modal_param.xorgcore_mandatory_email_text);
			$( "#xorgcore_placeholder_validated_msg" ).fadeIn();
			setTimeout( function(){$( "#xorgcore_placeholder_validated_msg" ).fadeOut();},3000);
		} else {
			if ( xorgcore_atc_modal_param.xorgcore_debounce_key ) {
				var settings = {
					"async": true,
					"crossDomain": true,
					"url": "https://api.debounce.io/v1/?api=" + xorgcore_atc_modal_param.xorgcore_debounce_key + "&email=" + xorgcore_get_email_address,
					"method": "GET",
					"headers": {}
				}

				$.ajax(settings)
				.done(function (response) {
					if ( response.success === '1' ) {
						if( '4' === response.debounce.code || '5' === response.debounce.code || '8' === response.debounce.code ) {
							xorgcore_add_to_cart_action();
						} else {
							$( '#xorgcore_placeholder_validated_msg' ).text(xorgcore_atc_modal_param.xorgcore_mandatory_email_text);
							$( "#xorgcore_placeholder_validated_msg" ).fadeIn();
							setTimeout( function(){$( "#xorgcore_placeholder_validated_msg" ).fadeOut();},3000);
						}
					} else {
						xorgcore_add_to_cart_action();
					}
				})
				.fail(function (error) {
					xorgcore_add_to_cart_action();
				});
			} else {
				xorgcore_add_to_cart_action();
			}
		}
	};

	
	xorgcore_single_simple_atc.prototype.updateButton = function( e, fragments, cart_hash, $button ) {
		$button = typeof $button === 'undefined' ? false : $button;
		if ( $button ) {

			
			if ( ! wc_add_to_cart_params.is_cart ) {

				var xorgcore_is_popup_displayed = localStorage.getItem("xorgcore_popup_displayed");
				if ( ( typeof xorgcore_is_popup_displayed === undefined ) || ( xorgcore_is_popup_displayed != "yes" ) ){
					localStorage.setItem("xorgcore_popup_displayed", "yes");

					var xorgcore_next_date = new Date();
					xorgcore_next_date.setHours( xorgcore_next_date.getHours() + 24 );
					//xorgcore_next_date.setMinutes( xorgcore_next_date.getMinutes() + 4);
					localStorage.setItem("xorgcore_popup_displayed_next_time", xorgcore_next_date.getTime() );

					var xorgcore_email_data = {
						xorgcore_atc_email       : localStorage.getItem("xorgcore_hidden_email_id"),
						xorgcore_atc_user_action : localStorage.getItem("xorgcore_atc_user_action"),
						action: 'xorgcore_atc_store_guest_email'
					}
					$.post( wc_add_to_cart_params.wc_ajax_url.toString().replace( '%%endpoint%%', 'xorgcore_atc_store_guest_email' ), xorgcore_email_data, function( response_dat, status, xhr ) {
						if ( status === 'success' && response_dat ) {
							localStorage.setItem( "xorgcore_abandoned_id", response_dat );
							close();
						}
		        	} );
				}
			}
			$( document.body ).trigger( 'wc_cart_button_updated', [ $button ] );
		}
	};

	xorgcore_single_simple_atc.prototype.xorgcore_add_product_to_cart = function( e ) {
		e.preventDefault();

		if ( "off" == xorgcore_atc_modal_param.xorgcore_atc_mandatory_email ) {
			localStorage.setItem("xorgcore_atc_user_action", "no" );
			xorgcore_add_product_to_cart_for_all();
			close();
		} else {
			var xorgcore_get_email_address = $('#xorgcore_popup_input').val();
			var xorgcore_validate_text = xorgcore_atc_modal_param.xorgcore_mandatory_text;
			if ( xorgcore_get_email_address ) {
				xorgcore_validate_text = xorgcore_atc_modal_param.xorgcore_mandatory_email_text;
			}
			$('#xorgcore_placeholder_validated_msg').text( xorgcore_validate_text );

			$( "#xorgcore_placeholder_validated_msg" ).fadeIn();

			setTimeout( function(){
				$( "#xorgcore_placeholder_validated_msg" ).fadeOut();
				//close();
			},3000);
		}
	}

	function xorgcore_add_to_cart_action() {
		if( $( '#xorgcore_coupon_auto_applied' ).length > 0 ) {
			$( '#xorgcore_coupon_auto_applied' ).text(xorgcore_atc_modal_param.xorgcore_atc_coupon_applied_msg);
			$( '#xorgcore_coupon_auto_applied' ).fadeIn();
			setTimeout( function() {
				$( '#xorgcore_coupon_auto_applied' ).fadeOut();
				xorgcore_get_client_email = $('#xorgcore_popup_input').val();
				localStorage.setItem("xorgcore_hidden_email_id", xorgcore_get_client_email);
				localStorage.setItem("xorgcore_atc_user_action", "yes" );
				xorgcore_add_product_to_cart_for_all();
			}, 3000 );
		} else {
			xorgcore_get_client_email = $('#xorgcore_popup_input').val();
			localStorage.setItem("xorgcore_hidden_email_id", xorgcore_get_client_email);
			localStorage.setItem("xorgcore_atc_user_action", "yes" );
			xorgcore_add_product_to_cart_for_all();
		}
	}

	function xorgcore_add_product_to_cart_for_all (){
		var xorgcore_is_popup_displayed = localStorage.getItem("xorgcore_popup_displayed");

		if ( ( typeof xorgcore_is_popup_displayed === undefined ) || ( xorgcore_is_popup_displayed != "yes" ) ){
			xorgcore_get_client_email = $('#xorgcore_popup_input').val();
			localStorage.setItem("xorgcore_hidden_email_id", xorgcore_get_client_email);
		}

		if ( $('form.cart').length > 0 ) {
			$form = $('form.cart');
			$form.append('<input type="hidden" name="add-to-cart" value="'+xorgcore_product_id+'" />');
			$form.submit();
		} else {
			var href = $( '.ajax_add_to_cart' ).attr('href');
			window.location = href;
		}
	}

	new xorgcore_single_simple_atc();
});
