<?php



if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! class_exists( 'xorgcore_Actions' ) ) {
	
	class xorgcore_Actions {
		
		public static function xorgcore_perform_action( $xorgcore_action, $xorgcore_action_two ) {

			$class = new xorgcore_Actions_Handler();
			
			if ( 'xorgcore_abandoned_delete' === $xorgcore_action || 'xorgcore_abandoned_delete' === $xorgcore_action_two ) {
				$ids = xorgcore_Common::xorgcore_get_abandoned_cart_ids_from_get();
				if ( ! is_array( $ids ) ){
					$ids = array( $ids );
				}
				$xorgcore_abandoned_selected_order_count = count( $ids );
				foreach ( $ids as $id ) {

					$class->xorgcore_delete_bulk_action_handler_function( $id, $xorgcore_abandoned_selected_order_count );
				}
			}

			
			if ( 'xorgcore_abandoned_trash' === $xorgcore_action || 'xorgcore_abandoned_trash' === $xorgcore_action_two ) {
				$ids = xorgcore_Common::xorgcore_get_abandoned_cart_ids_from_get();
				if ( ! is_array( $ids ) ){
					$ids = array( $ids );
				}
				$xorgcore_abandoned_selected_order_count = count ( $ids );
				foreach ( $ids as $id ) {
					$class->xorgcore_abandoned_trash_bulk_action_handler( $id, $xorgcore_abandoned_selected_order_count );
				}
			}

			if ( 'xorgcore_abandoned_trash_visitor' === $xorgcore_action || 'xorgcore_abandoned_trash_visitor' === $xorgcore_action_two ) {
				$class->xorgcore_abandoned_trash_visitor_bulk_action_handler();
			}

			if ( 'xorgcore_abandoned_trash_guest' === $xorgcore_action || 'xorgcore_abandoned_trash_guest' === $xorgcore_action_two ) {
				$class->xorgcore_abandoned_trash_guest_bulk_action_handler();
			}

			if ( 'xorgcore_abandoned_trash_registered' === $xorgcore_action || 'xorgcore_abandoned_trash_registered' === $xorgcore_action_two ) {
				$class->xorgcore_abandoned_trash_registered_bulk_action_handler();
			}

			if ( 'xorgcore_abandoned_trash_all' === $xorgcore_action || 'xorgcore_abandoned_trash_all' === $xorgcore_action_two ) {
				$class->xorgcore_abandoned_trash_all_bulk_action_handler();
			}

			
			if ( 'xorgcore_abandoned_restore' === $xorgcore_action || 'xorgcore_abandoned_restore' === $xorgcore_action_two ) {

				$ids = xorgcore_Common::xorgcore_get_abandoned_cart_ids_from_get();
				if ( ! is_array( $ids ) ){
					$ids = array( $ids );
				}
				$xorgcore_restore_selected_order_count = count( $ids );

				foreach ( $ids as $id ) {
					$class->xorgcore_abandoned_restore_bulk_action_handler( $id, $xorgcore_restore_selected_order_count );
				}
			}

			
			if ( 'xorgcore_rec_delete' === $xorgcore_action || 'xorgcore_rec_delete' === $xorgcore_action_two ) {
				$ids = xorgcore_Common::xorgcore_get_abandoned_cart_ids_from_get();
				if ( ! is_array( $ids ) ){
					$ids = array( $ids );
				}
				foreach ( $ids as $id ) {

					$class->xorgcore_recovered_delete_bulk_action_handler( $id );
				}
			}

			
			if ( 'xorgcore_rec_restore' === $xorgcore_action || 'xorgcore_rec_restore' === $xorgcore_action_two ) {
				$ids = xorgcore_Common::xorgcore_get_abandoned_cart_ids_from_get();
				if ( ! is_array( $ids ) ) {
					$ids = array( $ids );
				}
				$xorgcore_restore_selected_order_count = count( $ids );
				foreach ( $ids as $id ) {

					$class->xorgcore_recovered_restore_bulk_action_handler( $id, $xorgcore_restore_selected_order_count );
				}
			}

			
			$xorgcore_trash_selected_order_count = 0;
			if ( 'xorgcore_rec_trash' === $xorgcore_action || 'xorgcore_rec_trash' === $xorgcore_action_two ) {
				$ids = xorgcore_Common::xorgcore_get_abandoned_cart_ids_from_get();
				if ( ! is_array( $ids ) ) {
					$ids = array( $ids );
				}
				$xorgcore_trash_selected_order_count = count( $ids );
				foreach ( $ids as $id ) {

					$class->xorgcore_recovered_trash_bulk_action_handler( $id, $xorgcore_trash_selected_order_count );
				}
			}

			
			if ( 'xorgcore_delete_template' === $xorgcore_action || 'xorgcore_delete_template' === $xorgcore_action_two ) {
				$ids = xorgcore_Common::xorgcore_get_template_ids_from_get();
				if ( ! is_array( $ids ) ) {
					$ids = array( $ids );
				}
				foreach ( $ids as $id ) {

					$class->xorgcore_delete_template_bulk_action_handler_function( $id );
				}
			}

			
			if ( 'xorgcore_delete_sms_template' === $xorgcore_action || 'xorgcore_delete_sms_template' === $xorgcore_action_two || 
				'xorgcore_delete_fb_template' === $xorgcore_action || 'xorgcore_delete_fb_template' === $xorgcore_action_two ) {

				$ids = xorgcore_Common::xorgcore_get_template_ids_from_get();
				if ( ! is_array( $ids ) ) {
					$ids = array( $ids );
				}
				foreach ( $ids as $id ) {
					xorgcore_SMS::xorgcore_delete_template_data( $id );
				}

				if ( 'xorgcore_delete_sms_template' === $xorgcore_action || 'xorgcore_delete_sms_template' === $xorgcore_action_two ) {
					wp_safe_redirect( admin_url( '/admin.php?page=xcart&action=cart_recovery&section=sms&xorgcore_sms_template_deleted=YES' ) );
				} elseif ( 'xorgcore_delete_fb_template' === $xorgcore_action || 'xorgcore_delete_fb_template' === $xorgcore_action_two ) {
					wp_safe_redirect( admin_url( '/admin.php?page=xcart&action=cart_recovery&section=fb_templates&xorgcore_fb_template_deleted=YES' ) );
				}
			}

			
			if ( 'emailtemplates&mode=xorgcore_manual_email' === $xorgcore_action ) {

				$ids = isset( $_GET['abandoned_order_id'] ) ? $_GET['abandoned_order_id'] : false;

				if ( ! is_array( $ids ) ) {
					$ids = array( $ids );
				}
				$ids_list = implode( ',', $ids );

				wp_safe_redirect( admin_url( "/admin.php?page=xcart&action=cart_recovery&section=emailtemplates&mode=xorgcore_manual_email&abandoned_order_id=$ids_list" ) );
			}

			$mode = isset( $_GET['mode'] ) ? $_GET['mode'] : '';
			if ( 'listcart' === $xorgcore_action && 'unsubscribe' === $mode ) {
				$xorgcore_cart_id = $_GET['abandoned_order_id'];
				xorgcore_DB_Layer::xorgcore_unsubscribe_cart( $xorgcore_cart_id );
			}
		}
	}
}
