<?php



if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! class_exists( 'xorgcore_Orders_Listing' ) ) {

	
	class xorgcore_Orders_Listing {

		
		public function __construct() {
			add_action( 'manage_shop_order_posts_custom_column', array( &$this, 'xorgcore_add_recovered_status' ), 99, 1 );
		}

		
		public static function xorgcore_add_recovered_status( $column ) {
			global $post;

			if ( 'order_status' === $column ) {

				global $wpdb;
				$order_id = $post->ID;

				$get_cart = $wpdb->get_results( $wpdb->prepare( "SELECT id FROM `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` WHERE recovered_cart = %d", $order_id ) ); //phpcs:ignore

				if ( isset( $get_cart ) && is_array( $get_cart ) && count( $get_cart ) > 0 ) {
					$status = esc_html__( 'Recovered', 'xcart-tr' );
					echo "<br><span id='xorgcore_recovered_cart' class='xorgcore_recovered_cart' style='background-color: green; color: white; padding: 4px 9px 4px 9px; border-radius: 3px; margin-top: 8px; display:inline-block;'>$status</span>";
				}
			}
			if ( 'wc_actions' === $column ) {
				
				$coupon_code = get_post_meta( $post->ID, 'xorgcore_atc_coupon', true );
				if ( isset( $coupon_code ) && '' !== $coupon_code ) {
					$coupon_status = __( 'ATC Coupon Used', 'xcart-tr' );
					echo wp_kses_post( "<span id='xorgcore_atc_coupon' class='xorgcore_atc_coupon' style='font-weight: 600;font-style: italic;'>$coupon_status</span>" );
				}
			}
		}
	} 
} 
$xorgcore_orders_listing = new xorgcore_Orders_Listing();
