<?php


if ( ! defined( 'ABSPATH' ) ) exit;

if ( !class_exists('xorgcore_Tiny_Mce' ) ) {
    
    class xorgcore_Tiny_Mce{

        
        public static function xorgcore_add_tiny_mce_button_and_plugin() {
            
            
            if ( !current_user_can( 'edit_posts' ) && !current_user_can( 'edit_pages' ) ) {
                return;
            }
            if ( !isset( $_GET['page'] ) || $_GET['page'] != "xcart" ) {
                return;
            }
            if ( 'true' == get_user_option( 'rich_editing' ) ) {
                remove_filter( 'the_excerpt', 'wpautop' );

                add_filter( 'tiny_mce_before_init', array( 'xorgcore_Tiny_Mce', 'xorgcore_format_tiny_MCE' ) );
                add_filter( 'mce_buttons',          array( 'xorgcore_Tiny_Mce', 'xorgcore_filter_mce_button' ) );
                add_filter( 'mce_external_plugins', array( 'xorgcore_Tiny_Mce', 'xorgcore_filter_mce_plugin' ) );
            }
            if ( isset( $_GET['page'] ) && 'xcart' == $_GET['page'] ){
                if( session_id() === '' ){
                    //session has not started
                    if ( is_plugin_active( 'agilecrm/index.php' ) ) {
                        @session_start();
                    } else {
                        session_start();
                    }
                }
            }
        }

        
        public static function xorgcore_format_tiny_MCE( $in ) {
            add_editor_style();
            $in['force_root_block']             = false;
            $in['valid_children']               = '+body[style]';
            $in['remove_linebreaks']            = false;
            $in['gecko_spellcheck']             = false;
            $in['keep_styles']                  = true;
            $in['accessibility_focus']          = true;
            $in['tabfocus_elements']            = 'major-publishing-actions';
            $in['media_strict']                 = false;
            $in['paste_remove_styles']          = false;
            $in['paste_remove_spans']           = false;
            $in['paste_strip_class_attributes'] = 'none';
            $in['paste_text_use_dialog']        = true;
            $in['wpeditimage_disable_captions'] = true;
            $in['wpautop']                      = false;
            $in['apply_source_formatting']      = true;
            $in['cleanup']                      = true;
            $in['convert_newlines_to_brs']      = FALSE;
            $in['fullpage_default_xml_pi']      = false;
            $in['convert_urls']                 = false;
            
            $in['remove_redundant_brs']         = false;

            return $in;
        }

        
        public static function xorgcore_filter_mce_button( $buttons ) {
            
            array_push( $buttons, 'abandoncart_pro', '|' );
            array_push( $buttons, 'abandoncart_pro_css', '|' );
            return $buttons;
        }

        
        public static function xorgcore_filter_mce_plugin( $plugins ) {

            $suffix = defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ? '' : '.min';
            
            $plugins['abandoncart_pro']     = xorgcore_PLUGIN_URL . '/assets/js/admin/xcart' . $suffix . '.js';
            $plugins['abandoncart_pro_css'] = xorgcore_PLUGIN_URL . '/assets/js/admin/xcart_css' . $suffix . '.js';
            return $plugins;
        }
    }
}
