<?php


if ( ! defined( 'ABSPATH' ) ) {
	exit; 
}

if ( ! class_exists( 'xorgcore_Abandoned_Cart_Details' ) ) {

	
	class xorgcore_Abandoned_Cart_Details {

		
		public static function xorgcore_get_cart_detail_view( $xorgcore_cart_id = '', $xorgcore_email_address, $xorgcore_customer_details, $xorgcore_cart_total, $xorgcore_abandoned_date, $xorgcore_abandoned_status, $xorgcore_current_page ) {
			global $wpdb, $woocommerce;

			$xorgcore_selected_abandoned_cart = array();
			$xorgcore_show_customer_detail    = '';
			$xorgcore_cart_content_var        = '';
			$xorgcore_cart_user_id            = '';
			$user_email                   = '';
			$xorgcore_cart_email_sent         = '';
			$xorgcore_cart_email_clicked      = '';
			$xorgcore_cart_email_open         = '';
			$xorgcore_add_customer_details    = '';

			$wc_shipping_charges           = '';
			$shipping_charges_value        = '';
			$xorgcore_shipping_charges_text    = '';
			$wc_shipping_charges_text      = '';
			$wc_shipping_charges_formatted = '';

			if ( '' !== $xorgcore_email_address ) {
				$xorgcore_email_address_explode = explode( '<a', $xorgcore_email_address );
				$xorgcore_email_address         = trim( $xorgcore_email_address_explode[0] );
			}
			$xorgcore_show_customer_detail = '<br><a href="" id "xorgcore_customer_detail_modal" class ="xorgcore_customer_detail_modal">اطلاعات بیشتر</a>';

			$xorgcore_get_abandoned_cart_result = $wpdb->get_results( 
				$wpdb->prepare(
					'SELECT * FROM ' . xorgcore_ABANDONED_CART_HISTORY_TABLE . ' WHERE `id` = %d', 
					$xorgcore_cart_id
				)
			);

			$user_role = '';
			if ( isset( $xorgcore_get_abandoned_cart_result[0] ) ) {
				if ( 0 === $xorgcore_get_abandoned_cart_result[0]->user_id ) {
					$user_role = 'Guest';
				} elseif ( $xorgcore_get_abandoned_cart_result[0]->user_id >= 63000000 ) {
					$user_role = 'Guest';
				} else {
					$user_role = xorgcore_Common::xorgcore_get_user_role( $xorgcore_get_abandoned_cart_result[0]->user_id );
				}
			}

			$recovered_order = isset( $xorgcore_get_abandoned_cart_result[0]->recovered_cart ) && $xorgcore_get_abandoned_cart_result[0]->recovered_cart > 0 ? absint( $xorgcore_get_abandoned_cart_result[0]->recovered_cart ) : 0;
			if ( 'send_email' === $xorgcore_current_page ) {

				if ( '1' === $xorgcore_get_abandoned_cart_result[0]->unsubscribe_link ) {
					$ac_status             = __( 'Unsubscribed', 'xcart-tr' );
					$xorgcore_abandoned_status = "<span id ='xorgcore_unsubscribe_link_modal' class = 'unsubscribe_link'  >" . $ac_status . '</span>';
				} elseif ( '0' === $xorgcore_get_abandoned_cart_result[0]->cart_ignored && 0 === $xorgcore_get_abandoned_cart_result[0]->recovered_cart ) {
					$ac_status             = __( 'Abandoned', 'xcart-tr' );
					$xorgcore_abandoned_status = "<span id='xorgcore_status_modal_abandoned' class='xorgcore_status_modal_abandoned'  >" . $ac_status . '</span>';
				} elseif ( '1' === $xorgcore_get_abandoned_cart_result[0]->cart_ignored && 0 === $xorgcore_get_abandoned_cart_result[0]->recovered_cart ) {
					$ac_status             = __( 'Abandoned but new cart created after this', 'xcart-tr' );
					$xorgcore_abandoned_status = "<span id='xorgcore_status_modal_abandoned_new' class='xorgcore_status_modal_abandoned_new'  >" . $ac_status . '</span>';
				}

				$cart_update_time = $xorgcore_get_abandoned_cart_result[0]->abandoned_cart_time;

				if ( '' !== $cart_update_time && 0 !== $cart_update_time ) {
					$date_format         = date_i18n( get_option( 'date_format' ), $cart_update_time );
					$time_format         = date_i18n( get_option( 'time_format' ), $cart_update_time );
					$xorgcore_abandoned_date = $date_format . ' ' . $time_format;

				}
			} else {
				$ac_status = __( $xorgcore_abandoned_status, 'xcart-tr' ); 
				switch ( $xorgcore_abandoned_status ) {
					case 'Abandoned':
						$xorgcore_abandoned_status = "<span id='xorgcore_status_modal_abandoned_new' class='xorgcore_status_modal_abandoned_new'  >" . $ac_status . '</span>';
						break;
					case 'Recovered':
						$xorgcore_abandoned_status = "<span id='xorgcore_status_modal_abandoned' class='xorgcore_status_modal_abandoned'  >" . $ac_status . '</span>';
						break;
					case 'Unsubscribed':
						$xorgcore_abandoned_status = "<span id ='xorgcore_unsubscribe_link_modal' class = 'unsubscribe_link'  >" . $ac_status . '</span>';
						break;
					case 'Abandoned - Order Cancelled':
						$xorgcore_abandoned_status = "<span id ='xorgcore_status_cancelled_order' class = 'xorgcore_status_cancelled_order'  >" . $ac_status . '</span>';
						break;
					case 'Abandoned - Pending Payment':
						$xorgcore_abandoned_status = "<span id ='xorgcore_status_unpaid_order' class = 'xorgcore_status_unpaid_order'  >" . $ac_status . '</span>';
						break;
					case 'Abandoned - Order Received':
						$xorgcore_abandoned_status = "<span id ='xorgcore_status_received_order' class = 'xorgcore_status_received_order'  >" . $ac_status . '</span>';
						break;
					default:
						$xorgcore_abandoned_status = "<span id='xorgcore_status_modal_abandoned_new' class='xorgcore_status_modal_abandoned_new'  >" . $ac_status . '</span>';
						break;

				}
			}

			$xorgcore_get_abandoned_sent_result = $wpdb->get_results( 
				$wpdb->prepare(
					'SELECT wcet.`template_name`, wsht.`sent_time`, wsht.`id`, wsht.`sent_email_id` FROM ' . xorgcore_EMAIL_SENT_HISTORY_TABLE . ' as wsht LEFT JOIN ' . xorgcore_EMAIL_TEMPLATE_TABLE . ' AS wcet ON wsht.template_id = wcet.id WHERE `abandoned_order_id` = %d', 
					$xorgcore_cart_id
				)
			);

			$shipping_charges        = 0;
			$currency_symbol         = get_woocommerce_currency_symbol();
			$biiling_field_display   = 'block';
			$email_field_display     = 'block';
			$phone_field_display     = 'block';
			$shipping_field_display  = 'block';
			$user_ip_address         = '';
			$user_ip_address_display = 'none';
			if ( isset( $xorgcore_get_abandoned_cart_result[0]->ip_address ) && '' !== $xorgcore_get_abandoned_cart_result[0]->ip_address ) {
				$user_ip_address         = $xorgcore_get_abandoned_cart_result[0]->ip_address;
				$user_ip_address_display = 'block';
			}

			$user_billing_company    = '';
			$user_billing_address_1  = '';
			$user_billing_address_2  = '';
			$user_billing_city       = '';
			$user_billing_postcode   = '';
			$user_billing_state      = '';
			$user_billing_country    = '';
			$user_shipping_company   = '';
			$user_shipping_address_1 = '';
			$user_shipping_address_2 = '';
			$user_shipping_city      = '';
			$user_shipping_postcode  = '';
			$user_shipping_state     = '';
			$user_shipping_country   = '';
			$biiling_field_display   = 'none';
			$shipping_field_display  = 'none';

			if ( isset( $xorgcore_get_abandoned_cart_result[0] ) && 'GUEST' === $xorgcore_get_abandoned_cart_result[0]->user_type && '0' !== $xorgcore_get_abandoned_cart_result[0]->user_id ) {

				$results_guest = $wpdb->get_results( 
					$wpdb->prepare(
						'SELECT * FROM `' . xorgcore_GUEST_CART_HISTORY_TABLE . '` WHERE id = %d', 
						$xorgcore_get_abandoned_cart_result[0]->user_id
					)
				);

				$user_first_name        = ( isset( $results_guest[0]->billing_first_name ) && '' !== $results_guest[0]->billing_first_name ) ? $results_guest[0]->billing_first_name : '';
				$user_last_name         = ( isset( $results_guest[0]->billing_last_name ) && '' !== $results_guest[0]->billing_last_name ) ? $results_guest[0]->billing_last_name : '';
				$user_billing_postcode  = ( isset( $results_guest[0]->billing_zipcode ) && '' !== $results_guest[0]->billing_zipcode ) ? $results_guest[0]->billing_zipcode : '';
				$user_shipping_postcode = ( isset( $results_guest[0]->shipping_zipcode ) && '' !== $results_guest[0]->shipping_zipcode ) ? $results_guest[0]->shipping_zipcode : '';
				$shipping_charges       = ( isset( $results_guest[0]->shipping_charges ) && '' !== $results_guest[0]->shipping_charges ) ? $results_guest[0]->shipping_charges : '';
				$user_billing_phone     = ( isset( $results_guest[0]->phone ) && '' !== $results_guest[0]->phone ) ? $results_guest[0]->phone : '';

				if ( isset( $user_billing_phone ) && '' === $user_billing_phone ) {
					$phone_field_display = 'none';
				}

				$user_email = '';
				if ( isset( $results_guest[0]->email_id ) ) {
					$user_email = $results_guest[0]->email_id;
					if ( 'send_email' === $xorgcore_current_page ) {
						$xorgcore_email_address = $results_guest[0]->email_id;

						$customer_information = $user_first_name . ' ' . $user_last_name;

						if ( '' === $user_billing_phone ) {
							$xorgcore_customer_details = $customer_information . '<br>' . $user_role;
						} else {
							$xorgcore_customer_details = $customer_information . '<br>' . $user_billing_phone . '<br>' . $user_role;
						}
					}
				}
			} elseif ( isset( $xorgcore_get_abandoned_cart_result[0] ) && 'GUEST' === $xorgcore_get_abandoned_cart_result[0]->user_type && '0' === $xorgcore_get_abandoned_cart_result[0]->user_id ) {
				$user_email             = '';
				$user_first_name        = 'Visitor';
				$user_last_name         = '';
				$user_billing_postcode  = '';
				$user_shipping_postcode = '';
				$shipping_charges       = '';
				$user_billing_phone     = '';
				$user_billing_company   = '';
				$user_billing_address_1 = '';
				$user_billing_address_2 = '';
				$user_billing_city      = '';
				$user_billing_state     = '';
				$user_billing_country   = '';

				$user_shipping_first_name   = '';
				$user_shipping_last_name    = '';
				$user_shipping_company_temp = '';
				$user_shipping_company      = '';
				$user_shipping_address_1    = '';
				$user_shipping_address_2    = '';
				$user_shipping_city         = '';
				$user_shipping_state        = '';
				$user_shipping_country      = '';

				$biiling_field_display  = 'none';
				$email_field_display    = 'none';
				$phone_field_display    = 'none';
				$shipping_field_display = 'none';
			} else {

				$user_email = '';
				if ( isset( $xorgcore_get_abandoned_cart_result[0] ) ) {
					$user_email_biiling = get_user_meta( $xorgcore_get_abandoned_cart_result[0]->user_id, 'billing_email', true );
				}

				if ( isset( $user_email_biiling ) ) {
					if ( '' === $user_email_biiling ) {
						if ( isset( $xorgcore_get_abandoned_cart_result[0] ) ) {
							$current_user_data = get_userdata( $xorgcore_get_abandoned_cart_result[0]->user_id );
							$user_email        = $current_user_data->user_email;
						}
					} else {
						$user_email = $user_email_biiling;
					}
				}
				if ( 'send_email' === $xorgcore_current_page ) {

					$xorgcore_email_address = $user_email;

					$user_first_name_temp = '';
					if ( isset( $xorgcore_get_abandoned_cart_result[0] ) ) {
						$user_first_name_temp = get_user_meta( $xorgcore_get_abandoned_cart_result[0]->user_id, 'billing_first_name', true );
					}

					if ( isset( $user_first_name_temp ) && '' === $user_first_name_temp ) {
						$user_data       = get_userdata( $xorgcore_get_abandoned_cart_result[0]->user_id );
						$user_first_name = $user_data->first_name;
					} else {
						$user_first_name = $user_first_name_temp;
					}

					$user_last_name_temp = get_user_meta( $xorgcore_get_abandoned_cart_result[0]->user_id, 'billing_last_name', true );
					if ( isset( $user_last_name_temp ) && '' === $user_last_name_temp ) {
						$user_data      = get_userdata( $xorgcore_get_abandoned_cart_result[0]->user_id );
						$user_last_name = $user_data->last_name;
					} else {
						$user_last_name = $user_last_name_temp;
					}

					$user_phone_number = array();
					if ( isset( $xorgcore_get_abandoned_cart_result[0] ) ) {
						$user_phone_number = get_user_meta( $xorgcore_get_abandoned_cart_result[0]->user_id, 'billing_phone' );
					}
					if ( isset( $user_phone_number[0] ) ) {
						$phone = $user_phone_number[0];
					} else {
						$phone = '';
					}
					$customer_information = $user_first_name . ' ' . $user_last_name;

					if ( '' === $phone ) {
						$xorgcore_customer_details = $customer_information . '<br>' . $user_role;
					} else {
						$xorgcore_customer_details = $customer_information . '<br>' . $phone . '<br>' . $user_role;
					}
				}
				if ( isset( $xorgcore_get_abandoned_cart_result[0] ) ) {

					$user_billing_details = self::xorgcore_get_billing_details( $xorgcore_get_abandoned_cart_result[0]->user_id );

					$user_billing_company   = $user_billing_details['billing_company'];
					$user_billing_address_1 = $user_billing_details['billing_address_1'];
					$user_billing_address_2 = $user_billing_details['billing_address_2'];
					$user_billing_city      = $user_billing_details['billing_city'];
					$user_billing_postcode  = $user_billing_details['billing_postcode'];
					$user_billing_country   = $user_billing_details['billing_country'];
					$user_billing_state     = $user_billing_details['billing_state'];

					$user_billing_phone_temp = get_user_meta( $xorgcore_get_abandoned_cart_result[0]->user_id, 'billing_phone' );
					$user_billing_phone      = '';
					if ( isset( $user_billing_phone_temp[0] ) ) {
						$user_billing_phone = $user_billing_phone_temp[0];
					}
					$user_shipping_first_name   = get_user_meta( $xorgcore_get_abandoned_cart_result[0]->user_id, 'shipping_first_name' );
					$user_shipping_last_name    = get_user_meta( $xorgcore_get_abandoned_cart_result[0]->user_id, 'shipping_last_name' );
					$user_shipping_company_temp = get_user_meta( $xorgcore_get_abandoned_cart_result[0]->user_id, 'shipping_company' );
					$user_shipping_company      = '';
					if ( isset( $user_shipping_company_temp[0] ) ) {
						$user_shipping_company = $user_shipping_company_temp[0];
					}
					$user_shipping_address_1_temp = get_user_meta( $xorgcore_get_abandoned_cart_result[0]->user_id, 'shipping_address_1' );
					$user_shipping_address_1      = '';
					if ( isset( $user_shipping_address_1_temp[0] ) ) {
						$user_shipping_address_1 = $user_shipping_address_1_temp[0];
					}
					$user_shipping_address_2_temp = get_user_meta( $xorgcore_get_abandoned_cart_result[0]->user_id, 'shipping_address_2' );
					$user_shipping_address_2      = '';
					if ( isset( $user_shipping_address_2_temp[0] ) ) {
						$user_shipping_address_2 = $user_shipping_address_2_temp[0];
					}
					$user_shipping_city_temp = get_user_meta( $xorgcore_get_abandoned_cart_result[0]->user_id, 'shipping_city' );
					$user_shipping_city      = '';
					if ( isset( $user_shipping_city_temp[0] ) ) {
						$user_shipping_city = $user_shipping_city_temp[0];
					}
					$user_shipping_postcode_temp = get_user_meta( $xorgcore_get_abandoned_cart_result[0]->user_id, 'shipping_postcode' );
					$user_shipping_postcode      = '';
					if ( isset( $user_shipping_postcode_temp[0] ) ) {
						$user_shipping_postcode = $user_shipping_postcode_temp[0];
					}
					$user_shipping_country_temp = get_user_meta( $xorgcore_get_abandoned_cart_result[0]->user_id, 'shipping_country' );
					$user_shipping_country      = '';
					if ( isset( $user_shipping_country_temp[0] ) ) {
						$user_shipping_country = $user_shipping_country_temp[0];
						if ( isset( $woocommerce->countries->countries[ $user_shipping_country ] ) ) {
							$user_shipping_country = $woocommerce->countries->countries[ $user_shipping_country ];
						} else {
							$user_shipping_country = '';
						}
					}
					$user_shipping_state_temp = get_user_meta( $xorgcore_get_abandoned_cart_result[0]->user_id, 'shipping_state' );
					$user_shipping_state      = '';
					if ( isset( $user_shipping_state_temp[0] ) ) {
						$user_shipping_state = $user_shipping_state_temp[0];
						if ( isset( $woocommerce->countries->states[ $user_shipping_country_temp[0] ][ $user_shipping_state ] ) ) {
							$user_shipping_state = $woocommerce->countries->states[ $user_shipping_country_temp[0] ][ $user_shipping_state ];
						}
					}
					
					$cart_info           = json_decode( stripslashes( $xorgcore_get_abandoned_cart_result[0]->abandoned_cart_info ) );
					$wc_shipping_charges = isset( $cart_info->shipping_charges ) ? $cart_info->shipping_charges : 0;
				}
			}

			if ( '' === $user_billing_company && '' === $user_billing_address_1 && '' === $user_billing_address_2 &&
				'' === $user_billing_city && '' === $user_billing_postcode && '' === $user_billing_state && '' === $user_billing_country ) {

				$biiling_field_display = 'none';
			}

			$xorgcore_billing_address_text   = __( 'آدرس', 'xcart-tr' );
			$xorgcore_create_billing_address = '<br>' . $user_billing_company . '</br>' .
												$user_billing_address_1 . '</br>' .
												$user_billing_address_2 . '</br>' .
												$user_billing_city . '</br>' .
												$user_billing_postcode;

			$xorgcore_shipping_address_text = __( 'آدرس ارسال سفارش:', 'xcart-tr' );

			if ( '' === $user_shipping_company &&
				'' === $user_shipping_address_1 &&
				'' === $user_shipping_address_2 &&
				'' === $user_shipping_city &&
				'' === $user_shipping_postcode &&
				'' === $user_shipping_state &&
				'' === $user_shipping_country ) {

				$xorgcore_create_shipping_address = '';
			} else {
				$xorgcore_create_shipping_address = '<br>' . $user_shipping_company . '</br>' .
				$user_shipping_address_1 . '</br>' .
				$user_shipping_address_2 . '</br>' .
				$user_shipping_city . '</br>' .
				$user_shipping_postcode;
			}

			$xorgcore_ip_address_text = __( 'IP', 'xcart-tr' );
			if ( '' !== $shipping_charges ) {
				$xorgcore_shipping_charges_text = __( 'هزینه ارسال', 'xcart-tr' );
				$shipping_charges_value     = wc_price( $shipping_charges );
			}
			if ( '' !== $wc_shipping_charges ) {
				$wc_shipping_charges_text      = __( 'هزینه ارسال', 'xcart-tr' );
				$wc_shipping_charges_formatted = wc_price( $wc_shipping_charges );
			}

			$xorgcore_add_customer_details = " <div class= 'xorgcore_modal_customer_all_details' >
                <span style = 'display: $user_ip_address_display' >
                    <strong>
                        $xorgcore_ip_address_text
                    </strong>
                     $user_ip_address
                     <br>
                     <strong>  $xorgcore_shipping_charges_text </strong>
                   $shipping_charges_value
                </span>
                <span style = 'display:$biiling_field_display'>
                <strong>  $xorgcore_billing_address_text </strong>
                   $xorgcore_create_billing_address
                </span>
                <span style = 'display:$shipping_field_display'>
                <strong>  $xorgcore_shipping_address_text </strong>
                   $xorgcore_create_shipping_address <br/>
                   <strong>  $wc_shipping_charges_text </strong>
                   $wc_shipping_charges_formatted
                </span>

            </div>";

			if ( isset( $xorgcore_get_abandoned_cart_result[0] ) && ! empty( $xorgcore_get_abandoned_cart_result ) ) {

				$xorgcore_cart_user_id = $xorgcore_get_abandoned_cart_result[0]->user_id;
				$xorgcore_cart_info    = json_decode( stripslashes( $xorgcore_get_abandoned_cart_result[0]->abandoned_cart_info ) );

				if ( null === $xorgcore_cart_info ) {
					$xorgcore_cart_info = json_decode( $xorgcore_get_abandoned_cart_result[0]->abandoned_cart_info );
				}

				$xorgcore_cart_details = $xorgcore_cart_info->cart;

				
				$currency = isset( $xorgcore_cart_info->currency ) ? $xorgcore_cart_info->currency : '';

				$line_subtotal_tax = '';

				$display_cart_details = self::xorgcore_get_cart_details( $xorgcore_cart_details, $xorgcore_cart_id, $xorgcore_current_page, $currency, $xorgcore_cart_total );

				if ( 'send_email' === $xorgcore_current_page ) {
					$xorgcore_quantity_total = ( $display_cart_details ['qty_total'] > 0 ) ? $display_cart_details ['qty_total'] : 0;
					$xorgcore_cart_total     = ( $display_cart_details ['cart_total'] > 0 ) ? $display_cart_details ['cart_total'] : 0;

					$line_subtotal_tax_total = ( $display_cart_details ['line_subtotal_tax_total'] > 0 ) ? $display_cart_details ['line_subtotal_tax_total'] : 0;
				}

				foreach ( $xorgcore_cart_details as $k => $v ) {
					$product_id         = $display_cart_details[ $k ]['product_id'];
					$product_page_url   = get_permalink( $product_id );
					$product_name       = $display_cart_details[ $k ]['product_name'];
					$item_total_display = $display_cart_details[ $k ]['item_total_formatted'];
					$quantity_total     = $display_cart_details[ $k ]['qty'];
					$line_tax_total     = $display_cart_details[ $k ]['line_tax'];

					$qty_item_text = 'محصول';
					if ( $quantity_total > 1 ) {
						$qty_item_text = 'محصول';
					}

					$xorgcore_cart_content_var .= '<tr>';
					$xorgcore_cart_content_var .= '<td> <a href="' . $product_page_url . '"> ' . $product_name . '</a></td>';
					$xorgcore_cart_content_var .= '<td> ' . $item_total_display . '</td>';
					$xorgcore_cart_content_var .= '<td> ' . $quantity_total . ' ' . $qty_item_text . '</td>';
					$xorgcore_cart_content_var .= '</tr>';

				}

				$xorgcore_include_tax         = get_option( 'woocommerce_prices_include_tax' );
				$xorgcore_include_tax_setting = get_option( 'woocommerce_calc_taxes' );
			}

			if ( 'send_email' === $xorgcore_current_page ) {
				$xorgcore_cart_total = apply_filters( 'acfac_change_currency', xorgcore_Common::xorgcore_get_price( $xorgcore_cart_total, $currency ), $xorgcore_cart_id, $xorgcore_cart_total, 'xorgcore_ajax' );

				if ( 1 === $xorgcore_quantity_total ) {
					$item_disp = __( 'item', 'xcart-tr' );
				} else {
					$item_disp = __( 'items', 'xcart-tr' );
				}

				$show_taxes = apply_filters( 'xorgcore_show_taxes', true );

				if ( $show_taxes && isset( $xorgcore_include_tax ) && 'no' === $xorgcore_include_tax &&
					isset( $xorgcore_include_tax_setting ) && 'yes' === $xorgcore_include_tax_setting ) {

						$line_subtotal_tax_total = apply_filters( 'acfac_change_currency', xorgcore_Common::xorgcore_get_price( $line_subtotal_tax_total, $currency ), $xorgcore_cart_id, $line_subtotal_tax_total, 'xorgcore_ajax' );

						$xorgcore_cart_total = $xorgcore_cart_total . '<br>Tax: ' . $line_subtotal_tax_total;
				} elseif ( isset( $xorgcore_include_tax ) && 'yes' === $xorgcore_include_tax &&
					isset( $xorgcore_include_tax_setting ) && 'yes' === $xorgcore_include_tax_setting ) {

						$line_subtotal_tax_total = apply_filters( 'acfac_change_currency', xorgcore_Common::xorgcore_get_price( $line_subtotal_tax_total, $currency ), $xorgcore_cart_id, $line_subtotal_tax_total, 'xorgcore_ajax' );
					if ( $show_taxes ) {

						$xorgcore_cart_total = $xorgcore_cart_total . ' (includes Tax: ' . $line_subtotal_tax_total . ')';
					} else {
						$xorgcore_cart_total = $xorgcore_cart_total;
					}
				}
				$xorgcore_cart_total = $xorgcore_cart_total . '<br>' . $xorgcore_quantity_total . ' ' . $item_disp;
			}

			if ( ! empty( $xorgcore_get_abandoned_sent_result ) && count( $xorgcore_get_abandoned_sent_result ) > 0 ) {
				foreach ( $xorgcore_get_abandoned_sent_result as $xorgcore_get_abandoned_sent_key => $xorgcore_get_abandoned_sent_value ) {

					$xorgcore_email_sent_time = strtotime( $xorgcore_get_abandoned_sent_value->sent_time );
					$sent_date_format     = date_i18n( get_option( 'date_format' ), $xorgcore_email_sent_time );
					$sent_time_format     = date_i18n( get_option( 'time_format' ), $xorgcore_email_sent_time );
					$xorgcore_email_sent_time = $sent_date_format . ' ' . $sent_time_format;
					$email_address        = $xorgcore_get_abandoned_sent_value->sent_email_id;

					$xorgcore_cart_email_sent .= '<tr>';
					$xorgcore_cart_email_sent .= '<td>Email template <strong>' . $xorgcore_get_abandoned_sent_value->template_name . '</strong> was sent to <strong>' . $email_address . ' </strong> on ' . $xorgcore_email_sent_time . ' </td>';
					$xorgcore_cart_email_sent .= '</tr>';

					$xorgcore_get_abandoned_cart_clicked_result = $wpdb->get_results( 
						$wpdb->prepare(
							'SELECT `time_clicked` FROM ' . xorgcore_EMAIL_CLICKED_TABLE . ' WHERE `email_sent_id` = %d ORDER BY `id` DESC LIMIT 1', 
							$xorgcore_get_abandoned_sent_value->id
						)
					);

					if ( ! empty( $xorgcore_get_abandoned_cart_clicked_result ) && count( $xorgcore_get_abandoned_cart_clicked_result ) > 0 ) {
						$xorgcore_email_time_clicked = strtotime( $xorgcore_get_abandoned_cart_clicked_result[0]->time_clicked );
						$clicked_date_format     = date_i18n( get_option( 'date_format' ), $xorgcore_email_time_clicked );
						$clicked_time_format     = date_i18n( get_option( 'time_format' ), $xorgcore_email_time_clicked );
						$xorgcore_email_time_clicked = $clicked_date_format . ' ' . $clicked_time_format;

						$xorgcore_cart_email_clicked .= '<tr>';
						$xorgcore_cart_email_clicked .= '<td>Email template <strong>' . $xorgcore_get_abandoned_sent_value->template_name . '</strong> was <strong> clicked </strong> on ' . $xorgcore_email_time_clicked . ' </td>';
						$xorgcore_cart_email_clicked .= '</tr>';
					}

					$xorgcore_results_opens = $wpdb->get_results( //phpcs:ignore
						$wpdb->prepare(
							'SELECT time_opened FROM ' . xorgcore_EMAIL_OPENED_TABLE . ' WHERE email_sent_id= %d ORDER BY `id` DESC LIMIT 1', 
							$xorgcore_get_abandoned_sent_value->id
						)
					);

					if ( ! empty( $xorgcore_results_opens ) && count( $xorgcore_results_opens ) > 0 ) {
						$xorgcore_opened_tmstmp    = strtotime( $xorgcore_results_opens[0]->time_opened );
						$opened_date_format    = date_i18n( get_option( 'date_format' ), $xorgcore_opened_tmstmp );
						$opened_time_format    = date_i18n( get_option( 'time_format' ), $xorgcore_opened_tmstmp );
						$xorgcore_email_opened     = $opened_date_format . ' ' . $opened_time_format;
						$xorgcore_cart_email_open .= '<tr>';
						$xorgcore_cart_email_open .= '<td>Email template <strong>' . $xorgcore_get_abandoned_sent_value->template_name . '</strong> was <strong> opened </strong> on ' . $xorgcore_email_opened . ' </td>';
						$xorgcore_cart_email_open .= '</tr>';
					}
				}
			}

			?>

		<div class="xorgcore-modal__header">
			
			<h1><?php printf( esc_html__( 'Cart #%s', 'xcart-tr' ), esc_html( $xorgcore_cart_id ) ); ?></h1>
			<?php
			echo wp_kses_post( stripslashes( $xorgcore_abandoned_status ) );
			if ( $recovered_order > 0 ) {
				$order_post      = get_post( $recovered_order );
				$recovered_stamp = strtotime( $order_post->post_date );

				$order_date_format = date_i18n( get_option( 'date_format' ), $recovered_stamp );
				$order_time_format = date_i18n( get_option( 'time_format' ), $recovered_stamp );
				$recovered_date    = "$order_date_format $order_time_format";

				$order_url = admin_url( "post.php?post=$recovered_order&action=edit" );

				echo wp_kses_post(
					sprintf(
						
						'<h1>' . __( 'Order', 'xcart-tr' ) . " <a href='%s' target='_blank'>#%s</a><h1><h5>" . __( 'Recovered on %s', 'xcart-tr' ) . '</h5>',
						esc_url( $order_url ),
						esc_attr( $recovered_order ),
						esc_attr( $recovered_date )
					)
				);
			}
			?>
		</div>

		<div class="xorgcore-modal__body">
			<div class="xorgcore-modal__body-inner">

				<table cellspacing="0" cellpadding="6" border="1" class="xorgcore-cart-table">
					<thead>
					<tr>
						<th><?php esc_html_e( 'شماره تماس', 'xcart-tr' ); ?></th>
						<th><?php esc_html_e( 'اطلاعات', 'xcart-tr' ); ?></th>
						<th><?php esc_html_e( 'مجموع سفارش', 'xcart-tr' ); ?></th>
						<th><?php esc_html_e( 'زمان رها شدن', 'xcart-tr' ); ?></th>
					</tr>
					</thead>
					<tbody>
						<tr>
							<td> <?php echo esc_html( $xorgcore_email_address ); ?> </td>
							<td> <?php echo wp_kses_post( $xorgcore_customer_details . $xorgcore_show_customer_detail . $xorgcore_add_customer_details ); ?> </td>
							<td> <?php echo wp_kses_post( stripslashes( $xorgcore_cart_total ) ); ?> </td>
							<td> <?php echo wp_kses_post( $xorgcore_abandoned_date ); ?> </td>
						</tr>
					</tbody>
				</table>
				<table cellspacing="0" cellpadding="0" class="xorgcore-modal-cart-content">
					<thead>
					<tr>
						<th><?php esc_html_e( 'نام محصول', 'xcart-tr' ); ?></th>
						<th><?php esc_html_e( 'قیمت', 'xcart-tr' ); ?></th>
						<th><?php esc_html_e( 'تعداد', 'xcart-tr' ); ?></th>
					</tr>
					</thead>
					<tbody>
						<?php echo wp_kses_post( $xorgcore_cart_content_var ); ?>
					</tbody>
				</table>
				<?php if ( ! empty( $xorgcore_get_abandoned_sent_result ) && count( $xorgcore_get_abandoned_sent_result ) > 0 ) { ?>
				<table cellspacing="0" cellpadding="0" class="xorgcore-modal-email-content">
					<tbody>
						<?php echo wp_kses_post( $xorgcore_cart_email_sent ); ?>
						<?php echo wp_kses_post( $xorgcore_cart_email_open ); ?>
						<?php echo wp_kses_post( $xorgcore_cart_email_clicked ); ?>
					</tbody>
				</table>
				<?php } ?>
			</div>
		</div>

		<div class="xorgcore-modal__footer">
			<?php

		


			$xorgcore_footer_close_text = __( 'بستن', 'xcart-tr' );
			$value_close            = '<a class=" button xorgcore-icon-close-footer xorgcore-js-close-modal" >' . $xorgcore_footer_close_text . '</a>';
			echo wp_kses_post( $value_close );
			?>
		</div>
			<?php
		}

		
		public static function xorgcore_get_billing_details( $user_id ) {

			$billing_details = array();

			$user_billing_company_temp = get_user_meta( $user_id, 'billing_company' );
			$user_billing_company      = '';
			if ( isset( $user_billing_company_temp[0] ) ) {
				$user_billing_company = $user_billing_company_temp[0];
			}
			$billing_details['billing_company'] = $user_billing_company;

			$user_billing_address_1_temp = get_user_meta( $user_id, 'billing_address_1' );
			$user_billing_address_1      = '';
			if ( isset( $user_billing_address_1_temp[0] ) ) {
				$user_billing_address_1 = $user_billing_address_1_temp[0];
			}
			$billing_details['billing_address_1'] = $user_billing_address_1;

			$user_billing_address_2_temp = get_user_meta( $user_id, 'billing_address_2' );
			$user_billing_address_2      = '';
			if ( isset( $user_billing_address_2_temp[0] ) ) {
				$user_billing_address_2 = $user_billing_address_2_temp[0];
			}
			$billing_details['billing_address_2'] = $user_billing_address_2;

			$user_billing_city_temp = get_user_meta( $user_id, 'billing_city' );
			$user_billing_city      = '';
			if ( isset( $user_billing_city_temp[0] ) ) {
				$user_billing_city = $user_billing_city_temp[0];
			}
			$billing_details['billing_city'] = $user_billing_city;

			$user_billing_postcode_temp = get_user_meta( $user_id, 'billing_postcode' );
			$user_billing_postcode      = '';
			if ( isset( $user_billing_postcode_temp[0] ) ) {
				$user_billing_postcode = $user_billing_postcode_temp[0];
			}
			$billing_details['billing_postcode'] = $user_billing_postcode;

			$user_billing_country_temp = get_user_meta( $user_id, 'billing_country' );
			$user_billing_country      = '';
			if ( isset( $user_billing_country_temp[0] ) ) {
				$user_billing_country = $user_billing_country_temp[0];
				if ( isset( WC()->countries->countries[ $user_billing_country ] ) ) {
					$user_billing_country = WC()->countries->countries[ $user_billing_country ];
				} else {
					$user_billing_country = '';
				}
			}
			$billing_details['billing_country'] = $user_billing_country;

			$user_billing_state_temp = get_user_meta( $user_id, 'billing_state' );
			$user_billing_state      = '';
			if ( isset( $user_billing_state_temp[0] ) ) {
				$user_billing_state = $user_billing_state_temp[0];
				if ( isset( WC()->countries->states[ $user_billing_country_temp[0] ][ $user_billing_state ] ) ) {
					$user_billing_state = WC()->countries->states[ $user_billing_country_temp[0] ][ $user_billing_state ];
				} else {
					$user_billing_state = '';
				}
			}
			$billing_details['billing_state'] = $user_billing_state;

			return $billing_details;
		}

		
		public static function xorgcore_get_cart_details( $xorgcore_cart_details, $xorgcore_cart_id = '', $xorgcore_current_page = '', $currency = '', $xorgcore_cart_total = 0 ) {

			global $woocommerce;

			$cart_total                  = 0;
			$item_subtotal               = 0;
			$item_total                  = 0;
			$line_subtotal_tax_display   = 0;
			$after_item_subtotal         = 0;
			$after_item_subtotal_display = 0;
			$line_subtotal_tax_total     = 0;

			$line_subtotal_tax   = 0;
			$xorgcore_quantity_total = 0;

			$xorgcore_include_tax         = get_option( 'woocommerce_prices_include_tax' );
			$xorgcore_include_tax_setting = get_option( 'woocommerce_calc_taxes' );

			$item_details = array();

			foreach ( $xorgcore_cart_details as $k => $v ) {

				$product_id = $v->product_id;
				$prod_name  = get_post( $product_id );
				if ( count( get_object_vars( $prod_name ) ) > 0 && 'product' === $prod_name->post_type ) {

					$quantity_total      = $v->quantity;
					$xorgcore_quantity_total = $xorgcore_quantity_total + $v->quantity;
					$item_name           = $prod_name->post_title;
					$product_name        = apply_filters( 'xorgcore_product_name', $item_name, $v->product_id );
					$xorgcore_product        = wc_get_product( $product_id );
					if ( version_compare( $woocommerce->version, '3.0.0', '>=' ) ) {
						$xorgcore_product_type = $xorgcore_product->get_type();
					} else {
						$xorgcore_product_type = $xorgcore_product->product_type;
					}
					$xorgcore_product_sku = apply_filters( 'xorgcore_product_sku', $xorgcore_product->get_sku(), $v->product_id );
					if ( false !== $xorgcore_product_sku && '' !== $xorgcore_product_sku ) {
						if ( 'simple' === $xorgcore_product_type && '' !== $xorgcore_product->get_sku() ) {
							$xorgcore_sku = '<br> SKU: ' . $xorgcore_product->get_sku();
						} else {
							$xorgcore_sku = '';
						}
						$product_name = $product_name . $xorgcore_sku;
					} else {
						$product_name = $product_name;
					}
					$product_name = apply_filters( 'xorgcore_after_product_name', $product_name, $v->product_id );
					if ( isset( $v->variation_id ) && '' !== $v->variation_id ) {
						$variation_id = $v->variation_id;
						$variation    = wc_get_product( $variation_id );

						if ( false !== $variation ) {
							$name        = $variation->get_formatted_name();
							$explode_all = explode( '&ndash;', $name );

							if ( version_compare( $woocommerce->version, '3.0.0', '>=' ) ) {
								if ( false !== $xorgcore_product_sku && '' !== $xorgcore_product_sku ) {
									$xorgcore_sku = '';
									if ( $variation->get_sku() ) {
										$xorgcore_sku = 'SKU: ' . $variation->get_sku();
									}
									$xorgcore_get_formatted_variation = wc_get_formatted_variation( $variation, true );

									$add_product_name = $product_name . ' - <br>' . $xorgcore_sku . ' ' . $xorgcore_get_formatted_variation;
								} else {
									$xorgcore_get_formatted_variation = wc_get_formatted_variation( $variation, true );

									$add_product_name = $product_name . '<br>' . $xorgcore_get_formatted_variation;
								}

								$pro_name_variation = (array) $add_product_name;

							} else {
								$pro_name_variation = array_slice( $explode_all, 1, -1 );
							}
							$product_name_with_variable = '';
							$explode_many_varaition     = array();
							foreach ( $pro_name_variation as $pro_name_variation_key => $pro_name_variation_value ) {
								$explode_many_varaition = explode( ',', $pro_name_variation_value );
								if ( ! empty( $explode_many_varaition ) ) {
									foreach ( $explode_many_varaition as $explode_many_varaition_key => $explode_many_varaition_value ) {
										$product_name_with_variable = $product_name_with_variable . html_entity_decode( $explode_many_varaition_value ) . '<br>';
									}
								} else {
									$product_name_with_variable = $product_name_with_variable . html_entity_decode( $explode_many_varaition_value ) . '<br>';
								}
							}
							$product_name = apply_filters( 'xorgcore_after_variable_product_name', $product_name_with_variable, $v->product_id );
						}
					}

					
					if ( isset( $xorgcore_include_tax ) && 'no' === $xorgcore_include_tax &&
						isset( $xorgcore_include_tax_setting ) && 'yes' === $xorgcore_include_tax_setting ) {

							$item_subtotal       = $item_subtotal + $v->line_total;  
							$line_subtotal_tax  += $v->line_tax; 
							$after_item_subtotal = $item_subtotal;
							
							$line_subtotal_tax_total += $line_subtotal_tax;

					} elseif ( isset( $xorgcore_include_tax ) && 'yes' === $xorgcore_include_tax &&
							isset( $xorgcore_include_tax_setting ) && 'yes' === $xorgcore_include_tax_setting ) {
							
						if ( is_numeric( $v->line_tax ) && $v->line_tax > 0 ) {
							$line_subtotal_tax_display += $v->line_tax;

							
							$after_item_subtotal = $item_subtotal + $v->line_total + $v->line_tax;

							
							$item_subtotal = $item_subtotal + $v->line_subtotal + $v->line_subtotal_tax;

							
							$line_subtotal_tax_total += $line_subtotal_tax_display;
						} else {
							$item_subtotal              = $item_subtotal + $v->line_total;
							$line_subtotal_tax_display += $v->line_tax;
						}
					} else {

						$item_subtotal       = $item_subtotal + $v->line_total;
						$after_item_subtotal = $v->line_total;
					}

							
							$item_total                  = $item_subtotal;
							$item_price                  = $item_subtotal / $quantity_total;
							$after_item_subtotal_display = ( $item_subtotal - $after_item_subtotal ) + $after_item_subtotal_display;

							$item_total_display = apply_filters( 'acfac_change_currency', xorgcore_Common::xorgcore_get_price( $item_total, $currency ), $xorgcore_cart_id, $item_total, 'xorgcore_ajax' );

							$item_price = apply_filters( 'acfac_change_currency', xorgcore_Common::xorgcore_get_price( $item_price, $currency ), $xorgcore_cart_id, $item_price, 'xorgcore_ajax' );

					if ( isset( $xorgcore_include_tax ) && 'no' === $xorgcore_include_tax &&
								isset( $xorgcore_include_tax_setting ) && 'yes' === $xorgcore_include_tax_setting ) {

							$line_subtotal_tax_display_formatted = apply_filters( 'acfac_change_currency', xorgcore_Common::xorgcore_get_price( $line_subtotal_tax, $currency ), $xorgcore_cart_id, $line_subtotal_tax, 'xorgcore_ajax' );
							$item_total_display                  = $item_total_display . '<br>' . __( 'Tax: ', 'xcart-tr' ) . $line_subtotal_tax_display_formatted;
					} elseif ( isset( $xorgcore_include_tax ) && 'yes' === $xorgcore_include_tax &&
									isset( $xorgcore_include_tax_setting ) && 'yes' === $xorgcore_include_tax_setting ) {

							$line_subtotal_tax_display_formatted = apply_filters( 'acfac_change_currency', xorgcore_Common::xorgcore_get_price( $line_subtotal_tax_display, $currency ), $xorgcore_cart_id, $line_subtotal_tax_display, 'xorgcore_ajax' );

							$item_total_display = $item_total_display . ' (' . __( 'includes Tax: ', 'xcart-tr' ) . $line_subtotal_tax_display_formatted . ')';
					}

					if ( 'send_email' === $xorgcore_current_page ) {
						$xorgcore_cart_total = $after_item_subtotal + $xorgcore_cart_total;
					}
					$product = wc_get_product( $product_id );
					
					if ( isset( $product->bundle_data ) && is_array( $product->bundle_data ) && count( $product->bundle_data ) > 0 ) {
						foreach ( $product->bundle_data as $b_key => $b_value ) {
							$bundle_child[] = $b_key;
						}
					}
					
					if ( isset( $bundle_child ) && count( $bundle_child ) > 0 ) {
						if ( in_array( $product_id, $bundle_child, true ) ) {
							$item_subtotal      = '';
							$item_total_display = '';
							$quantity_total     = '';
						}
					}
				} else {
					$product_name       = __( 'Product has been deleted', 'xcart-tr' );
					$item_total_display = '';
					$quantity_total     = '';
					$qty_item_text      = '';
				}

				$item_details[ $k ]['product_id']           = $product_id;
				$item_details[ $k ]['product_name']         = $product_name;
				$item_details[ $k ]['item_total_formatted'] = $item_total_display;
				$item_details[ $k ]['item_total']           = $item_total;
				$item_details[ $k ]['qty']                  = $quantity_total;
				$item_details[ $k ]['line_tax']             = $line_subtotal_tax_total;

				
				$item_subtotal = 0;
				$item_total    = 0;
			}

			$item_details['qty_total']               = $xorgcore_quantity_total;
			$item_details['cart_total']              = $xorgcore_cart_total;
			$item_details['line_subtotal_tax_total'] = $line_subtotal_tax_total;

			return $item_details;
		}
	}
}
