<?php

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;

if ( !class_exists('xorgcore_Localization' ) ) {
    
    class xorgcore_Localization{
        
        public static function xorgcore_register_template_string_for_wpml() {
            if ( function_exists('icl_register_string') ) {
                global $wpdb;
                $context = 'xorgcore';
                
                $result = $wpdb->get_results("SELECT * FROM ".xorgcore_EMAIL_TEMPLATE_TABLE."");
                foreach ( $result as $each_template ) {
                    $name_msg = 'xorgcore_template_' . $each_template->id . '_message';
                    $value_msg = $each_template->body;
                    icl_register_string($context, $name_msg, $value_msg); //for registering message

                    $name_sub = 'xorgcore_template_' . $each_template->id . '_subject';
                    $value_sub = $each_template->subject;
                    icl_register_string($context, $name_sub, $value_sub); //for registering subject

                    $template_name = 'xorgcore_template_' . $each_template->id . '_template_name';
                    $getvalue_template_name = $each_template->template_name;
                    icl_register_string($context, $template_name, $getvalue_template_name);

                    $wc_email_header = 'xorgcore_template_' . $each_template->id . '_wc_email_header';
                    $getvalue_wc_email_header = $each_template->wc_email_header;
                    icl_register_string($context, $wc_email_header, $getvalue_wc_email_header);
                }

                // SMS & FB
                $short_messages = $wpdb->get_results( 'SELECT id, subject, body, type FROM ' . xorgcore_NOTIFICATIONS );
                if( is_array( $short_messages ) && count( $short_messages ) > 0 ) {
                    foreach( $short_messages as $message_data ) {
                        $subject      = $message_data->subject;
                        $body         = $message_data->body;
                        $subject_name = 'xorgcore_' . $message_data->type . '_' . $message_data->id . '_subject';
                        $body_name    = 'xorgcore_' . $message_data->type . '_' . $message_data->id . '_body';

                        icl_register_string( $context, $subject_name, $subject );
                        icl_register_string( $context, $body_name, $body );
                    }
                }
            }
        }
    }
}