<?php


if ( !defined( 'ABSPATH' ) ) {
    exit;
}    

class xorgcore_Dashboard_Report {

    
    function get_begin_of_month( $selected_data_range, $user_start_date ) {

        $begin_date   = '';
        switch ( $selected_data_range ){
            case 'this_month':
                $begin_date = mktime(00, 01, 01, date("n"), 1);
                break;
        
            case 'last_month':
                $begin_date = mktime(00, 01, 01, date("n") - 1, 1);
                break;
                
            case 'this_quarter':
                
                $current_month = date('m');
                $current_year = date('Y');
                
                if($current_month>=1 && $current_month<=3) {
                    $begin_date = strtotime('1-January-'.$current_year. '00:01:01' );  
                }
                else  if($current_month>=4 && $current_month<=6) {
                    $begin_date = strtotime('1-April-'.$current_year. '00:01:01' );  
                }
                else  if($current_month>=7 && $current_month<=9) {
                    $begin_date = strtotime('1-July-'.$current_year. '00:01:01' );  
                }
                else  if($current_month>=10 && $current_month<=12) {
                    $begin_date = strtotime('1-October-'.$current_year. '00:01:01' );  
                }
                
                break;
                
            case 'last_quarter':
                
                $current_month = date('m');
                $current_year = date('Y');
                
                if( $current_month >= 1 && $current_month <= 3 ) {
                    $begin_date = strtotime( '1-October-'.($current_year-1). '00:01:01' );  
                }
                else if( $current_month >= 4 && $current_month <= 6 ) {
                    $begin_date = strtotime( '1-January-'.$current_year . '00:01:01' );  
                }
                else if( $current_month >= 7 && $current_month <= 9 ) {
                    $begin_date = strtotime( '1-April-'.$current_year. '00:01:01' );  
                }
                else if( $current_month >= 10 && $current_month <= 12 ) {
                    $begin_date = strtotime( '1-July-'.$current_year. '00:01:01' );  
                }
                break;

            case 'this_year':
                $begin_date =  mktime( 00, 01, 01, 1, 1, date('Y') );;
                break;
                
            case 'last_year':
                $begin_date = mktime( 00, 01, 01, 1, 1, date('Y')-1 );
                break;
            
            case 'other':
                $explode_start_date = explode ( "-", $user_start_date );
                $month              = $explode_start_date[1];
                $date               = $explode_start_date[2];
                $year               = $explode_start_date[0];
                $begin_date         = mktime( 00, 01, 01, $month, $date, $year );
                break;

            default:
                $begin_date = time();
        }
        return $begin_date;
    }
    
    function get_end_of_month ( $selected_data_range, $user_end_date ){
    
        $end_date   = '';
        switch ( $selected_data_range ){
            case 'this_month':
                $end_date = mktime( 23, 59, 59, date("n"), date("t") );
                break;
    
            case 'last_month':
                $end_date = mktime( 23, 59, 59, date("n") - 1, date("t") - 1 );
                break;
    
            case 'this_quarter':
                $current_month = date('m');
                $current_year = date('Y');
                
                if( $current_month >= 1 && $current_month <= 3) {
                    $end_date = strtotime( '31-March-'.$current_year.'23:59:59' );  
                }
                else if( $current_month >= 4 && $current_month <=6 ) {
                    $end_date = strtotime( '30-July-'.$current_year.'23:59:59' );  
                }
                else if( $current_month >= 7 && $current_month <= 9 ) {
                    $end_date = strtotime( '30-September-'.$current_year.'23:59:59' );  
                }
                else if( $current_month >= 10 && $current_month <= 12) {
                    $end_date = strtotime( '1-January-'.( $current_year + 1 ).'23:59:59');  
                }
                
                break;
    
            case 'last_quarter':
                
                $current_month = date('m');
                $current_year = date('Y');
                
                if( $current_month >= 1 && $current_month <= 3 ) {
                    $end_date = strtotime( '1-January-'.$current_year.'23:59:59' );  
                }
                else if( $current_month >= 4 && $current_month <= 6 ) {
                    $end_date = strtotime( '31-March-'.$current_year.'23:59:59' );  
                }
                else if( $current_month >= 7 && $current_month <= 9 ) {
                    $end_date = strtotime( '30-June-'.$current_year.'23:59:59' );  
                }
                else if( $current_month >= 10 && $current_month <= 12 ) {
                    $end_date = strtotime( '30-September-'.$current_year.'23:59:59' );  
                }
                break;
    
            case 'this_year':
                
                $end_date =  mktime( 23, 59, 59, date('m'), date('d'), date('y') ); 
                break;
    
            case 'last_year':
                $end_date = mktime( 23, 59, 59, 12, 31, date('Y')-1 );
                break;
                
            case 'other':
                $explode_end_date = explode ( "-", $user_end_date );
                $month            = $explode_end_date[1];
                $date             = $explode_end_date[2];
                $year             = $explode_end_date[0];
                $end_date         = mktime( 23, 59, 59, $month, $date, $year );
                break;

            default:
                $end_date = time();
        }
        return $end_date;
    }
    
    function get_this_month_amount_reports( $type, $selected_data_range, $start_date, $end_date ) {
    
        $count_month = 0;
        $begin_of_month = $this->get_begin_of_month ( $selected_data_range, $start_date ); //mktime(0, 0, 0, date("n"), 1);
        $end_of_month   = $this->get_end_of_month   ( $selected_data_range, $end_date ); //mktime(23, 59, 0, date("n"), date("t"));
    
        switch ( $type ){
            case 'recover':
                $count_month = $this->get_current_month_recovered_amount ( $begin_of_month, $end_of_month);
                break;
    
            case 'wc_total_sales':
                $count_month = $this->get_wc_total_sales ( $begin_of_month, $end_of_month);
                break;
        }
        return $count_month;
    }
    
    
    function get_this_month_number_reports ( $type, $selected_data_range, $start_date, $end_date ) {
        $count = 0;
        $begin_of_month = $this->get_begin_of_month ( $selected_data_range, $start_date ); //mktime(0, 0, 0, date("n"), 1);
        $end_of_month   = $this->get_end_of_month   ( $selected_data_range, $end_date ); //mktime(23, 59, 0, date("n"), date("t"));
    
        switch ( $type ) {
            case 'abandoned':
                $count = $this->get_current_month_abandoned_count ( $begin_of_month, $end_of_month);
                break;
    
            case 'recover':
                $count = $this->get_current_month_recovered_count ( $begin_of_month, $end_of_month);
                break;
        }
        return $count;
    }
    
    function get_this_month_total_vs_abandoned_order( $type, $selected_data_range, $start_date, $end_date ) {
        $count          = 0;
        $begin_of_month = $this->get_begin_of_month ( $selected_data_range, $start_date );
        $end_of_month   = $this->get_end_of_month   ( $selected_data_range, $end_date );
    
        switch ( $type ) {
    
            case 'abandoned':
                $count = $this->get_current_month_abandoned_count( $begin_of_month, $end_of_month );
                break;
    
            case 'wc_total_orders':
                $count = $this->get_this_month_wc_total_order_count( $begin_of_month, $end_of_month );
                break;
        }
        return $count;
    }
    
    function xorgcore_get_email_report ( $type, $selected_data_range, $user_start_date, $user_end_date ){
        $count = 0;
        $begin_date             = $this->get_begin_of_month ( $selected_data_range, $user_start_date );
        $end_date               = $this->get_end_of_month   ( $selected_data_range, $user_end_date );
        
        $start_date_db          = date( 'Y-m-d H:i:s', $begin_date );
        $end_date_db            = date( 'Y-m-d H:i:s', $end_date );
        switch ( $type ) {
            case 'total_sent':
                $count = $this->xorgcore_get_total_email_sent_count ( $start_date_db, $end_date_db);
                break;
        
            case 'total_opened':
                $count = $this->xorgcore_get_total_emails_opened ( $start_date_db, $end_date_db);
                break;
                
            case 'total_clicked':
                $count = $this->xorgcore_get_total_emails_clicked ( $start_date_db, $end_date_db);
                break;
        }
        return $count;
    }

    
    function xorgcore_get_total_email_sent_count ( $start_date_db, $end_date_db ) {
        global $wpdb; 
        $query_ac_sent          = "SELECT COUNT(wpsh.id) FROM " . xorgcore_EMAIL_SENT_HISTORY_TABLE . " as wpsh 
                                    WHERE wpsh.sent_time >= '$start_date_db' AND 
                                    wpsh.sent_time <= '$end_date_db' ";
        $total_sent_email_count = $wpdb->get_var( $query_ac_sent );        
        return $total_sent_email_count;
    }
     
    function xorgcore_get_total_emails_opened ( $start_date_db, $end_date_db ) {
        global $wpdb;
        $query_ac_opened        = "SELECT COUNT(DISTINCT wpoe.email_sent_id) FROM " . xorgcore_EMAIL_OPENED_TABLE . " as wpoe 
                                    LEFT JOIN ". xorgcore_EMAIL_SENT_HISTORY_TABLE." AS wpsh ON wpsh.id = wpoe.email_sent_id 
                                    WHERE 
                                    time_opened >= '" . $start_date_db . "' 
                                    AND 
                                    time_opened <= '" . $end_date_db . "' 
                                    AND 
                                    wpsh.id = wpoe.email_sent_id ";
        $xorgcore_opened_emails     = $wpdb->get_var( $query_ac_opened );
        return $xorgcore_opened_emails;
    }
     
    function xorgcore_get_total_emails_clicked( $start_date_db, $end_date_db ) {
        global $wpdb;
        $query_ac_clicked       = "SELECT COUNT(DISTINCT wplc.email_sent_id) FROM " . xorgcore_EMAIL_CLICKED_TABLE . " as wplc 
                                    LEFT JOIN ".xorgcore_EMAIL_SENT_HISTORY_TABLE." AS wpsh ON wplc.email_sent_id = wpsh.id 
                                    WHERE wplc.time_clicked >= '" . $start_date_db . "' 
                                    AND 
                                    wplc.time_clicked <= '" . $end_date_db . "' 
                                    ORDER BY wplc.id DESC ";

        $xorgcore_opened_clicked    = $wpdb->get_var( $query_ac_clicked );
    
        return $xorgcore_opened_clicked;
    }
    
    function get_wc_total_sales( $begin_of_month, $end_of_month ) {
        global $wpdb; 
        $count_month         = 0;
        $begin_date_of_month = date( 'Y-m-d H:i:s', $begin_of_month );
        $end_date_of_month   = date( 'Y-m-d H:i:s', $end_of_month );
        
        $order_totals = $wpdb->get_row( "
        
            SELECT SUM(meta.meta_value) AS total_sales, COUNT(posts.ID) AS total_orders FROM {$wpdb->posts} AS posts
        
            LEFT JOIN {$wpdb->postmeta} AS meta ON posts.ID = meta.post_id
        
            WHERE meta.meta_key = '_order_total'
        
            AND posts.post_type = 'shop_order'
        
            AND posts.post_date >= '$begin_date_of_month'
        
            AND posts.post_date <= '$end_date_of_month'
        
            AND posts.post_status IN ( '" . implode( "','", array( 'wc-completed', 'wc-processing', 'wc-on-hold' ) ) . "' )
        
            " ) ;
        
            $count_month = $order_totals->total_sales == null ? 0 : $order_totals->total_sales;       
        return $count_month;
    }
    
    
    function get_current_month_recovered_amount ( $begin_of_month, $end_of_month ){
        global $wpdb;
        $blank_cart_info            =  '{"cart":[]}';
        $blank_cart_info_guest      =  '[]';
        $ac_results                 = array();
        $query_ac                   = "SELECT id, recovered_cart FROM " . xorgcore_ABANDONED_CART_HISTORY_TABLE . " 
                                        WHERE abandoned_cart_info NOT LIKE %s 
                                        AND 
                                        abandoned_cart_info NOT LIKE %s 
                                        AND 
                                        abandoned_cart_time >= %d 
                                        AND 
                                        abandoned_cart_time <= %d 
                                        AND 
                                        recovered_cart > 0 
                                        AND 
                                        xorgcore_trash = '' 
                                        ORDER BY recovered_cart desc";
        $ac_results                 = $wpdb->get_results( $wpdb->prepare( $query_ac, $blank_cart_info, $blank_cart_info_guest, $begin_of_month, $end_of_month ) );

        $recovered_order_total      = 0;
        $wc_get_price_decimals      = wc_get_price_decimals();
        $this->total_recover_amount = round( $recovered_order_total, $wc_get_price_decimals )  ;
        $count_month                = 0;
        $table_data                 = "";
        foreach ( $ac_results as $key => $value ) {
            if( 0 != $value->recovered_cart ) {
                $abandoned_order_id = $value->id;
                $recovered_id       = $value->recovered_cart;
                $rec_order          = get_post_meta( $recovered_id, '_order_total' );

                $recovered_order_total        = 0;
                if ( isset( $rec_order[0] ) ) {
                    $xorgcore_recovered_amount = $rec_order[0];
                    $recovered_order_total = $xorgcore_recovered_amount;
                }
                $count_month = round( ( $recovered_order_total + $count_month ) , $wc_get_price_decimals );
            }
        }
        return $count_month;
    }
    
    function get_current_month_abandoned_amount( $begin_of_month, $end_of_month ) {
        global $wpdb;
        $count_month             = 0;
        $start_date              = $begin_of_month;
        $end_date                = $end_of_month;
        $blank_cart_info         = '{"cart":[]}';
        $blank_cart_info_guest   = '[]';
        $query_ac_carts          = "SELECT abandoned_cart_info FROM " . xorgcore_ABANDONED_CART_HISTORY_TABLE . " 
                                    WHERE abandoned_cart_info NOT LIKE %s 
                                    AND 
                                    abandoned_cart_info NOT LIKE %s 
                                    AND 
                                    abandoned_cart_time >= %d 
                                    AND 
                                    abandoned_cart_time <= %d 
                                    AND 
                                    xorgcore_trash = '' AND cart_ignored <> '1'";
        $ac_carts_results        = $wpdb->get_results( $wpdb->prepare( $query_ac_carts, $blank_cart_info, $blank_cart_info_guest, $start_date, $end_date ) );
        $count_carts = $total_value = 0;
        
        foreach ( $ac_carts_results as $key => $value ) {
            $count_carts += 1;
            $cart_detail = json_decode( stripslashes( $value->abandoned_cart_info ) );
            $product_details = array();
            if( isset( $cart_detail->cart ) ){
                $product_details = $cart_detail->cart;
            }
            $line_total = 0;
            if ( isset( $product_details ) && count( $product_details ) > 0 && $product_details != false ) {
                foreach ( $product_details as $k => $v ) {
                    if( $v->line_subtotal_tax != 0 && $v->line_subtotal_tax > 0 ) {
                        $line_total = $line_total + $v->line_total + $v->line_subtotal_tax;
                    } else {
                        $line_total = $line_total + $v->line_total;
                    }
                }
            }
            $total_value += $line_total;
        }
        $count_month = round( $total_value, wc_get_price_decimals() );
        return $count_month;
    }
    
    function get_current_month_abandoned_count ( $begin_of_month, $end_of_month ) {
        global $wpdb;
        $count_month             = 0;
        $blank_cart_info         = '{"cart":[]}';
        $blank_cart_info_guest   = '[]';
        
        $ac_cutoff_time = is_numeric( get_option( 'ac_cart_abandoned_time', 10 ) ) ? get_option( 'ac_cart_abandoned_time', 10 ) : 10;
        $cut_off_time   = $ac_cutoff_time * 60;        
        $current_time   = current_time( 'timestamp' );
        $compare_time   = $current_time - $cut_off_time;
        
        
        $ac_cutoff_time_guest  = is_numeric( get_option( 'ac_cart_abandoned_time_guest', 10 ) ) ? get_option( 'ac_cart_abandoned_time_guest', 10 ) : 10;
        $cut_off_time_guest    = $ac_cutoff_time_guest * 60;
        $current_time          = current_time ('timestamp');
        $compare_time_guest    = $current_time - $cut_off_time_guest;
        
    
        $query_abandoned  = "SELECT COUNT(id) FROM `".xorgcore_ABANDONED_CART_HISTORY_TABLE."` 
                            WHERE ( user_type = 'REGISTERED' AND abandoned_cart_time >=  $begin_of_month AND abandoned_cart_time <= $end_of_month AND abandoned_cart_info NOT LIKE '%$blank_cart_info%' AND abandoned_cart_time <= '$compare_time' AND xorgcore_trash = '' AND cart_ignored <> '1') 
                            OR ( user_type = 'GUEST' AND abandoned_cart_time >=  $begin_of_month AND abandoned_cart_time <= $end_of_month AND abandoned_cart_info NOT LIKE '$blank_cart_info_guest' AND abandoned_cart_info NOT LIKE '%$blank_cart_info%' AND abandoned_cart_time <= '$compare_time_guest' AND xorgcore_trash = '' AND cart_ignored <> '1' )
                            ";
        $count_month = $wpdb->get_var( $query_abandoned );
        return $count_month;
    }

    function get_adv_stats( $selected_data_range, $start_date, $end_date ) {
        global $wpdb;

        $begin_of_month = $this->get_begin_of_month ( $selected_data_range, $start_date ); //mktime(0, 0, 0, date("n"), 1);
        $end_of_month   = $this->get_end_of_month   ( $selected_data_range, $end_date ); //mktime(23, 59, 0, date("n"), date("t"));

        $count_month             = 0;
        $blank_cart_info         = '{"cart":[]}';
        $blank_cart_info_guest   = '[]';
        
        $ac_cutoff_time = is_numeric( get_option( 'ac_cart_abandoned_time', 10 ) ) ? get_option( 'ac_cart_abandoned_time', 10 ) : 10;
        $cut_off_time   = $ac_cutoff_time * 60;        
        $current_time   = current_time( 'timestamp' );
        $compare_time   = $current_time - $cut_off_time;
        
        
        $ac_cutoff_time_guest  = is_numeric( get_option( 'ac_cart_abandoned_time_guest', 10 ) ) ? get_option( 'ac_cart_abandoned_time_guest', 10 ) : 10;
        $cut_off_time_guest    = $ac_cutoff_time_guest * 60;
        $current_time          = current_time ('timestamp');
        $compare_time_guest    = $current_time - $cut_off_time_guest;
    
        $query_abandoned  = "SELECT abandoned_cart_info, recovered_cart FROM `".xorgcore_ABANDONED_CART_HISTORY_TABLE."` 
                            WHERE ( user_type = 'REGISTERED' AND abandoned_cart_time >=  $begin_of_month AND abandoned_cart_time <= $end_of_month AND abandoned_cart_info NOT LIKE '%$blank_cart_info%' AND abandoned_cart_time <= '$compare_time' AND xorgcore_trash = '' AND ( cart_ignored <> '1' OR recovered_cart <> '0' ) ) 
                            OR ( user_type = 'GUEST' AND abandoned_cart_time >=  $begin_of_month AND abandoned_cart_time <= $end_of_month AND abandoned_cart_info NOT LIKE '$blank_cart_info_guest' AND abandoned_cart_info NOT LIKE '%$blank_cart_info%' AND abandoned_cart_time <= '$compare_time_guest' AND xorgcore_trash = '' AND ( cart_ignored <> '1' OR recovered_cart <> '0' ) )
                            ";

        $count_month = $wpdb->get_results( $query_abandoned );

        $abandoned_count = $recovered_count = $abandoned_amount = $recovered_amount = 0;

        foreach ( $count_month as $cart_value ) {

            $abandoned_count++;

            if ( $cart_value->recovered_cart !== '0' ) {
                $recovered_count++;
            }

            $cart_info = json_decode( stripslashes( $cart_value->abandoned_cart_info ) );
            if ( isset( $cart_info->cart ) ) {
                foreach ( $cart_info->cart as $cart ) {
                    $abandoned_amount += isset( $cart->line_total ) ? $cart->line_total : 0;

                    if ( $cart_value->recovered_cart !== '0' ) {
                        $recovered_amount += isset( $cart->line_total ) ? $cart->line_total : 0;
                    }

                }
            }
        }

        return array(
            'abandoned_count' => $abandoned_count,
            'recovered_count' => $recovered_count,
            'abandoned_amount' => $abandoned_amount,
            'recovered_amount' => $recovered_amount
        );
    }
    
    
    function get_current_month_recovered_count( $begin_of_month, $end_of_month ) {
        global $wpdb;
        $count_month             = 0;
        $blank_cart_info         = '{"cart":[]}';
        $blank_cart_info_guest   = '[]';
    
        $query_recover  = "SELECT COUNT(wach.recovered_cart) FROM `".xorgcore_ABANDONED_CART_HISTORY_TABLE."` as wach 
                            LEFT JOIN ".$wpdb->prefix."posts AS wposts ON wach.recovered_cart = wposts.ID 
                            WHERE 
                            wach.abandoned_cart_time >=  $begin_of_month 
                            AND 
                            wach.abandoned_cart_time <= $end_of_month 
                            AND 
                            wach.recovered_cart != 0 
                            AND 
                            wach.abandoned_cart_info NOT LIKE '%$blank_cart_info%' 
                            AND 
                            wach.abandoned_cart_info NOT LIKE '$blank_cart_info_guest' 
                            AND 
                            wach.xorgcore_trash = '' 
                            AND 
                            wach.recovered_cart = wposts.ID ";
        $count_month    = $wpdb->get_var( $query_recover );
        return $count_month;
    }

    
    
    function get_this_month_wc_total_order_count( $begin_of_month, $end_of_month ) {
        global $wpdb;
        $count_month         = 0;
        $begin_date_of_month = date( 'Y-m-d H:i:s', $begin_of_month );
        $end_date_of_month   = date( 'Y-m-d H:i:s', $end_of_month );
        $sales_query =  "SELECT COUNT(ID) FROM {$wpdb->posts} as posts
                            WHERE posts.post_type     = 'shop_order'
                            AND   
                            posts.post_date >= '$begin_date_of_month'
                            AND   
                            posts.post_date <= '$end_date_of_month' 
                            AND   
                            posts.post_status IN ( '" . implode( "','", array( 'wc-completed', 'wc-processing', 'wc-on-hold' ) ) . "' ) ";
        $count_month = $wpdb->get_var( $sales_query );
        return $count_month;
    }
    
   
    function xorgcore_get_total_email_sent_for_template( $xorgcore_template_id, $selected_data_range, $start_date, $end_date ) {
        global $wpdb;
        $begin_of_month      = $this->get_begin_of_month ( $selected_data_range, $start_date ); //mktime(0, 0, 0, date("n"), 1);
        $end_of_month        = $this->get_end_of_month   ( $selected_data_range, $end_date );
        $begin_date_of_month = date( 'Y-m-d H:i:s', $begin_of_month );
        $end_date_of_month   = date( 'Y-m-d H:i:s', $end_of_month );
    
        $query_no_emails        = "SELECT COUNT(id) FROM " . xorgcore_EMAIL_SENT_HISTORY_TABLE . " 
                                    WHERE template_id = $xorgcore_template_id  
                                    AND 
                                    sent_time >=  '$begin_date_of_month' 
                                    AND 
                                    sent_time <= '$end_date_of_month'";
        $xorgcore_emails_sent_count = $wpdb->get_var( $query_no_emails );
        return $xorgcore_emails_sent_count;
    }
     
    function xorgcore_get_total_email_open_for_template( $xorgcore_template_id, $selected_data_range, $start_date, $end_date ){
        global $wpdb;
        $begin_of_month      = $this->get_begin_of_month ( $selected_data_range, $start_date ); //mktime(0, 0, 0, date("n"), 1);
        $end_of_month        = $this->get_end_of_month   ( $selected_data_range, $end_date );
        $begin_date_of_month = date( 'Y-m-d H:i:s', $begin_of_month );
        $end_date_of_month   = date( 'Y-m-d H:i:s', $end_of_month );
        $query_ac_opened     = "SELECT COUNT( DISTINCT wpoe.email_sent_id )
                                FROM " . xorgcore_EMAIL_OPENED_TABLE . " AS wpoe
                                LEFT JOIN ".xorgcore_EMAIL_SENT_HISTORY_TABLE." AS wpsh ON wpsh.id = wpoe.email_sent_id
                                WHERE time_opened >=  '$begin_date_of_month'
                                AND time_opened <=  '$end_date_of_month'
                                AND wpsh.id = wpoe.email_sent_id
                                AND wpsh.template_id = '$xorgcore_template_id' ";
        $xorgcore_emails_opened_count = $wpdb->get_var( $query_ac_opened );
        return $xorgcore_emails_opened_count;
    }
    
    function xorgcore_get_total_email_click_for_template ( $xorgcore_template_id, $selected_data_range, $start_date, $end_date ){
        global $wpdb;
        $begin_of_month      = $this->get_begin_of_month ( $selected_data_range, $start_date ); //mktime(0, 0, 0, date("n"), 1);
        $end_of_month        = $this->get_end_of_month   ( $selected_data_range, $end_date );
        $begin_date_of_month = date( 'Y-m-d H:i:s', $begin_of_month );
        $end_date_of_month   = date( 'Y-m-d H:i:s', $end_of_month );
    
        $query_ac_clicked    = "SELECT COUNT( DISTINCT wplc.email_sent_id) FROM " . xorgcore_EMAIL_CLICKED_TABLE . " as wplc 
                                LEFT JOIN ".xorgcore_EMAIL_SENT_HISTORY_TABLE." AS wpsh ON wpsh.id = wplc.email_sent_id 
                                WHERE wpsh.template_id = $xorgcore_template_id 
                                AND 
                                wpsh.sent_time >= '$begin_date_of_month' 
                                AND 
                                wpsh.sent_time <= '$end_date_of_month' 
                                AND wplc.email_sent_id IN ( SELECT email_sent_id FROM " . xorgcore_EMAIL_OPENED_TABLE . " )
                                ";
        $xorgcore_emails_clicked_count = $wpdb->get_var( $query_ac_clicked );
        return $xorgcore_emails_clicked_count;
    }
    
    function xorgcore_get_total_email_recover_for_template( $xorgcore_template_id, $selected_data_range, $start_date, $end_date ) {
        global $wpdb;
        $begin_of_month      = $this->get_begin_of_month ( $selected_data_range, $start_date ); //mktime(0, 0, 0, date("n"), 1);
        $end_of_month        = $this->get_end_of_month   ( $selected_data_range, $end_date );
        $begin_date_of_month = date( 'Y-m-d H:i:s', $begin_of_month );
        $end_date_of_month   = date( 'Y-m-d H:i:s', $end_of_month );
    
         $query_recovered_orders = "SELECT COUNT(wpsh.id) FROM " . xorgcore_EMAIL_SENT_HISTORY_TABLE ." AS wpsh
                                    LEFT JOIN ". xorgcore_ABANDONED_CART_HISTORY_TABLE." AS wpac
                                    ON wpsh.abandoned_order_id = wpac.id WHERE wpsh.abandoned_order_id = wpac.id AND wpsh.template_id = $xorgcore_template_id 
                                    AND 
                                    wpsh.recovered_order != '0' 
                                    AND 
                                    wpsh.sent_time >=  '$begin_date_of_month' 
                                    AND 
                                    wpsh.sent_time <= '$end_date_of_month' 
                                    ";
        $number_order_recovered_count   = $wpdb->get_var( $query_recovered_orders );
        return $number_order_recovered_count;
    }
    
    function xorgcore_get_atc_data_of_range( $selected_data_range, $start_date, $end_date ) {
        global $wpdb;
        $begin_of_month      = $this->get_begin_of_month ( $selected_data_range, $start_date );
        $end_of_month        = $this->get_end_of_month   ( $selected_data_range, $end_date );
        $blank_cart_info        = '{"cart":[]}';
        $blank_cart_info_guest  = '[]';
        $xorgcore_post_ac_atc_stats = array(
            "xorgcore_atc_open" => 0, 
            "xorgcore_has_email" => 0, 
            "xorgcore_not_has_email" => 0
        );

        $ac_cutoff_time = is_numeric( get_option( 'ac_cart_abandoned_time', 10 ) ) ? get_option( 'ac_cart_abandoned_time', 10 ) : 10;
        $cut_off_time   = $ac_cutoff_time * 60;        
        $current_time   = current_time( 'timestamp' );
        $compare_time   = $current_time - $cut_off_time;
        
        $ac_cutoff_time_guest  = is_numeric( get_option( 'ac_cart_abandoned_time_guest', 10 ) ) ? get_option( 'ac_cart_abandoned_time_guest', 10 ) : 10;
        $cut_off_time_guest    = $ac_cutoff_time_guest * 60;
        $current_time          = current_time ('timestamp');
        $compare_time_guest    = $current_time - $cut_off_time_guest;
        
        $query_abandoned  = "SELECT * FROM `".xorgcore_ABANDONED_CART_HISTORY_TABLE."` WHERE ( user_type = 'REGISTERED' AND abandoned_cart_time >=  $begin_of_month AND abandoned_cart_time <= $end_of_month AND abandoned_cart_info NOT LIKE '%$blank_cart_info%' AND abandoned_cart_time <= '$compare_time' AND xorgcore_trash = '' AND cart_ignored <> '1') OR ( user_type = 'GUEST' AND abandoned_cart_time >=  $begin_of_month AND abandoned_cart_time <= $end_of_month AND abandoned_cart_info NOT LIKE '$blank_cart_info_guest' AND abandoned_cart_info NOT LIKE '%$blank_cart_info%' AND abandoned_cart_time <= '$compare_time_guest' AND xorgcore_trash = '' AND cart_ignored <> '1') ORDER BY id asc";
        $ac_carts_results = $wpdb->get_results($query_abandoned);  

        if ( count( $ac_carts_results ) > 0  ){
            $xorgcore_start_ac_id = reset( $ac_carts_results );
            $xorgcore_end_ac_id   = end  ( $ac_carts_results );
            
            $xorgcore_post_ac_carts_stats   = "SELECT post_id, meta_value FROM " . $wpdb->prefix . "postmeta WHERE meta_key = 'xorgcore_atc_report' AND post_id >= %d AND post_id <= %d ";
            $xorgcore_post_ac_carts_stats_results = $wpdb->get_results( $wpdb->prepare( $xorgcore_post_ac_carts_stats, $xorgcore_start_ac_id->id , $xorgcore_end_ac_id->id ) );

            $xorgcore_atc_open_count            = 0;
            $xorgcore_atc_email_given_count     = 0;
            $xorgcore_atc_not_email_given_count = 0;

            foreach( $xorgcore_post_ac_carts_stats_results as $xorgcore_post_ac_carts_stats_results_key => $xorgcore_post_ac_carts_stats_results_value ) {
                $xorgcore_ac_atc_data        = $xorgcore_post_ac_carts_stats_results_value->meta_value;
                $xorgcore_ac_atc_data_decode = unserialize( $xorgcore_ac_atc_data );
                if( 'yes' == $xorgcore_ac_atc_data_decode['xorgcore_atc_open'] ) {
                    $xorgcore_atc_open_count++;
                }
                if( 'yes' == $xorgcore_ac_atc_data_decode['xorgcore_atc_action'] ) {
                    $xorgcore_atc_email_given_count++;
                } else if ( 'no' == $xorgcore_ac_atc_data_decode['xorgcore_atc_action'] ) {
                    $xorgcore_atc_not_email_given_count++;
                }
            }
            $xorgcore_post_ac_atc_stats = array( 
                "xorgcore_atc_open" => $xorgcore_atc_open_count, 
                "xorgcore_has_email" => $xorgcore_atc_email_given_count, 
                "xorgcore_not_has_email" => $xorgcore_atc_not_email_given_count ); 
        }
        return $xorgcore_post_ac_atc_stats;
    }

    
    function get_abandoned_data( $selected_data_range, $begin_of_month, $end_of_month ) {
        global $wpdb;

        

        $begin_of_month = current_time('timestamp');
        $days = 8;

        $data[date('Y-m-d', $begin_of_month)] = array(
            'abandoned_amount' => 0,
            'recovered_amount' => 0
        );
        for( $day = 1; $day < $days; $day++ ){
            $data[date('Y-m-d', strtotime( "-$day day", $begin_of_month))] = array(
                'abandoned_amount' => 0,
                'recovered_amount' => 0
            );

            $end_date = strtotime( "-$day day", $begin_of_month );
        }

        $count_month             = 0;
        $start_date              = $end_of_month;
        $end_date                = $begin_of_month;
        $blank_cart_info         = '{"cart":[]}';
        $blank_cart_info_guest   = '[]';
        $query_ac_carts          = "SELECT abandoned_cart_time, recovered_cart, abandoned_cart_info FROM " . xorgcore_ABANDONED_CART_HISTORY_TABLE . " 
                                    WHERE abandoned_cart_info NOT LIKE %s AND 
                                    abandoned_cart_info NOT LIKE %s AND 
                                    abandoned_cart_time >= %d AND 
                                    abandoned_cart_time <= %d AND 
                                    xorgcore_trash = '' AND ( cart_ignored <> '1' OR recovered_cart <> '0' )";

        $ac_carts_results        = $wpdb->get_results( $wpdb->prepare( $query_ac_carts, $blank_cart_info, $blank_cart_info_guest, $start_date, $end_date ) );

        foreach ( $ac_carts_results as $cart_value ) {
            $selected_date = date('Y-m-d', $cart_value->abandoned_cart_time);

            if ( isset( $data[$selected_date] ) ) {
                $cart_info = json_decode( stripslashes( $cart_value->abandoned_cart_info ) );
                if( isset( $cart_info ) && false != $cart_info && count( get_object_vars( $cart_info ) ) > 0 && isset( $cart_info->cart ) ) {
                    foreach ( $cart_info->cart as $cart ) {
                        $data[$selected_date]['abandoned_amount'] += isset( $cart->line_total ) ? $cart->line_total : 0;

                        if ( $cart_value->recovered_cart != 0 ) {
                            $data[$selected_date]['recovered_amount'] += isset( $cart->line_total ) ? $cart->line_total : 0;
                        }
                    }
                }
            }
        }
        return array_reverse( $data );
    }

}
