<?php

if (!defined('ABSPATH')) {
    exit; 
}

if ( !class_exists('xorgcore_Cart_Updated' ) ) {
    
    class xorgcore_Cart_Updated {

        private static $current_time;
        private static $current_user_lang;
        
        public static function xorgcore_store_cart_timestamp() {

          if ( is_user_logged_in() || xorgcore_get_cart_session( 'xorgcore_abandoned_id' ) != '' ||
               xorgcore_get_cart_session( 'xorgcore_email_sent_id' ) != '' ||
               ( get_option( 'xorgcore_atc_enable_modal' ) === 'on' && get_option( 'xorgcore_atc_mandatory_email' ) !== 'on' ) ||
                get_option( 'xorgcore_atc_enable_modal' ) === 'off' ) {

            
            

            if ( get_transient( 'xorgcore_selected_language' ) !== false ) {
              xorgcore_set_cart_session( 'xorgcore_selected_language', get_transient( 'xorgcore_selected_language' ) );
              delete_transient( 'xorgcore_selected_language' );
            }
            if ( get_transient( 'xorgcore_c' ) !== false ) {
              xorgcore_set_cart_session( 'xorgcore_c', get_transient( 'xorgcore_c' ) );
              delete_transient( 'xorgcore_c' );
            }
            if ( get_transient( 'xorgcore_email_sent_id' ) !== false ) {
              xorgcore_set_cart_session( 'xorgcore_email_sent_id', get_transient( 'xorgcore_email_sent_id' ) );
              delete_transient( 'xorgcore_email_sent_id' );
            }

            self::$current_time       = current_time( 'timestamp' );
            self::$current_user_lang  = xorgcore_Common::xorgcore_get_language();
            $user_id                  = get_current_user_id();
            $xorgcore_is_user_restricted  = false;
            $xorgcore_get_is_user_blocked = array();
            $xorgcore_get_is_user_blocked = get_user_meta( $user_id, 'xorgcore_restrict_user' );

            if ( isset( $xorgcore_get_is_user_blocked[0] ) && count( $xorgcore_get_is_user_blocked ) > 0 && "on" == $xorgcore_get_is_user_blocked[0] ) {
                $xorgcore_is_user_restricted = true;
            }

            $enable_tracking = get_option( 'xorgcore_enable_tracking', '' );
            if ( is_user_logged_in() ) {
                if ( false == $xorgcore_is_user_restricted ) {
                    xorgcore_Cart_Updated::xorgcore_capture_logged_in_cart( $user_id );
                }
            } else {
                xorgcore_Cart_Updated::xorgcore_capture_guest_and_visitor_cart();
            }
          }
        }
        
        public static function xorgcore_capture_logged_in_cart( $user_id ) {

			if ( '' !== xorgcore_get_cart_session( 'xorgcore_user_id' ) &&
				 '' !== xorgcore_get_cart_session( 'xorgcore_guest_email' ) &&
				 null !== xorgcore_get_cart_session( 'xorgcore_abandoned_id' ) ) {
				return;
			}

            global $wpdb;
            $disable_logged_in_cart = get_option( 'ac_disable_logged_in_cart_email' );
            $cut_off                = is_numeric( get_option( 'ac_cart_abandoned_time', 10 ) ) ? get_option( 'ac_cart_abandoned_time', 10 ) : 10;
            $cart_cut_off_time      = intval( $cut_off ) * 60;
            $compare_time           = self::$current_time - $cart_cut_off_time;
            $logged_in_cart         = "";
            if ( isset( $disable_logged_in_cart ) ) {
                $logged_in_cart = $disable_logged_in_cart;
            }

            $loggedin_user_ip_address = xorgcore_Common::xorgcore_get_client_ip();
            $user_email_biiling       = get_user_meta( $user_id, 'billing_email', true );
            $current_user_email       = '';
            if (  "" == $user_email_biiling && isset( $user_email_biiling )  ) {
                $current_user_data   = get_userdata( $user_id );
                $current_user_email  = $current_user_data->user_email;
            } else {
                $current_user_email  = $user_email_biiling;
            }

            $xorgcore_is_ip_restricted            = xorgcore_Common::xorgcore_is_ip_restricted            ( $loggedin_user_ip_address );
            $xorgcore_is_email_address_restricted = xorgcore_Common::xorgcore_is_email_address_restricted ( $current_user_email );
            $xorgcore_is_domain_restricted        = xorgcore_Common::xorgcore_is_domain_restricted        ( $current_user_email );

            if ( $logged_in_cart != "on" && ( false == $xorgcore_is_ip_restricted && false == $xorgcore_is_email_address_restricted && false == $xorgcore_is_domain_restricted ) ) {

                $query   = "SELECT * FROM `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` WHERE user_id = %d AND cart_ignored IN ('0','2') AND recovered_cart = '0' ";
                $results = $wpdb->get_results( $wpdb->prepare( $query, $user_id ) );
                if ( count( $results ) == 0 ) {
                    xorgcore_Cart_Updated::xorgcore_insert_new_entry_of_loggedin_user( $user_id, self::$current_user_lang, $loggedin_user_ip_address, $results );
                } elseif ( $compare_time > $results[0]->abandoned_cart_time ) {
                    xorgcore_Cart_Updated::xorgcore_capture_cart_after_cutoff_loggedin_user ( $user_id, $results, self::$current_user_lang, $loggedin_user_ip_address );
                } else {
                    xorgcore_Cart_Updated::xorgcore_cart_capture_under_cart_cutoff_loggedin( $user_id, $results, self::$current_user_lang, $loggedin_user_ip_address );
				}

				if ( '' !== xorgcore_get_cart_session( 'xorgcore_guest_email' ) ) {
					xorgcore_set_cart_session( 'xorgcore_guest_email', '' );
				}
            }
        }
        
        public static function xorgcore_insert_new_entry_of_loggedin_user( $user_id, $current_user_lang, $loggedin_user_ip_address, $results ) {

          global $wpdb, $woocommerce;
          //$xorgcorel_woocommerce_persistent_cart = version_compare( $woocommerce->version, '3.1.0', ">=" ) ? '_woocommerce_persistent_cart_' . get_current_blog_id() : '_woocommerce_persistent_cart' ;
          //$updated_cart_info = json_encode( get_user_meta( $user_id, $xorgcorel_woocommerce_persistent_cart , true ) );

          $updated_cart_info         = array();
          $updated_cart_info['cart'] = WC()->session->cart;
          $updated_cart_info         = json_encode( $updated_cart_info );

          $cart_info = addslashes( $updated_cart_info );

          $blank_cart_info = '{"cart":[]}';
           if ( $blank_cart_info != $updated_cart_info &&  '""' != $cart_info && '""' != $updated_cart_info ) {
              
              $xorgcore_query   = "SELECT * FROM `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` WHERE user_id = %d AND cart_ignored = '1' AND recovered_cart = '0' ORDER BY id DESC LIMIT 1 ";
              $xorgcore_results = $wpdb->get_results( $wpdb->prepare( $xorgcore_query, $user_id ) );
                if ( count( $xorgcore_results ) > 0  ) {

                    $xorgcore_is_cart_updated = xorgcore_Cart_Updated::xorgcore_compare_all_users_carts( $updated_cart_info, $xorgcore_results[0]->abandoned_cart_info );

                    if ( ( $xorgcore_is_cart_updated != '' && '""' != $updated_cart_info ) || ( true === $xorgcore_is_cart_updated && '""' != $updated_cart_info ) ) {

                        $abandoned_cart_id = xorgcore_DB_Layer::insert_cart_history( 
                          $user_id, 
                          $cart_info, 
                          self::$current_time, 
                          '0', 
                          '0', 
                          '', 
                          'REGISTERED', 
                          $current_user_lang, 
                          '', 
                          $loggedin_user_ip_address, 
                          '', 
                          '' );

                        xorgcore_set_cart_session( 'xorgcore_abandoned_id', $abandoned_cart_id );
                    }

                } else if ( count( $results) == 0 ) {
                    $abandoned_cart_id = xorgcore_DB_Layer::insert_cart_history( 
                          $user_id, 
                          $cart_info, 
                          self::$current_time, 
                          '0', 
                          '0', 
                          '', 
                          'REGISTERED', 
                          $current_user_lang, 
                          '', 
                          $loggedin_user_ip_address, 
                          '', 
                          '' );

                    xorgcore_set_cart_session( 'xorgcore_abandoned_id', $abandoned_cart_id );
                }

                if ( xorgcore_get_cart_session( 'xorgcore_abandoned_id' ) != '' ) {
                    $abandoned_cart_id_hook = xorgcore_get_cart_session( 'xorgcore_abandoned_id' );
                	do_action ('acfac_add_data', $abandoned_cart_id_hook );
                	xorgcore_Common::xorgcore_add_checkout_link( $abandoned_cart_id_hook );
                	xorgcore_Common::xorgcore_run_webhook_after_cutoff( $abandoned_cart_id_hook );

                }
            }else if ( $blank_cart_info == $updated_cart_info && '""' == $updated_cart_info ){
                
                $query_ignored = "UPDATE `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` SET cart_ignored = '1' WHERE user_id ='" . $user_id . "'";
                $wpdb->query( $query_ignored );
            }
        }
        
        public static function xorgcore_capture_cart_after_cutoff_loggedin_user( $user_id, $results, $current_user_lang, $loggedin_user_ip_address ){

            global $wpdb, $woocommerce;

            //$xorgcorel_woocommerce_persistent_cart =version_compare( $woocommerce->version, '3.1.0', ">=" ) ? '_woocommerce_persistent_cart_' . get_current_blog_id() : '_woocommerce_persistent_cart' ;

            //$cart_data = get_user_meta( $user_id, $xorgcorel_woocommerce_persistent_cart , true );

            $cart_data         = array();
            $cart_data['cart'] = WC()->session->cart;

            $wc_shipping_charges = WC()->cart->get_cart_shipping_total();
            
            $wc_shipping_charges = strip_tags( html_entity_decode( $wc_shipping_charges ) );
            $wc_shipping_charges = (float) filter_var( $wc_shipping_charges, FILTER_SANITIZE_NUMBER_FLOAT, FILTER_FLAG_ALLOW_FRACTION );
            if( isset( $cart_data ) && is_array( $cart_data ) ) {
              $cart_data[ 'shipping_charges' ] = $wc_shipping_charges;
            }
            $updated_cart_info = json_encode( $cart_data );
          
            $blank_cart_info   = array( '{"cart":[],"shipping_charges":0}', '{"cart":[]}' );

            if (  ! in_array( $updated_cart_info, $blank_cart_info ) ) {

                $shipping_charge_changes = xorgcore_Cart_Updated::xorgcore_check_shipping_charges( $updated_cart_info, $results[0]->abandoned_cart_info );
                
                $updated_cart_info = addslashes ( $updated_cart_info );
              
                if ( xorgcore_Cart_Updated::xorgcore_compare_all_users_carts( $updated_cart_info, $results[0]->abandoned_cart_info ) && '""' !== $updated_cart_info  ) {

                    if( xorgcore_get_cart_session( 'xorgcore_email_sent_id' ) != '' ){
                      $query_update_cart = "UPDATE `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` SET 
                        abandoned_cart_info = '".$updated_cart_info."' 
                        WHERE user_id ='" . $user_id . "' AND cart_ignored='0' ";
                      $wpdb->query( $query_update_cart );
                    }else {
                      $query_ignored = "UPDATE `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` SET cart_ignored = '1' WHERE user_id ='" . $user_id . "'";
                      $wpdb->query( $query_ignored );

                      $insert_id = xorgcore_DB_Layer::insert_cart_history( 
                            $user_id, 
                            $updated_cart_info, 
                            self::$current_time, 
                            '0', 
                            '0', 
                            '', 
                            'REGISTERED', 
                            $current_user_lang, 
                            '', 
                            $loggedin_user_ip_address, 
                            '', 
                            '' );

                      xorgcore_set_cart_session( 'xorgcore_abandoned_id', $insert_id );

                      if ( '' !== $insert_id ) {
                        do_action ('acfac_add_data', $insert_id );
                        xorgcore_Common::xorgcore_add_checkout_link( $insert_id );
                        xorgcore_Common::xorgcore_run_webhook_after_cutoff( $insert_id );
                      }
                    }
                } else if( $shipping_charge_changes ) {

                    if ( function_exists( 'icl_object_id' ) ) {
                      $updated_cart_info = xorgcore_DB_Layer::add_wcml_currency( $updated_cart_info );
                    }
                    
                    $update_data = array( 'abandoned_cart_info' => $updated_cart_info,
                                          'language'            => $current_user_lang,
                                          'ip_address'          => $loggedin_user_ip_address,
                    );
                    
                    $wpdb->update( xorgcore_ABANDONED_CART_HISTORY_TABLE, $update_data, array( 'id' => $results[0]->id ) );

                    xorgcore_set_cart_session( 'xorgcore_abandoned_id', $results[0]->id );
                    if ( '' !== $results[0]->id ) {
                        do_action ('acfac_add_data', $results[0]->id );
                    }
                }
            }else if ( in_array( $updated_cart_info, $blank_cart_info ) && isset( $results[0]->id ) ) {
                $email_sent_id = xorgcore_get_cart_session( 'xorgcore_email_sent_id' );
                if ( false === $email_sent_id || is_null( $email_sent_id ) ) { 
                  xorgcore_DB_Layer::xorgcore_delete_abandoned_order( array( 'user_id' => $user_id, 'id' => $results[0]->id ) );
                } else if( $email_sent_id > 0 ) {
                	
                  $query_update_cart = "UPDATE `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` SET 
                        abandoned_cart_info = '".$updated_cart_info."' 
                        WHERE user_id ='" . $user_id . "' AND cart_ignored='0' ";
                  $wpdb->query( $query_update_cart );
                
                }
            }
        }
        
        public static function xorgcore_cart_capture_under_cart_cutoff_loggedin ( $user_id, $results, $current_user_lang, $loggedin_user_ip_address ){

            global $wpdb, $woocommerce;
            $blank_cart_info   = array( '{"cart":[],"shipping_charges":0}', '{"cart":[]}' );

            //$xorgcorel_woocommerce_persistent_cart = version_compare( $woocommerce->version, '3.1.0', ">=" ) ? '_woocommerce_persistent_cart_' . get_current_blog_id() : '_woocommerce_persistent_cart' ;
            
            //$cart_data = get_user_meta( $user_id, $xorgcorel_woocommerce_persistent_cart , true );

            $cart_data         = array();
            $cart_data['cart'] = WC()->session->cart;

            $wc_shipping_charges = WC()->cart->get_cart_shipping_total();
            
            $wc_shipping_charges = strip_tags( html_entity_decode( $wc_shipping_charges ) );
            $wc_shipping_charges = (float) filter_var( $wc_shipping_charges, FILTER_SANITIZE_NUMBER_FLOAT, FILTER_FLAG_ALLOW_FRACTION );
            
            $cart_data[ 'shipping_charges' ] = $wc_shipping_charges;
            
            $updated_cart_info = json_encode( $cart_data );

            if ( ( $results[0]->language == '' || $results[0]->language == $current_user_lang ) && ! in_array( $updated_cart_info, $blank_cart_info ) ) {
              
                $shipping_charge_changes = xorgcore_Cart_Updated::xorgcore_check_shipping_charges( $updated_cart_info, $results[0]->abandoned_cart_info );
                $updated_cart_info = addslashes ( $updated_cart_info );

                if ( function_exists( 'icl_object_id' ) ) {
                  $updated_cart_info = xorgcore_DB_Layer::add_wcml_currency( $updated_cart_info );
                }

                if ( ( xorgcore_Cart_Updated::xorgcore_compare_all_users_carts( $updated_cart_info, $results[0]->abandoned_cart_info ) && '""' !== $updated_cart_info ) || $shipping_charge_changes ) {

                    $query_update = "UPDATE `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` SET abandoned_cart_info = '" . $updated_cart_info . "', abandoned_cart_time  = '" . self::$current_time . "', language = '". $current_user_lang ."', ip_address = '". $loggedin_user_ip_address ."'   WHERE id ='" . $results[0]->id . "' ";
                    $wpdb->query( $query_update );

                    xorgcore_set_cart_session( 'xorgcore_abandoned_id', $results[0]->id );
                    if ( '' !== $results[0]->id ){
                        do_action ('acfac_add_data', $results[0]->id );
                    }
                }
            }else if ( in_array( $updated_cart_info, $blank_cart_info ) && isset( $results[0]->id ) ) {
                xorgcore_DB_Layer::xorgcore_delete_abandoned_order( array( 'user_id' => $user_id, 'id' => $results[0]->id ) );
            }
        }
        
        public static function xorgcore_capture_guest_and_visitor_cart(){

            global $wpdb, $woocommerce;

            $disable_guest_cart                 = get_option( 'ac_disable_guest_cart_email' );

            $track_guest_cart_from_cart_page    = get_option( 'ac_track_guest_cart_from_cart_page' );
            $cut_off                            = get_option( 'ac_cart_abandoned_time_guest' );
            $cart_cut_off_time                  = intval( $cut_off ) * 60;
            $compare_time                       = self::$current_time - $cart_cut_off_time;
            $guest_cart                         = "";
            if ( isset( $disable_guest_cart ) ) {
                $guest_cart = $disable_guest_cart;
            }
            $guest_user_ip_address   = xorgcore_Common::xorgcore_get_client_ip();

            $user_id = xorgcore_get_cart_session( 'xorgcore_user_id' );

            $cart    = array();
            $results = array();
          
            if ( $user_id > 0 ){
                $query   = "SELECT * FROM `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` WHERE user_id = %d AND cart_ignored IN ('0','2') AND recovered_cart = '0' AND user_id != '0'";
                $results = $wpdb->get_results( $wpdb->prepare( $query, $user_id ) );
            }

            if ( function_exists('WC') ) {
                $cart['cart'] = WC()->session->cart;
            } else {
                $cart['cart'] = $woocommerce->session->cart;
            }
            $updated_cart_info = json_encode( $cart );
            $updated_cart_info = addslashes ( $updated_cart_info );

            $guest_blank_cart_info  = '[]';
            if ( count($results) > 0 ) {
                if ( $guest_cart != "on" ) {
                    if ( $compare_time > $results[0]->abandoned_cart_time ) {
                        if (  '' != $updated_cart_info &&
                            $updated_cart_info != $guest_blank_cart_info &&
                            xorgcore_Cart_Updated::xorgcore_compare_all_users_carts( $updated_cart_info, $results[0]->abandoned_cart_info ) ) {

                            xorgcore_Cart_Updated::xorgcore_update_guest_cart_after_cutoff_time( $user_id, $updated_cart_info, self::$current_user_lang, $guest_user_ip_address );
                        }
                    } else {
                        if (  '' != $updated_cart_info &&
                            $updated_cart_info != $guest_blank_cart_info &&
                                xorgcore_Cart_Updated::xorgcore_compare_all_users_carts( $updated_cart_info, $results[0]->abandoned_cart_info ) ) {

                                xorgcore_Cart_Updated::xorgcore_update_guest_cart_within_cutoff_time( $user_id, $updated_cart_info, $guest_user_ip_address, $results[0]->id );
                        }
                    }
                }
            } else {

                
                $xorgcore_is_ip_restricted = xorgcore_Common::xorgcore_is_ip_restricted( $guest_user_ip_address );
                if ( isset( $disable_guest_cart ) ) {
                    $guest_cart = $disable_guest_cart;
                }

                $track_guest_user_cart_from_cart     = "";
                if ( isset( $track_guest_cart_from_cart_page ) ) {
                    $track_guest_user_cart_from_cart = $track_guest_cart_from_cart_page;
                }

                $xorgcore_guest_cart_key = xorgcore_Common::xorgcore_get_guest_session_key();

                if ( $xorgcore_guest_cart_key !== '' &&
                    $track_guest_user_cart_from_cart == "on" &&
                    false == $xorgcore_is_ip_restricted && 
                    ( xorgcore_get_cart_session( 'xorgcore_abandoned_id' ) != '' ||
                      xorgcore_get_cart_session( 'xorgcore_email_sent_id' ) != '' || 
                      get_option( 'xorgcore_atc_enable_modal' ) === 'off' ) ) {
                        xorgcore_Cart_Updated::xorgcore_capture_visitors_cart( $compare_time, $updated_cart_info, self::$current_user_lang, $guest_user_ip_address, $xorgcore_guest_cart_key );
                }
            }
        }

        public static function xorgcore_update_session_id() {
            if ( null === xorgcore_get_cart_session( 'xorgcore_update_visitor_cart' ) && 
                null !== xorgcore_get_cart_session( 'xorgcore_abandoned_id' ) && 
                0 !== xorgcore_Common::xorgcore_get_guest_session_key() ) {
                global $wpdb;

                $wpdb->update(
					xorgcore_ABANDONED_CART_HISTORY_TABLE,
					array( 
						'session_id' => esc_attr( xorgcore_Common::xorgcore_get_guest_session_key() ),
					),
					array( 'id' => esc_attr( xorgcore_get_cart_session( 'xorgcore_abandoned_id' ) ) )
				);
                xorgcore_set_cart_session( 'xorgcore_update_visitor_cart', 'updated' );
            }
        }

        
        public static function xorgcore_capture_visitors_cart ( $compare_time, $updated_cart_info, $current_user_lang, $visitor_user_ip_address, $xorgcore_guest_cart_key ) {

            global $wpdb;

            $query     = "SELECT * FROM `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` WHERE session_id LIKE %s AND cart_ignored = '0' AND recovered_cart = '0' ";
            $results   = $wpdb->get_results( $wpdb->prepare( $query, $xorgcore_guest_cart_key ) );

            $cart_info = $updated_cart_info;
            if ( count( $results ) == 0 ) {
                xorgcore_Cart_Updated::xorgcore_capture_new_visitor_cart ( $cart_info, $current_user_lang, $visitor_user_ip_address, $xorgcore_guest_cart_key );
            } elseif ( $compare_time > $results[0]->abandoned_cart_time ) {
                xorgcore_Cart_Updated::xorgcore_capture_after_cutofftime_visitor_cart ( $results, $current_user_lang, $visitor_user_ip_address, $updated_cart_info, $xorgcore_guest_cart_key );
            } else {
                xorgcore_Cart_Updated::xorgcore_capture_within_cutofftime_visitor_cart ( $results, $current_user_lang, $visitor_user_ip_address, $updated_cart_info, $xorgcore_guest_cart_key );
            }
        }

        
        public static function xorgcore_capture_new_visitor_cart ( $cart_info, $current_user_lang, $visitor_user_ip_address, $xorgcore_guest_cart_key ){

            global $wpdb;
            $blank_cart_info  = '[]';
            if ( '' != $cart_info && $blank_cart_info != $cart_info ) {

                $insert_id = xorgcore_DB_Layer::insert_cart_history( 
                  '', 
                  $cart_info, 
                  self::$current_time, 
                  '0', 
                  '0', 
                  '', 
                  'GUEST', 
                  $current_user_lang, 
                  $xorgcore_guest_cart_key, 
                  $visitor_user_ip_address, 
                  '', 
                  '' );

                xorgcore_set_cart_session( 'xorgcore_abandoned_id', $insert_id );

                if ( $insert_id != '' ) {
                  do_action ('acfac_add_data', $insert_id );
                }
            }
        }
        
        public static function xorgcore_capture_after_cutofftime_visitor_cart ( $results, $current_user_lang, $visitor_user_ip_address, $updated_cart_info, $xorgcore_guest_cart_key ) {

            global $wpdb;
            $blank_cart_info  = '[]';

            if (  '' != $updated_cart_info  &&
                ( $results[0]->language == $current_user_lang || $results[0]->language == '' ) &&
                $blank_cart_info != $updated_cart_info ) {

                    if ( xorgcore_Cart_Updated::xorgcore_compare_all_users_carts( $updated_cart_info, $results[0]->abandoned_cart_info ) ) {

                        $query_ignored = "UPDATE `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` SET cart_ignored = '1', ip_address = '". $visitor_user_ip_address ."' WHERE session_id ='" . $xorgcore_guest_cart_key . "'";
                        $wpdb->query( $query_ignored );

                        $insert_id = xorgcore_DB_Layer::insert_cart_history( 
                          '', 
                          $updated_cart_info, 
                          self::$current_time, 
                          '0', 
                          '0', 
                          '', 
                          'GUEST', 
                          $current_user_lang, 
                          $xorgcore_guest_cart_key, 
                          $visitor_user_ip_address, 
                          '', 
                          '' );

                        xorgcore_set_cart_session( 'xorgcore_abandoned_id', $insert_id );

                        if ( '' !== $insert_id ) {
                            do_action ('acfac_add_data', $insert_id );
                        }
                    }
            }
        }
        
        public static function xorgcore_capture_within_cutofftime_visitor_cart ( $results, $current_user_lang, $visitor_user_ip_address, $updated_cart_info, $xorgcore_guest_cart_key ) {
            global $wpdb;
            $blank_cart_info = '[]';

            if ( '' != $updated_cart_info &&
               ( $results[0]->language == $current_user_lang ||  $results[0]->language == '' ) &&
               $blank_cart_info != $updated_cart_info ) {

                if ( xorgcore_Cart_Updated::xorgcore_compare_all_users_carts( $updated_cart_info, $results[0]->abandoned_cart_info ) ) {

                    if ( function_exists( 'icl_object_id' ) ) {
                      $updated_cart_info = xorgcore_DB_Layer::add_wcml_currency( $updated_cart_info );
                    }

                    $query_update = "UPDATE `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` SET abandoned_cart_info = '" . $updated_cart_info . "', abandoned_cart_time  = '" . self::$current_time . "', language = '". $current_user_lang ."', ip_address = '". $visitor_user_ip_address ."' WHERE session_id ='" . $xorgcore_guest_cart_key . "' AND cart_ignored='0' ";
                    $wpdb->query( $query_update );

                    if ( '' !== $results[0]->id ) {
                        do_action ('acfac_add_data', $results[0]->id );
                    }
                }
            }
        }

        
        public static function xorgcore_update_guest_cart_after_cutoff_time ( $user_id, $updated_cart_info, $current_user_lang, $guest_user_ip_address ) {

            global $wpdb;

            if( xorgcore_get_cart_session( 'xorgcore_email_sent_id' ) != '' ){
				$updated_cart_decoded = json_decode( stripslashes( $updated_cart_info ) );
                
                if ( ! isset( $updated_cart_decoded->xorgcore_user_ref ) ) {
                    
                    
                    $get_cart_existing = $wpdb->get_var( $wpdb->prepare( 'SELECT abandoned_cart_info FROM ' . xorgcore_ABANDONED_CART_HISTORY_TABLE . ' WHERE user_id = %d', $user_id ) );
                    $existing_cart_decoded = json_decode( stripslashes( $get_cart_existing ) );
                    if ( isset( $existing_cart_decoded->xorgcore_user_ref ) ) {
                        $updated_cart_decoded->xorgcore_user_ref = $existing_cart_decoded->xorgcore_user_ref;
                        $updated_cart_info = json_encode( $updated_cart_decoded );
                    }
                }
              $query_update_cart = "UPDATE `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` SET 
                abandoned_cart_info = '".$updated_cart_info."' 
                WHERE user_id ='" . $user_id . "' AND cart_ignored='0' ";
              $wpdb->query( $query_update_cart );
            }else {
              $query_ignored = "UPDATE `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` SET cart_ignored = '1' WHERE user_id ='" . $user_id . "'";
              $wpdb->query( $query_ignored );

              $insert_id = xorgcore_DB_Layer::insert_cart_history( 
                $user_id, 
                $updated_cart_info, 
                self::$current_time, 
                '0', 
                '0', 
                '', 
                'GUEST', 
                $current_user_lang, 
                '', 
                $guest_user_ip_address, 
                '', 
                '' );

              xorgcore_set_cart_session( 'xorgcore_abandoned_id', $insert_id );

              if ( '' !== $insert_id ) {
                do_action ('acfac_add_data', $insert_id );
                xorgcore_Common::xorgcore_add_checkout_link( $insert_id );
                xorgcore_Common::xorgcore_run_webhook_after_cutoff( $insert_id );
              }
            }
        }

        
        public static function xorgcore_update_guest_cart_within_cutoff_time ( $user_id, $updated_cart_info, $guest_user_ip_address, $abandoned_cart_id ) {

            global $wpdb;

            if( is_multisite() ) {
                $main_prefix = $wpdb->get_blog_prefix(1);
            }else {
                $main_prefix = $wpdb->prefix;
            }

            if ( function_exists( 'icl_object_id' ) ) {
              $updated_cart_info = xorgcore_DB_Layer::add_wcml_currency( $updated_cart_info );
            }

            $query_update = "UPDATE `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` 
                                SET 
                                abandoned_cart_info = '".$updated_cart_info."', 
                                abandoned_cart_time = '" . self::$current_time . "',  
                                ip_address = '" . $guest_user_ip_address . "' 
                                WHERE 
                                user_id='" . $user_id . "' AND cart_ignored='0' ";
            $wpdb->query( $query_update );

            
            $wpdb->query( "UPDATE `" .  $main_prefix . "usermeta` 
              SET meta_value = '" . $updated_cart_info . "'
              WHERE user_id = '" . $user_id . "'
              AND meta_key = '_woocommerce_persistent_cart'" );
            

            if ( '' !== $abandoned_cart_id ) {
                do_action ('acfac_add_data', $abandoned_cart_id );
            }
        }

        
        public static function xorgcore_compare_all_users_carts( $new_cart, $last_abandoned_cart) {

            $current_woo_cart   = $abandoned_cart_arr = array();

            $current_woo_cart   = json_decode( stripslashes( $new_cart ), true );
            $abandoned_cart_arr = json_decode( stripslashes( $last_abandoned_cart ), true );

            
            if( isset( $current_woo_cart['cart'], $abandoned_cart_arr['cart'] ) ) {
              if ( ( is_array( $current_woo_cart ) && is_array( $abandoned_cart_arr ) ) &&
                  ( count( $current_woo_cart['cart'] ) <  count( $abandoned_cart_arr['cart'] ) || 
                 count( $current_woo_cart['cart'] ) >  count( $abandoned_cart_arr['cart'] ) ) ) {
                  return true;
              }

              $xorgcore_check_cart_diff = xorgcore_Cart_Updated::xorgcore_array_diff_recursive( $current_woo_cart['cart'], $abandoned_cart_arr['cart'] );

              if ( $xorgcore_check_cart_diff != 0 ){
                return true;
              }
            }
          return false;
        }
        
        public static function xorgcore_array_diff_recursive( $array1, $array2 ) {
            $difference = array();
            $new_diff   = array();
            if( is_array( $array1 ) && count( $array1 ) > 0 ) {
                foreach( $array1 as $key => $value ) {
                    if( is_array( $value ) ) {
                        if( !isset( $array2[$key] ) ) {
                            $difference[$key] = $value;
                        } elseif( !is_array( $array2[$key] ) ) {
                            $difference[$key] = $value;
                        } else {
                            $new_diff = xorgcore_Cart_Updated::xorgcore_array_diff_recursive( $value, $array2[$key] );
                            if( $new_diff != FALSE ) {
                                $difference[$key] = $new_diff;
                            }
                        }
                    } elseif( !isset( $array2[$key] ) || $array2[$key] != $value ) {
                        $difference[$key] = $value;
                    }
                }
                $blank_difference = array_filter( $difference );
              
                if ( count( $difference ) > 0  && !empty( $blank_difference ) ) {
                    return $difference ;
                } else {
                    return 0;
                }
            } else {
                return 0;
            }
        }
        
        
        static function xorgcore_check_shipping_charges( $updated_cart, $existing_cart ) {
        
            $updated_cart_decoded = json_decode( $updated_cart );
            $existing_cart_decoded = json_decode( $existing_cart );

            if( isset( $updated_cart_decoded->shipping_charges ) && isset( $existing_cart_decoded->shipping_charges ) ) {
                if( $updated_cart_decoded->shipping_charges != $existing_cart_decoded->shipping_charges ) {
                    return true;
                }
            }
            return false;
        }

        static function xorgcore_delete_non_logged_in_cart( $refer, $user ){

          $abandoned_id = xorgcore_get_cart_session( 'xorgcore_abandoned_id' );

          if ( $abandoned_id != '' ) {
            xorgcore_DB_Layer::xorgcore_delete_abandoned_order( array( 'id' => $abandoned_id ) );

            xorgcore_unset_cart_session( 'xorgcore_abandoned_id' );
          }

          return $refer;
        }

        
        public static function xorgcore_add_banner() {

            if ( ! is_user_logged_in() ) {

                $display_msg = htmlspecialchars_decode( get_option('xorgcore_countdown_timer_msg', '') );
                
                $abandoned_id   = xorgcore_get_cart_session( 'xorgcore_abandoned_id' );
				$coupons_post_meta = get_post_meta( $abandoned_id, '_woocommerce_ac_coupon', true );

				if ( is_array( $coupons_post_meta ) && count ( $coupons_post_meta ) > 0 ) {
					foreach ( $coupons_post_meta as $k => $details ) {
						if ( isset( $details['atc_coupon_code'] ) && '' !== $details ) {
							$coupon_details = $details;
							break;
						}
					}
				}
                $display_dismissed = isset( $coupon_details['countdown_display_dismissed'] ) && $coupon_details['countdown_display_dismissed'] ? true : false;
                $coupon_removed = isset( $coupon_details['coupon_removed'] ) && $coupon_details['coupon_removed'] ? true : false;

                if( ! $display_dismissed && ! $coupon_removed ) {

                    $coupon_expiry  = isset( $coupon_details['time_expires'] ) && '' !== $coupon_details['time_expires'] ? $coupon_details['time_expires'] : '';
                    
                    $coupon_code        = isset( $coupon_details['atc_coupon_code'] ) ? $coupon_details['atc_coupon_code'] : '';
                    
                    if ( '' !== $coupon_code ) {
                            
                        if ( ( '' !== $coupon_expiry && $coupon_expiry > current_time( 'timestamp' ) ) || ( $coupon_expiry === '' && '' !== $coupon_code ) ) {    
                            if ( ! WC()->cart->has_discount( $coupon_code ) && count( WC()->cart->get_applied_coupons() ) == 0 ) {
                                WC()->cart->add_discount( $coupon_code );
                            }
                        } else if ( '' !== $coupon_expiry && $coupon_expiry < current_time( 'timestamp' ) ) { 
                            if( WC()->cart->has_discount( $coupon_code ) ) {
                                WC()->cart->remove_coupon( $coupon_code ); 
                            }   
                        }
                    }
                    
                    if ( '' !== $display_msg && '' !== $coupon_expiry ) {
                        if( $coupon_expiry > current_time( 'timestamp' ) ) {
                            if ( false !== strpos( $display_msg, '<coupon_code>' ) ) {
                                $coupon_name = $coupon_details['atc_coupon_code'];
                                $display_msg = str_ireplace( "<coupon_code>", $coupon_name, $display_msg );
                            }
                            if ( false !== strpos( $display_msg, '<hh:mm:ss>' ) ) {
                                $display_msg = str_ireplace( '<hh:mm:ss>', "<span id='xorgcore_timer'></span>", $display_msg );
                            }
                        } else {
                            $display_msg = get_option( 'xorgcore_countdown_msg_expired', 'The offer is no longer valid.' );
                        }
                        
                        $banner_content = "<div id='xorgcore_primary' class='woocommerce-info'><div id='xorgcore_float'>$display_msg<i class='fa fa-close' id='xorgcore_countdown_dismiss'></i></div></div>";
                        echo $banner_content;
                    }
                }
            }
            
        }

        
        public static function xorgcore_update_coupon_details( $coupon_code ) {

            
            if ( ! is_user_logged_in() ) {

                
                $abandoned_id   = xorgcore_get_cart_session( 'xorgcore_abandoned_id' );

                
                $coupons_meta   = get_post_meta( $abandoned_id, '_woocommerce_ac_coupon', true );
                $update_details = $coupons_meta;
                if ( is_array( $coupons_meta ) && count( $coupons_meta ) > 0 ) {
                    foreach ( $coupons_meta as $key => $coupon_details ) {
						$coupon_applied  = isset( $coupon_details['time_applied'] ) && '' !== $coupon_details['time_applied'] ? $coupon_details['time_applied'] : '';

						$atc_coupon_code = isset( $coupon_details['atc_coupon_code'] ) ? $coupon_details['atc_coupon_code'] : '';

						if ( '' !== $coupon_applied && $coupon_code === $atc_coupon_code ) {
							$update_details[$key]['coupon_removed'] = true;
							update_post_meta( $abandoned_id, '_woocommerce_ac_coupon', $update_details );
							break;
						}
					}
				}
            }
        }
    }
}
