<?php


if ( ! defined( 'ABSPATH' ) ) exit;

if ( !class_exists('xorgcore_Coupon' ) ) {
    
    class xorgcore_Coupon{

        
        public static function xorgcore_capture_applied_coupon( $valid ) {

            global $wpdb;

            $coupon_code = xorgcore_get_cart_session( 'xorgcore_c' );

            $user_id = xorgcore_get_cart_session( 'xorgcore_user_id' );

            $user_id = $user_id != '' ? $user_id : get_current_user_id();

            if ( $coupon_code == '' && isset( $_POST['coupon_code'] ) ){
                $coupon_code = $_POST['coupon_code'];
            } else if ( isset( $valid ) ){
                $coupon_code = $valid;
            }

            if ( $valid != '' ) {
                if ( is_user_logged_in()){

                    $abandoned_cart_id_query   = "SELECT id FROM `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` WHERE user_id = %d AND cart_ignored = '0' AND recovered_cart = '0'";
                    $abandoned_cart_id_results = $wpdb->get_results( $wpdb->prepare( $abandoned_cart_id_query, $user_id ) );
                }else if ( ! is_user_logged_in()){
                        $xorgcore_get_cookie_id        =  xorgcore_Common::xorgcore_get_guest_session_key();
                        $abandoned_cart_id_query   = "SELECT id FROM `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` WHERE user_id = %d AND cart_ignored = '0' AND recovered_cart = '0' ORDER BY id DESC LIMIT 1";
                        $abandoned_cart_id_results = $wpdb->get_results( $wpdb->prepare( $abandoned_cart_id_query, $user_id ) );
                }

                $abandoned_cart_id         = '0';
                if( isset( $abandoned_cart_id_results ) && !empty( $abandoned_cart_id_results ) ) {
                    $abandoned_cart_id = $abandoned_cart_id_results[0]->id;
                }
				$existing_coupon = ( get_user_meta( $user_id, '_woocommerce_ac_coupon', true ) );
				$applied = xorgcore_Common::xorgcore_update_coupon_post_meta( $abandoned_cart_id, $coupon_code );
				if ( $applied ) {
					return $valid;
				}
				if ( is_array( $existing_coupon ) && count( $existing_coupon ) > 0 ) {
					foreach ( $existing_coupon as $key => $value ) {
						if ( $existing_coupon[$key]['coupon_code'] != $coupon_code ) {
							$existing_coupon[]      = array ( 'coupon_code' => $coupon_code, 'coupon_message' => __( 'Discount code applied successfully.', 'xcart-tr' ) );
							update_user_meta( $user_id, '_woocommerce_ac_coupon', $existing_coupon );
							return $valid;
						}
					}
				} else {
					$coupon_details[]       = array ( 'coupon_code' => $coupon_code, 'coupon_message' => __( 'Discount code applied successfully.', 'xcart-tr' ) );
					update_user_meta( $user_id, '_woocommerce_ac_coupon', $coupon_details );
					return $valid;
				}
            }

            return $valid;
        }

        
        public static function xorgcore_capture_coupon_error( $valid, $new ) {

            global $wpdb;
            $coupon_code = xorgcore_get_cart_session( 'xorgcore_c' );

            $user_id = xorgcore_get_cart_session( 'xorgcore_user_id' );

            $user_id = $user_id != '' ? $user_id : get_current_user_id();

            $abandoned_cart_id_query   = "SELECT id FROM `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "` WHERE user_id = %d AND cart_ignored = '0' AND recovered_cart = '0' ORDER BY id DESC LIMIT 1";
            $abandoned_cart_id_results = $wpdb->get_results( $wpdb->prepare( $abandoned_cart_id_query, $user_id ) );
            $abandoned_cart_id         = '0';

            if( isset( $abandoned_cart_id_results ) && count( $abandoned_cart_id_results ) > 0 ) {
                $abandoned_cart_id = $abandoned_cart_id_results[0]->id;
            }
            
            if( $coupon_code == '' && isset( $_POST['coupon_code'] ) ) {
                $coupon_code = $_POST['coupon_code'];
            }

            if ( '' != $coupon_code ) {
                $existing_coupon        = get_user_meta( $user_id, '_woocommerce_ac_coupon', false );
                $existing_coupon[]      = array ( 'coupon_code' => $coupon_code, 'coupon_message' => $valid );
                $post_meta_coupon_array = array ( 'coupon_code' => $coupon_code, 'coupon_message' => $valid );
                if ( $user_id > 0 ) {
					$updated = xorgcore_Common::xorgcore_update_coupon_post_meta( $abandoned_cart_id, $coupon_code, $valid );
                }
                update_user_meta( $user_id, '_woocommerce_ac_coupon', $existing_coupon );
            }
            return $valid;
        }
        
        public static function xorgcore_apply_direct_coupon_code( $coupon_code ) {

            remove_action( 'woocommerce_cart_updated', array( 'xorgcore_Cart_Updated', 'xorgcore_store_cart_timestamp' ) );

            $xorgcore_language = xorgcore_get_cart_session( 'xorgcore_selected_language' );
            if ( $xorgcore_language != '' && function_exists( 'icl_register_string' ) ) {
                global $sitepress;
                if ( NULL !== $sitepress ) {
                    $sitepress->switch_lang( $xorgcore_language );
                }
            }

            $coupon_code = xorgcore_get_cart_session( 'xorgcore_c' );

            if ( $coupon_code != '' ) {
                global $woocommerce;

                
                if ( $woocommerce->cart->has_discount( sanitize_text_field( $coupon_code ) ) ) {
                    if ( !$woocommerce->cart->remove_coupons( sanitize_text_field( $coupon_code ) ) ) {
                        wc_print_notices( );
                    }
                }
                
                if ( !$woocommerce->cart->add_discount( sanitize_text_field( $coupon_code ) ) ) {
                    wc_print_notices( );
                } else {
                    wc_print_notices( );
                }
                
                $woocommerce->cart->calculate_totals();
                
                xorgcore_unset_cart_session( 'xorgcore_c' );
            }
       }
    }
}
