<?php

if (!defined('ABSPATH')) {
    exit; 
}

if ( !class_exists('xorgcore_On_Placed_Order' ) ) {
    
  class xorgcore_On_Placed_Order {
    
    public static function xorgcore_order_placed( $order_id ) {

        global $wpdb;
        $email_sent_id         = xorgcore_get_cart_session( 'xorgcore_email_sent_id' );
        $abandoned_order_id    = xorgcore_get_cart_session( 'xorgcore_abandoned_id' );
        $xorgcore_user_id_of_guest = xorgcore_get_cart_session( 'xorgcore_user_id' );

        
        $guest_turned_registered = false;
        if ( isset( $_POST['account_password'] ) && $_POST['account_password'] != '' ) { 
            $guest_turned_registered = true;
        } else if( isset( $_POST['createaccount'] ) && $_POST['createaccount'] != '' ) { 
            $guest_turned_registered = true;
        } else if( !isset( $_POST[ 'createaccount' ] ) && 'no' == get_option( 'woocommerce_enable_guest_checkout', 'no' ) ) { 
            $guest_turned_registered = true;
        }
        
        if( $email_sent_id != '' && $email_sent_id > 0 ) { 
        
            if( $abandoned_order_id == '' || $abandoned_order_id == false ) {
            
                $get_ac_id_query    = "SELECT abandoned_order_id FROM `" . xorgcore_EMAIL_SENT_HISTORY_TABLE ."` WHERE id = %d";
                $get_ac_id_results  = $wpdb->get_results( $wpdb->prepare( $get_ac_id_query, $email_sent_id ) );
            
                $abandoned_order_id = $get_ac_id_results[0]->abandoned_order_id;
            }

            add_post_meta( $order_id , 'xorgcore_recover_order_placed_sent_id', $email_sent_id );
            add_post_meta( $order_id , 'xorgcore_recover_order_placed', $abandoned_order_id );
            
        }

        if ( $abandoned_order_id != '' && $guest_turned_registered && $xorgcore_user_id_of_guest != '' ) {

            if( version_compare( WC()->version, '3.7.0', '>=' ) ) {
                $update_id = $wpdb->update(
                    xorgcore_ABANDONED_CART_HISTORY_TABLE,
                    array(
                        'user_id'   => get_current_user_id(),
                        'user_type' => 'REGISTERED',
                    ),
                    array( 'user_id' => $xorgcore_user_id_of_guest )
                );
            } else {
                $update_id = $wpdb->update(
                    xorgcore_ABANDONED_CART_HISTORY_TABLE,
                    array(
                        'user_id'   => get_current_user_id(),
                        'user_type' => 'REGISTERED',
                    ),
                    array( 'id' => $abandoned_order_id )
                );
            }

            $wpdb->delete( xorgcore_GUEST_CART_HISTORY_TABLE ,     array( 'id' => $xorgcore_user_id_of_guest ) );
    
        }

        add_post_meta( $order_id, 'xorgcore_abandoned_cart_id', $abandoned_order_id );
		$order        = new WC_Order( $order_id );
		$order_status = $order ? $order->get_status() : '';

		if ( 'pending' === $order_status ) {
			$wpdb->update(
				xorgcore_ABANDONED_CART_HISTORY_TABLE,
				array(
					'cart_ignored' => '2',
				),
				array(
					'id' => $abandoned_order_id,
				)
			);
		}
    }
    
    
    public static function xorgcore_cart_details_update( $order_id, $wc_old_status, $wc_new_status ) {
    
        if( 'pending' != $wc_new_status &&
            'failed' != $wc_new_status &&
            'cancelled' != $wc_new_status &&
            'trash' != $wc_new_status ) {
    
            global $wpdb;

            if( $order_id > 0 ) {
                $get_abandoned_id_of_order  = get_post_meta( $order_id, 'xorgcore_recover_order_placed', true );
                $abandoned_id               = $get_abandoned_id_of_order;

                if( $get_abandoned_id_of_order > 0 || xorgcore_get_cart_session( 'xorgcore_email_sent_id' ) != '' ) {
                    
                    $get_sent_email_id_of_order = get_post_meta( $order_id, 'xorgcore_recover_order_placed_sent_id', true );

                    
                    

                    $order = new WC_Order( $order_id );

                    $order_status = ( $order ) ? $order->get_status() : '';

                    if ( 'pending' !== $order_status &&
                        'failed' !== $order_status &&
                        'cancelled' !== $order_status &&
                        'trash' !== $order_status ) {

                        
                        if ( isset( $get_sent_email_id_of_order ) && '' != $get_sent_email_id_of_order ) {
                            xorgcore_common::xorgcore_updated_recovered_cart( $get_abandoned_id_of_order, $order_id, $get_sent_email_id_of_order, $order );
                        }
                    }
                } else {

                    $xorgcore_abandoned_id = get_post_meta( $order_id, 'xorgcore_abandoned_cart_id', true );
                    $abandoned_id      = $xorgcore_abandoned_id;

                    
                    $query_cart_data = "SELECT user_id, user_type FROM `" . xorgcore_ABANDONED_CART_HISTORY_TABLE . "`
                                        WHERE id = %d";
                    $get_cart_data = $wpdb->get_results( $wpdb->prepare( $query_cart_data, $xorgcore_abandoned_id ) );

                    if( is_array( $get_cart_data ) && count( $get_cart_data ) > 0 ) {
                        $user_type = $get_cart_data[0]->user_type;
                        $user_id = $get_cart_data[0]->user_id;

                        if( 'GUEST' === $user_type && $user_id >= 63000000 ) {
                            $wpdb->delete( xorgcore_GUEST_CART_HISTORY_TABLE, array( 'id' => $user_id ) );
                            $wpdb->delete( xorgcore_ABANDONED_CART_HISTORY_TABLE, array( 'user_id' => $user_id ) );
                        }
                    }
                    $wpdb->delete( xorgcore_ABANDONED_CART_HISTORY_TABLE, array( 'id' => $xorgcore_abandoned_id ) );

                    
                    xorgcore_Common::xorgcore_delete_cart_notification( $xorgcore_abandoned_id );
                }

                
                if ( $order_id > 0 && $abandoned_id > 0 ) {
					$coupons_meta = get_post_meta( $abandoned_id, '_woocommerce_ac_coupon', true );

					if ( is_array( $coupons_meta ) && count( $coupons_meta ) > 0 ) {
						foreach ( $coupons_meta as $key => $coupon_details ) {

							$details_added = isset( $coupon_details['order_atc_details_added'] ) && $coupon_details['order_atc_details_added'] ? true : false;

							if ( is_array( $coupon_details ) && isset( $coupon_details['atc_coupon_code'] ) && '' !== $coupon_details['atc_coupon_code'] && ! $details_added ) {
								$coupon_code = $coupon_details['atc_coupon_code']; 
								$order = wc_get_order( $order_id ); 

								
								update_post_meta( $order_id, 'xorgcore_atc_coupon', $coupon_code );
								$order->add_order_note( "ATC Coupon $coupon_code was used.", 'xcart-tr' );
								$coupons_meta[$key]['order_atc_details_added'] = true;
								update_post_meta( $abandoned_id, '_woocommerce_ac_coupon', $coupons_meta );
							}
						}
					}
                }
            }
        }

    }

    
    public static function xorgcore_order_complete_action( $woo_order_status, $order_id ) {

        $order = new WC_Order( $order_id );

        $get_abandoned_id_of_order  = get_post_meta( $order_id, 'xorgcore_recover_order_placed', true );
        $get_sent_email_id_of_order = get_post_meta( $order_id, 'xorgcore_recover_order_placed_sent_id', true );

        
        
        
        $order_status = ( $order ) ? $order->get_status() : '';

        if ( 'pending' !== $order_status &&
             'failed' !== $order_status &&
             'cancelled' !== $order_status &&
             'trash' !== $order_status ) {

            
            if ( isset( $get_sent_email_id_of_order ) && '' != $get_sent_email_id_of_order ) {
                xorgcore_common::xorgcore_updated_recovered_cart( $get_abandoned_id_of_order, $order_id, $get_sent_email_id_of_order, $order );
            }
        }

        return $woo_order_status;
    }
    
    
    static function xorgcore_update_cart_status( $created_via, $order ) {
        global $wpdb;
    
        $order_id = ( $order ) ? $order->get_id() : 0;
    
        if( isset( $order_id ) && $order_id > 0 ) {
            $abandoned_id  = get_post_meta( $order_id, 'xorgcore_abandoned_cart_id', true );
    
            if( isset( $abandoned_id ) && $abandoned_id > 0 ) {
                $update_data = array( 'cart_ignored' => '2' );
    
                $wpdb->update( xorgcore_ABANDONED_CART_HISTORY_TABLE, $update_data, array( 'id' => $abandoned_id ) );
            }
        }
        return $created_via;
    }
  }
}