<?php


if ( ! defined( 'ABSPATH' ) ) {
	exit; 
}

if ( ! class_exists( 'xorgcore_Load_Scripts' ) ) {
	
	class xorgcore_Load_Scripts {
		
		public static function xorgcore_enqueue_scripts_js( $hook ) {
			global $pagenow, $woocommerce;

			$suffix = defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ? '' : '.min';

			$xorgcore_is_import_page_displayed = get_option( 'xorgcore_import_page_displayed' );
			$xorgcore_is_lite_data_imported    = get_option( 'xorgcore_lite_data_imported' );

			$page = isset( $_GET['page'] ) ? $_GET['page'] : '';

			if ( 'yes' === $xorgcore_is_import_page_displayed && false === $xorgcore_is_lite_data_imported ) {
				if ( 'plugins.php' == $hook ) {
					wp_enqueue_script( 'xorgcore_import_lite_data', xorgcore_PLUGIN_URL . '/assets/js/admin/import_lite_data.js' );
				}
			}
			
			if ( 'dashboard_page_xorgcore-update' == $hook ) {
				wp_enqueue_script( 'xorgcore_import_lite_data', xorgcore_PLUGIN_URL . '/assets/js/admin/import_lite_data.js' );
			}

			if ( 'index.php' === $pagenow ) {
				wp_enqueue_script( 'xorgcore_dashboard_widget', xorgcore_PLUGIN_URL . '/assets/js/admin/dashboard_widget' . $suffix . '.js' );
			}
			if ( $page === '' || $page !== 'xcart' ) {
				return;
			} else {
				wp_enqueue_script( 'jquery' );
				wp_enqueue_script(
					'jquery-ui-min',
					xorgcore_PLUGIN_URL . '/assets/js/jquery-ui.min.js',
					'',
					'',
					false
				);
				
				wp_register_script( 'woocommerce_admin', plugins_url() . '/woocommerce/assets/js/admin/woocommerce_admin.js', array( 'jquery', 'jquery-ui-widget', 'jquery-ui-core' ) );
				wp_register_script( 'jquery-ui-datepicker', plugins_url() . '/woocommerce/assets/js/admin/ui-datepicker.js' );

				wp_register_script( 'enhanced', plugins_url() . '/woocommerce/assets/js/admin/wc-enhanced-select.js', array( 'jquery', 'select2' ) );
				wp_enqueue_script( 'accounting' );
				wp_enqueue_script( 'woocommerce_metaboxes' );
				wp_enqueue_script( 'jquery-ui-datepicker' );

				wp_register_script( 'flot', xorgcore_PLUGIN_URL . '/assets/js/jquery-flot/jquery.flot.min.js', array( 'jquery' ) );
				wp_register_script( 'flot-resize', xorgcore_PLUGIN_URL . '/assets/js/jquery-flot/jquery.flot.resize.min.js', array( 'jquery', 'flot' ) );
				wp_register_script( 'flot-time', xorgcore_PLUGIN_URL . '/assets/js/jquery-flot/jquery.flot.time.min.js', array( 'jquery', 'flot' ) );
				wp_register_script( 'flot-pie', xorgcore_PLUGIN_URL . '/assets/js/jquery-flot/jquery.flot.pie.min.js', array( 'jquery', 'flot' ) );
				wp_register_script( 'flot-stack', xorgcore_PLUGIN_URL . '/assets/js/jquery-flot/jquery.flot.stack.min.js', array( 'jquery', 'flot' ) );
				wp_register_script( 'xorgcore-dashboard-report', xorgcore_PLUGIN_URL . '/assets/js/admin/reports.min.js', array( 'jquery' ) );
				wp_enqueue_script( 'flot' );
				wp_enqueue_script( 'flot-resize' );
				wp_enqueue_script( 'flot-time' );
				wp_enqueue_script( 'flot-pie' );
				wp_enqueue_script( 'flot-stack' );
				wp_enqueue_script( 'xorgcore-dashboard-report' );

				wp_enqueue_script(
					'bootstrap_js',
					xorgcore_PLUGIN_URL . '/assets/js/admin/bootstrap.min.js',
					'',
					'',
					false
				);

				wp_enqueue_script(
					'd3_js',
					xorgcore_PLUGIN_URL . '/assets/js/admin/d3.v3.min.js',
					'',
					'',
					false
				);

				wp_register_script(
					'xorgcore_graph_js',
					xorgcore_PLUGIN_URL . '/assets/js/admin/adv_dashboard' . $suffix . '.js',
					'',
					'',
					true
				);
				
				wp_localize_script(
					'enhanced',
					'wc_enhanced_select_params',
					array(
						'i18n_matches_1'            => _x( 'One result is available, press enter to select it.', 'enhanced select', 'woocommerce' ),
						'i18n_matches_n'            => _x( '%qty% results are available, use up and down arrow keys to navigate.', 'enhanced select', 'woocommerce' ),
						'i18n_no_matches'           => _x( 'No matches found', 'enhanced select', 'woocommerce' ),
						'i18n_ajax_error'           => _x( 'Loading failed', 'enhanced select', 'woocommerce' ),
						'i18n_input_too_short_1'    => _x( 'Please enter 1 or more characters', 'enhanced select', 'woocommerce' ),
						'i18n_input_too_short_n'    => _x( 'Please enter %qty% or more characters', 'enhanced select', 'woocommerce' ),
						'i18n_input_too_long_1'     => _x( 'Please delete 1 character', 'enhanced select', 'woocommerce' ),
						'i18n_input_too_long_n'     => _x( 'Please delete %qty% characters', 'enhanced select', 'woocommerce' ),
						'i18n_selection_too_long_1' => _x( 'You can only select 1 item', 'enhanced select', 'woocommerce' ),
						'i18n_selection_too_long_n' => _x( 'You can only select %qty% items', 'enhanced select', 'woocommerce' ),
						'i18n_load_more'            => _x( 'Loading more results&hellip;', 'enhanced select', 'woocommerce' ),
						'i18n_searching'            => _x( 'Searching&hellip;', 'enhanced select', 'woocommerce' ),
						'ajax_url'                  => xorgcore_ADMIN_AJAX_URL,
						'search_products_nonce'     => wp_create_nonce( 'search-products' ),
						'search_customers_nonce'    => wp_create_nonce( 'search-customers' ),
					)
				);

				$wc_round_value       = wc_get_price_decimals();
				$wc_currency_position = get_option( 'woocommerce_currency_pos' );

				wp_localize_script(
					'xorgcore-dashboard-report',
					'xorgcore_dashboard_report_params',
					array(
						'currency_symbol'              => get_woocommerce_currency_symbol(),
						'wc_round_value'               => $wc_round_value,
						'wc_currency_position'         => $wc_currency_position,
						'currency_format_decimal_sep'  => esc_attr( wc_get_price_decimal_separator() ),
						'currency_format_thousand_sep' => esc_attr( wc_get_price_thousand_separator() ),
						'currency_format'              => esc_attr( str_replace( array( '%1$s', '%2$s' ), array( '%s', '%v' ), get_woocommerce_price_format() ) ),
					)
				);

				wp_enqueue_script( 'enhanced' );
				wp_enqueue_script( 'woocommerce_admin' );
				wp_enqueue_script( 'jquery-ui-sortable' );

				$woocommerce_admin_meta_boxes = array(
					'search_products_nonce' => wp_create_nonce( 'search-products' ),
					'plugin_url'            => plugins_url(),
					'ajax_url'              => xorgcore_ADMIN_AJAX_URL,
				);
				wp_localize_script( 'woocommerce_metaboxes', 'woocommerce_admin_meta_boxes', $woocommerce_admin_meta_boxes );
				wp_dequeue_script( 'wc-enhanced-select' );

				if ( version_compare( $woocommerce->version, '3.2.0', '>=' ) ) {

					wp_register_script( 'selectWoo', plugins_url() . '/woocommerce/assets/js/selectWoo/selectWoo.full.min.js', array( 'jquery' ) );
					wp_enqueue_script( 'selectWoo' );
				}

				wp_register_script( 'woocommerce_admin', plugins_url() . '/woocommerce/assets/js/admin/woocommerce_admin.min.js', array( 'jquery', 'jquery-tiptip' ), '', true );
				wp_register_script( 'woocommerce_tip_tap', plugins_url() . '/woocommerce/assets/js/jquery-tiptip/jquery.tipTip.min.js', array( 'jquery' ), '', true );
				wp_enqueue_script( 'woocommerce_tip_tap' );
				wp_enqueue_script( 'woocommerce_admin' );

				wp_register_script( 'select2', plugins_url() . '/woocommerce/assets/js/select2/select2.min.js', array( 'jquery', 'jquery-ui-widget', 'jquery-ui-core' ) );
				wp_enqueue_script( 'select2' );

				$js_src = includes_url( 'js/tinymce/' ) . 'tinymce.min.js';
				wp_enqueue_script( 'tinyMCE_ac', $js_src );
				

				$action = $action_down = '';
				if ( isset( $_GET['action'] ) ) {
					$action = $_GET['action'];
				}

				if ( isset( $_GET['action2'] ) ) {
					$action_down = $_GET['action2'];
				}

				if ( '-1' == $action && isset( $_GET['xorgcore_action'] ) ) {
					$action = $_GET['xorgcore_action'];
				}
				$section = ( isset( $_GET['section'] ) ) ? $_GET['section'] : '';
				if ( 'emailsettings' == $action ) {
					wp_enqueue_script( 'xorgcore_guest_setting', xorgcore_PLUGIN_URL . '/assets/js/admin/guest_settings' . $suffix . '.js' );
					wp_enqueue_style( 'wp-color-picker' );
					wp_enqueue_script( 'iris' );
					wp_enqueue_script( 'xorgcore_vue_js', xorgcore_PLUGIN_URL . '/assets/js/vue.min.js' );

					
					wp_enqueue_script( 'xorgcore_enable_atc_modal', xorgcore_PLUGIN_URL . '/assets/js/admin/enable_atc_modal' . $suffix . '.js' );
					wp_enqueue_script( 'xorgcore_mandatory_email_field', xorgcore_PLUGIN_URL . '/assets/js/admin/mandatory_atc_email' . $suffix . '.js' );
					wp_enqueue_script( 'xorgcore_atc_reset_field', xorgcore_PLUGIN_URL . '/assets/js/admin/atc_reset_setting' . $suffix . '.js' );
				}

				
				$xorgcore_section = isset( $_GET['xorgcore_section'] ) ? $_GET['xorgcore_section'] : '';
				if ( 'emailsettings' == $action && 'xorgcore_sms_settings' == $xorgcore_section ) {
					wp_register_script( 'xorgcore_sms_settings', xorgcore_PLUGIN_URL . '/assets/js/admin/sms_settings.js' );
					wp_localize_script(
						'xorgcore_sms_settings',
						'xorgcore_advance',
						array(
							'ajax_url' => xorgcore_ADMIN_AJAX_URL,
						)
					);
					wp_enqueue_script( 'xorgcore_sms_settings' );

				}
				if ( 'cart_recovery' == $action || 'emailtemplates' == $section || 'emailtemplates&mode=xorgcore_manual_email' == $action || 'emailtemplates&mode=xorgcore_manual_email' == $action_down ) {

					wp_enqueue_script(
						'xorgcore_vue_js',
						xorgcore_PLUGIN_URL . '/assets/js/vue.min.js',
						'',
						'',
						false
					);
					wp_enqueue_script(
						'xorgcore_resource_js',
						xorgcore_PLUGIN_URL . '/assets/js/admin/vue_resource.min.js',
						'',
						'',
						false
					);
					wp_enqueue_script(
						'popper_js',
						xorgcore_PLUGIN_URL . '/assets/js/admin/popper.min.js',
						'',
						'',
						false
					);
					wp_enqueue_script(
						'bootstrap_js',
						xorgcore_PLUGIN_URL . '/assets/js/admin/bootstrap.min.js',
						'',
						'',
						false
					);

					wp_enqueue_script( 'xorgcore_template_preview', xorgcore_PLUGIN_URL . '/assets/js/admin/template_preview.js', '', '', true );

					$template_localized_params = self::xorgcore_template_params();
					wp_localize_script(
						'xorgcore_template_preview',
						'xorgcore_template_params',
						$template_localized_params
					);

					$recovery_section = ( isset( $_GET['section'] ) ) ? $_GET['section'] : 'emailtemplates';
					wp_enqueue_script( 'xorgcore_template_activate', xorgcore_PLUGIN_URL . '/assets/js/admin/template_activate' . $suffix . '.js' );
					wp_localize_script(
						'xorgcore_template_activate',
						'xorgcore_activate_params',
						array( 'template_type' => $recovery_section )
					);

					wp_enqueue_script( 'ac_email_variables', xorgcore_PLUGIN_URL . '/assets/js/admin/xcart' . $suffix . '.js' );
					wp_enqueue_script( 'ac_email_button_css', xorgcore_PLUGIN_URL . '/assets/js/admin/xcart_css' . $suffix . '.js' );

					wp_enqueue_script( 'xorgcore_maual_email', xorgcore_PLUGIN_URL . '/assets/js/admin/manual_email' . $suffix . '.js' );
					wp_enqueue_script( 'xorgcore_preview_email', xorgcore_PLUGIN_URL . '/assets/js/admin/preview_email' . $suffix . '.js' );

					wp_localize_script(
						'xorgcore_preview_email',
						'xorgcore_preview_email_params',
						array(
							'xorgcore_email_sent_image_path' => xorgcore_PLUGIN_URL . '/assets/images/xorgcore_email_sent.svg',
						)
					);
					wp_enqueue_script( 'xorgcore_template_for_customer_email', xorgcore_PLUGIN_URL . '/assets/js/admin/template_for_customer_email' . $suffix . '.js' );

					$wc_payment_gateways = new WC_Payment_Gateways();
					$payment_gateways    = $wc_payment_gateways->payment_gateways();
					$available_gateways  = array();
					foreach ( $payment_gateways as $slug => $gateways ) {
						if ( 'yes' === $gateways->enabled ) {
							$available_gateways[ $slug ] = $gateways->title;
						}
					}
					wp_localize_script(
						'xorgcore_template_for_customer_email',
						'xorgcore_email_params',
						array(
							'xorgcore_order_status' => array(
								'abandoned' => __( 'Abandoned', 'xcart-tr' ),
								'abandoned-pending' => __( 'Abandoned - Pending Payment', 'xcart-tr' ),
								'abandoned-cancelled' => __( 'Abandoned - Order Cancelled', 'xcart-tr' ),
							),
							'xorgcore_send_to' => array(
								'all' => __( 'All', 'xcart-tr' ),
								'registered_users' => __( 'Registered Users', 'xcart-tr' ),
								'guest_users' => __( 'Guest Users', 'xcart-tr' ),
								'xorgcore_email_customer' => __( 'Customers', 'xcart-tr' ),
								'xorgcore_email_admin'    => __( 'Admin', 'xcart-tr' ),
								'xorgcore_email_customer_admin' => __( 'Customers & Admin', 'xcart-tr' ),
								'email_addresses' => __( 'Email Addresses', 'xcart-tr' ),
							),
							'xorgcore_payment_gateways' => $available_gateways,
							'xorgcore_cond_includes' => array(
								'includes' => __( 'Includes any of', 'xcart-tr' ),
								'excludes' => __( 'Excludes any of', 'xcart-tr' ),
							),
							'xorgcore_counts' => array(
								'greater_than_equal_to' => __( 'Greater than or equal to', 'xcart-tr' ),
								'equal_to'              => __( 'Equal to', 'xcart-tr' ),
								'less_than_equal_to'    => __( 'Less than or equal to', 'xcart-tr' ),
							),
							'xorgcore_send_to_select'  => __( 'Search for options&hellip;', 'xcart-tr' ),
							'xorgcore_product_select'  => __( 'Search for a Product&hellip;', 'xcart-tr' ),
							'xorgcore_coupon_select'   => __( 'Search for a Coupon&hellip;', 'xcart-tr'),
							'xorgcore_prod_cat_select' => __( 'Search for a Product Category&hellip;', 'xcart-tr' ),
							'xorgcore_prod_tag_select' => __( 'Search for a Product Tag&hellip;', 'xcart-tr' ),
							'xorgcore_status_select'   => __( 'Search for a Cart Status&hellip;', 'xcart-tr' ),
						)
					);
					wp_register_script( 'woocommerce_admin', plugins_url() . '/woocommerce/assets/js/admin/woocommerce_admin.min.js', array( 'jquery', 'jquery-tiptip' ) );
					wp_register_script( 'woocommerce_tip_tap', plugins_url() . '/woocommerce/assets/js/jquery-tiptip/jquery.tipTip.min.js', array( 'jquery' ) );
					wp_enqueue_script( 'woocommerce_tip_tap' );
					wp_enqueue_script( 'woocommerce_admin' );

					$locale  = localeconv();
					$decimal = isset( $locale['decimal_point'] ) ? $locale['decimal_point'] : '.';
					$params  = array(
						
						'i18n_decimal_error'               => sprintf( __( 'Please enter in decimal (%s) format without thousand separators.', 'woocommerce' ), $decimal ),
						
						'i18n_mon_decimal_error'           => sprintf( __( 'Please enter in monetary decimal (%s) format without thousand separators and currency symbols.', 'woocommerce' ), wc_get_price_decimal_separator() ),
						'i18n_country_iso_error'           => __( 'Please enter in country code with two capital letters.', 'woocommerce' ),
						'i18_sale_less_than_regular_error' => __( 'Please enter in a value less than the regular price.', 'woocommerce' ),
						'decimal_point'                    => $decimal,
						'mon_decimal_point'                => wc_get_price_decimal_separator(),
						'strings'                          => array(
							'import_products' => __( 'Import', 'woocommerce' ),
							'export_products' => __( 'Export', 'woocommerce' ),
						),
						'urls'                             => array(
							'import_products' => esc_url_raw( admin_url( 'edit.php?post_type=product&page=product_importer' ) ),
							'export_products' => esc_url_raw( admin_url( 'edit.php?post_type=product&page=product_exporter' ) ),
						),
					);
					
					wp_localize_script( 'woocommerce_admin', 'woocommerce_admin', $params );
				}

				if ( 'cart_recovery' == $action && 'sms' == $section ) {

					wp_register_script( 'xorgcore_sms_list', xorgcore_PLUGIN_URL . '/assets/js/admin/sms_template_list' . $suffix . '.js' );
					wp_localize_script(
						'xorgcore_sms_list',
						'xorgcore_sms_params',
						array(
							'ajax_url' => xorgcore_ADMIN_AJAX_URL,
						)
					);
					wp_enqueue_script( 'xorgcore_sms_list' );
				}

				if ( 'listcart' == $action || 'emailstats' == $action ) {
					wp_enqueue_script( 'xorgcore_bulk_action', xorgcore_PLUGIN_URL . '/assets/js/admin/xcart_action' . $suffix . '.js' );
					wp_enqueue_script( 'xorgcore_abandoned_cart_details', xorgcore_PLUGIN_URL . '/assets/js/admin/xcart_modal' . $suffix . '.js' );
				}

				if ( 'stats' == $action || 'emailstats' == $action || 'listcart' == $action || 'cart_recovery' === $action ) {
					wp_enqueue_script( 'xorgcore_date_filter', xorgcore_PLUGIN_URL . '/assets/js/admin/date_select_filter' . $suffix . '.js' );
				}

				if ( isset( $_GET['page'] ) && $_GET['page'] == 'xcart' && 'cart_recovery' == $action && 'emailtemplates' == $section ) {
					wp_enqueue_script( 'xorgcore_test_email', xorgcore_PLUGIN_URL . '/assets/js/admin/test_email' . $suffix . '.js' );

					wp_localize_script(
						'xorgcore_test_email',
						'xorgcore_test_email_params',
						array(
							'xorgcore_test_email_sent_image_path'  => xorgcore_PLUGIN_URL . '/assets/images/check.jpg',
						)
					);
				}

				wp_enqueue_script( 'xorgcore_dismiss_notice', xorgcore_PLUGIN_URL . '/assets/js/admin/admin_notices.js' );
				wp_localize_script(
					'xorgcore_dismiss_notice',
					'xorgcore_dismiss_params',
					array(
						'ajax_url' => xorgcore_ADMIN_AJAX_URL,
					)
				);
			}
		}

		
		public static function xorgcore_include_js_for_guest() {

			$suffix = defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ? '' : '.min';

			$guest_cart = get_option( 'ac_disable_guest_cart_email' );

			
			$load_cart      = 'on' === get_option( 'xorgcore_countdown_cart', '' ) ? true : false;
			$cart_condition = $load_cart ? 'is_cart()' : '';

			if ( ( $cart_condition || is_checkout() ) && $guest_cart != 'on' && ! is_user_logged_in() ) {
				wp_enqueue_script( 'xorgcore_capture_guest_user', xorgcore_PLUGIN_URL . '/assets/js/frontend/guest_user' . $suffix . '.js' );
				$guest_msg = get_option( 'xorgcore_guest_cart_capture_msg' );

				$session_gdpr = xorgcore_get_cart_session( 'xorgcore_cart_tracking_refused' );
				$show_gdpr    = isset( $session_gdpr ) && 'yes' == $session_gdpr ? false : true;

				$vars = array();
				if ( isset( $guest_msg ) && '' != $guest_msg ) {
					$vars = array(
						'_show_gdpr_message'        => $show_gdpr,
						'_gdpr_message'             => htmlspecialchars( get_option( 'xorgcore_guest_cart_capture_msg' ), ENT_QUOTES ),
						'_gdpr_nothanks_msg'        => htmlspecialchars( get_option( 'xorgcore_gdpr_allow_opt_out' ), ENT_QUOTES ),
						'_gdpr_after_no_thanks_msg' => htmlspecialchars( get_option( 'xorgcore_gdpr_opt_out_message' ), ENT_QUOTES ),
						'enable_ca_tracking'        => true,
					);
				}

				$vars['ajax_url'] = xorgcore_ADMIN_AJAX_URL;

				wp_localize_script( 'xorgcore_capture_guest_user', 'xorgcore_capture_guest_user_params', $vars );
			}
		}

		public static function xorgcore_include_js_atc_coupon() {

			$suffix = defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ? '' : '.min';

			$guest_cart = get_option( 'ac_disable_guest_cart_email' );

			
			$load_cart      = 'on' === get_option( 'xorgcore_countdown_cart', '' ) ? true : false;
			$cart_condition = $load_cart ? 'is_cart()' : '';

			if ( ( $cart_condition || is_checkout() ) && $guest_cart != 'on' && ! is_user_logged_in() ) {
				wp_enqueue_script( 'xorgcore_atc_coupon_countdown', xorgcore_PLUGIN_URL . '/assets/js/frontend/atc_coupon_countdown' . $suffix . '.js' );

				$vars = array();

				$vars['ajax_url'] = xorgcore_ADMIN_AJAX_URL;

				
				$atc_coupon_applied        = 'on' === get_option( 'xorgcore_atc_auto_apply_coupon_enabled', '' ) ? true : false;
				$vars['_xorgcore_coupons_atc'] = $atc_coupon_applied;

				
				if ( 'on' === get_option( 'xorgcore_atc_auto_apply_coupon_enabled', '' ) && '' !== get_option( 'xorgcore_countdown_timer_msg', 'Coupon <coupon_code> expires in <hh:mm:ss>. Avail it now.' ) && 0 < get_option( 'xorgcore_atc_popup_coupon_validity', 0 ) ) {
					$coupon_expiry = '';
					$abandoned_id = xorgcore_get_cart_session( 'xorgcore_abandoned_id' );
					$coupons_meta = get_post_meta( $abandoned_id, '_woocommerce_ac_coupon', true );
					if ( is_array( $coupons_meta ) && count( $coupons_meta ) > 0 ) {
						foreach ( $coupons_meta as $key => $coupon_details ) {
							if ( isset( $coupon_details['time_expires'] ) ) {
								$coupon_expiry = $coupon_details['time_expires'];
								break;
							}
						}
					}
					if ( '' !== $coupon_expiry ) {
						$coupon_expiry_date = date( 'Y-m-d, H:i:s', $coupon_expiry );
						$display_msg        = get_option( 'xorgcore_countdown_timer_msg', 'Coupon <coupon_code> expires in <hh:mm:ss>. Avail it now.' );

						$vars['_xorgcore_coupon_msg']     = __( $display_msg, 'xcart-tr' );
						$vars['_xorgcore_coupon_expires'] = $coupon_expiry_date;
						$vars['_xorgcore_expiry_msg']     = __( get_option( 'xorgcore_countdown_msg_expired', 'The offer is no longer valid.' ), 'xcart-tr' );
						$vars['_xorgcore_server_offset']  = get_option( 'gmt_offset' ) * HOUR_IN_SECONDS;
					}
				}
				wp_localize_script( 'xorgcore_atc_coupon_countdown', 'xorgcore_atc_coupon_countdown_params', $vars );
			}
		}
		
		public static function xorgcore_dequeue_scripts_atc_modal() {

			$suffix = defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ? '' : '.min';

			wp_dequeue_script( 'wc-add-to-cart' );

			wp_register_script(
				'wc-add-to-cart',
				xorgcore_PLUGIN_URL . '/assets/js/frontend/atc_modal' . $suffix . '.js',
				'',
				'',
				true
			);
			wp_enqueue_script( 'wc-add-to-cart' );
		}

		
		public static function xorgcore_enqueue_scripts_atc_modal() {

			$suffix = defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ? '' : '.min';

			if ( xorgcore_get_cart_session( 'xorgcore_populate_email' ) != '' && 'on' != get_option( 'xorgcore_atc_enable_modal' ) ) {
				$xorgcore_get_url_email_address = xorgcore_get_cart_session( 'xorgcore_populate_email' );
				$xorgcore_is_atc_enabled        = get_option( 'xorgcore_atc_enable_modal' );

				wp_enqueue_script( 'jquery' );
				wp_enqueue_script(
					'jquery-ui-min',
					xorgcore_PLUGIN_URL . '/assets/js/jquery-ui.min.js',
					'',
					'',
					false
				);
				wp_register_script( 'xorgcore-capture-url-email', xorgcore_PLUGIN_URL . '/assets/js/frontend/capture_url_email' . $suffix . '.js' );
				wp_enqueue_script( 'xorgcore-capture-url-email' );
				wp_localize_script(
					'xorgcore-capture-url-email',
					'xorgcore_capture_url_email_param',
					array(
						'xorgcore_ajax_add'       => get_option( 'woocommerce_enable_ajax_add_to_cart' ),
						'xorgcore_populate_email' => $xorgcore_get_url_email_address,
						'xorgcore_ajax_url'       => xorgcore_ADMIN_URL,
						'wc_ajax_url'         => WC_AJAX::get_endpoint( '%%endpoint%%' ),
						'xorgcore_is_atc_enabled' => $xorgcore_is_atc_enabled,
					)
				);
			}

			if ( 'on' === get_option( 'xorgcore_atc_enable_modal' ) && xorgcore_get_cart_session( 'xorgcore_email_sent_id' ) == '' ) {
				global $post;

				if ( ! is_user_logged_in() ) {
					$xorgcore_atc_modal = '';
					if ( ! is_cart() && ! is_checkout() ) {
						ob_start();
						include xorgcore_PLUGIN_PATH . '/includes/add_to_cart.php';
						$xorgcore_atc_modal = ob_get_clean();
						wp_enqueue_script(
							'xorgcore_vue_js',
							xorgcore_PLUGIN_URL . '/assets/js/vue.min.js',
							'',
							'',
							true
						);
					}

					$xorgcore_atc_modal = apply_filters( 'xorgcore_add_custom_atc_template', $xorgcore_atc_modal );

					$page_id      = get_the_ID();
					$custom_pages = is_array( get_option( 'xorgcore_custom_pages_list' ) ) && count( get_option( 'xorgcore_custom_pages_list' ) ) > 0 ? get_option( 'xorgcore_custom_pages_list' ) : array();

					if ( ( is_shop() || is_home() || is_product_category() || is_front_page() || ( function_exists( 'is_demo' ) && is_demo() ) || in_array( $page_id, $custom_pages ) ) &&
					apply_filters( 'xorgcore_enable_pages_popup_modal', true ) ) {
						wp_dequeue_script( 'wc-add-to-cart' );
						wp_deregister_script( 'wc-add-to-cart' );
						wp_enqueue_script( 'jquery' );
						wp_enqueue_script(
							'jquery-ui-min',
							xorgcore_PLUGIN_URL . '/assets/js/jquery-ui.min.js',
							'',
							'',
							false
						);
						wp_register_script( 'wc-add-to-cart', xorgcore_PLUGIN_URL . '/assets/js/frontend/atc_modal' . $suffix . '.js', '', '', true );
						wp_enqueue_script( 'wc-add-to-cart' );

						wp_localize_script(
							'wc-add-to-cart',
							'xorgcore_atc_modal_param',
							self::xorgcore_atc_localize_params( $xorgcore_atc_modal )
						);
					}
					$xorgcore_populate_email_address = null !== xorgcore_get_cart_session( 'xorgcore_populate_email' ) && '' != xorgcore_get_cart_session( 'xorgcore_populate_email' ) ? xorgcore_get_cart_session( 'xorgcore_populate_email' ) : '';
					if ( is_product() || ( function_exists( 'is_producto' ) && is_producto() ) ) {
						$xorgcore_product = wc_get_product( $post->ID );

						if ( $xorgcore_product->is_type( 'simple' ) || $xorgcore_product->is_type( 'course' ) || $xorgcore_product->is_type( 'subscription' ) || $xorgcore_product->is_type( 'composite' ) || $xorgcore_product->is_type( 'booking' ) || $xorgcore_product->is_type( 'appointment' ) || $xorgcore_product->is_type( 'bundle' ) ) {
							wp_dequeue_script( 'astra-single-product-ajax-cart' );
							wp_dequeue_script( 'wc-add-to-cart' );
							wp_deregister_script( 'wc-add-to-cart' );
							wp_enqueue_script( 'jquery' );
							wp_register_script( 'xorgcore_atc_single_simple_product', xorgcore_PLUGIN_URL . '/assets/js/frontend/atc_simple_single_page' . $suffix . '.js' );
							wp_enqueue_script( 'xorgcore_atc_single_simple_product' );

							wp_localize_script(
								'xorgcore_atc_single_simple_product',
								'xorgcore_atc_modal_param',
								self::xorgcore_atc_localize_params( $xorgcore_atc_modal )
							);
						} elseif ( $xorgcore_product->is_type( 'variable' ) || $xorgcore_product->is_type( 'variable-subscription' ) ) {
							wp_dequeue_script( 'wc-add-to-cart' );
							wp_deregister_script( 'wc-add-to-cart' );
							
							if ( 'entrada' == get_option( 'template' ) ) {
								wp_register_script( 'xorgcore_entrada_atc_variable_page', xorgcore_PLUGIN_URL . '/assets/js/themes/entrada_atc_variable_page' . $suffix . '.js', array( 'jquery', 'wp-util' ) );
								wp_enqueue_script( 'xorgcore_entrada_atc_variable_page' );

								wp_localize_script(
									'xorgcore_entrada_atc_variable_page',
									'xorgcore_atc_modal_param',
									self::xorgcore_atc_localize_params( $xorgcore_atc_modal )
								);
							} elseif ( is_plugin_active( 'woo-variations-table-grid/woo-variations-table.php' ) && ! get_option( 'vartable_disabled' ) &&
								( get_post_meta( $xorgcore_product->get_id(), 'disable_variations_table', true ) == '' || get_post_meta( $xorgcore_product->get_id(), 'disable_variations_table', true ) != 1 ) ) {

								wp_dequeue_script( 'wc-add-to-cart-variation' );
								wp_deregister_script( 'wc-add-to-cart-variation' );

								wp_register_script( 'wc-add-to-cart-variation', xorgcore_PLUGIN_URL . '/assets/js/frontend/atc_modal' . $suffix . '.js', '', '', true );
								wp_enqueue_script( 'wc-add-to-cart-variation' );

								$xorgcore_populate_email_address = null !== xorgcore_get_cart_session( 'xorgcore_populate_email' ) && '' != xorgcore_get_cart_session( 'xorgcore_populate_email' ) ? xorgcore_get_cart_session( 'xorgcore_populate_email' ) : '';
								wp_localize_script(
									'wc-add-to-cart-variation',
									'xorgcore_atc_modal_param',
									self::xorgcore_atc_localize_params( $xorgcore_atc_modal )
								);
							} else {
								wp_dequeue_script( 'wc-add-to-cart-variation' );
								wp_deregister_script( 'wc-add-to-cart-variation' );

								wp_register_script( 'wc-add-to-cart-variation', xorgcore_PLUGIN_URL . '/assets/js/frontend/atc_modal_single_product' . $suffix . '.js', array( 'jquery', 'wp-util' ), '', true );

								wp_enqueue_script( 'wc-add-to-cart-variation' );

								wp_localize_script(
									'wc-add-to-cart-variation',
									'xorgcore_atc_modal_param_variation',
									self::xorgcore_atc_localize_params( $xorgcore_atc_modal )
								);
							}
						} elseif ( $xorgcore_product->is_type( 'grouped' ) ) {
							wp_enqueue_script( 'jquery' );
							wp_register_script( 'xorgcore_atc_group_product', xorgcore_PLUGIN_URL . '/assets/js/frontend/atc_group_page' . $suffix . '.js' );
							wp_enqueue_script( 'xorgcore_atc_group_product' );

							wp_localize_script(
								'xorgcore_atc_group_product',
								'xorgcore_atc_modal_param',
								self::xorgcore_atc_localize_params( $xorgcore_atc_modal )
							);
						}
					}

					if ( is_cart() && ( 'yes' === get_option( 'woocommerce_cart_redirect_after_add' ) || 'no' === get_option( 'woocommerce_cart_redirect_after_add' ) ) ) {
						wp_enqueue_script( 'jquery' );
						wp_register_script( 'xorgcore_atc_cart', xorgcore_PLUGIN_URL . '/assets/js/frontend/atc_cart_page' . $suffix . '.js' );
						wp_enqueue_script( 'xorgcore_atc_cart' );
						wp_localize_script(
							'xorgcore_atc_cart',
							'xorgcore_atc_cart_param',
							array(
								'xorgcore_ajax_url' => xorgcore_ADMIN_URL,
							)
						);
					}

					$atc_coupon_code = '';
					if ( 'on' === get_option( 'xorgcore_atc_auto_apply_coupon_enabled', '' ) && 'pre-selected' === get_option( 'xorgcore_atc_coupon_type', '' ) && 0 < get_option( 'xorgcore_atc_popup_coupon', 0 ) ) {
						$atc_coupon_code = get_the_title( get_option( 'xorgcore_atc_popup_coupon', 0 ) );
					}
					do_action( 'xorgcore_after_atc_scripts_loaded', $xorgcore_atc_modal, $xorgcore_populate_email_address, $atc_coupon_code );
				}
			}

			if ( xorgcore_get_cart_session( 'xorgcore_email_sent_id' ) == '' && ( 'on' === get_option( 'ac_capture_email_from_forms' ) || '' !== get_option( 'ac_capture_email_address_from_url' ) ) && ! is_user_logged_in() ) {
				wp_register_script( 'xorgcore_mailchimp_capture', xorgcore_PLUGIN_URL . '/assets/js/frontend/mailchimp_capture' . $suffix . '.js' );
				wp_localize_script(
					'xorgcore_mailchimp_capture',
					'xorgcore_mailchimp_setting',
					array(
						'xorgcore_popup_setting' => get_option( 'xorgcore_atc_enable_modal' ),
						'xorgcore_form_classes'  => str_replace( ' ', '', trim( get_option( 'ac_email_forms_classes' ) ) ),
						'xorgcore_ajax_url'      => xorgcore_ADMIN_AJAX_URL,
						'xorgcore_url_capture'   => get_option( 'ac_capture_email_address_from_url' ),
					)
				);
				wp_enqueue_script( 'xorgcore_mailchimp_capture' );
			}
		}

		
		public static function xorgcore_enqueue_css_atc_modal() {
			if ( ! is_cart() && ! is_checkout() && ! is_user_logged_in() ) {
				wp_enqueue_style( 'xorgcore_abandoned_details_modal', xorgcore_PLUGIN_URL . '/assets/css/frontend/atc_detail_modal.min.css' );
			}
			if ( ( is_cart() || is_checkout() ) && ! is_user_logged_in() ) {
				wp_enqueue_style( 'xorgcore_countdown_timer', xorgcore_PLUGIN_URL . '/assets/css/frontend/atc_countdown_timer.css' );
				wp_enqueue_style( 'xorgcore-font-awesome', xorgcore_PLUGIN_URL . '/assets/css/admin/font-awesome.css' );
				wp_enqueue_style( 'xorgcore-font-awesome-min', xorgcore_PLUGIN_URL . '/assets/css/admin/font-awesome.min.css' );
			}
		}

		
		public static function xorgcore_enqueue_scripts_css( $hook ) {
			global $pagenow;

			$page = isset( $_GET['page'] ) ? $_GET['page'] : '';

			if ( $hook != 'woocommerce_page_xcart' && 'index.php' === $pagenow ) {
				wp_enqueue_style( 'xorgcore-dashboard', xorgcore_PLUGIN_URL . '/assets/css/admin/style.min.css' );
				return;
			} elseif ( $page === 'xcart' ) {
				wp_enqueue_style( 'jquery-ui', xorgcore_PLUGIN_URL . '/assets/css/admin/jquery-ui.css', '', '', false );
				wp_enqueue_style( 'woocommerce_admin_styles', plugins_url() . '/woocommerce/assets/css/admin.css' );
				wp_enqueue_style( 'jquery-ui-style', xorgcore_PLUGIN_URL . '/assets/css/admin/jquery-ui-smoothness.css' );

				$action = '';
				if ( isset( $_GET['action'] ) ) {
					$action = xorgcore_Common::xorgcore_get_action();
				}

				$section = isset( $_GET['section'] ) ? $_GET['section'] : '';
				if ( 'xorgcore_dashboard_advanced' == $action || '' == $action || 'listcart' === $action ) {
					wp_enqueue_style( 'xorgcore-dashboard-adv', xorgcore_PLUGIN_URL . '/assets/css/admin/reports_adv.css' );

					wp_register_style( 'bootstrap_css', xorgcore_PLUGIN_URL . '/assets/css/admin/bootstrap.min.css', '', '', 'all' );
					wp_enqueue_style( 'bootstrap_css' );

					wp_enqueue_style( 'xorgcore-font-awesome', xorgcore_PLUGIN_URL . '/assets/css/admin/font-awesome.css' );

					wp_enqueue_style( 'xorgcore-font-awesome-min', xorgcore_PLUGIN_URL . '/assets/css/admin/font-awesome.min.css' );
				}

				if ( 'xorgcore_dashboard' == $action || '' == $action ) {
					wp_enqueue_style( 'xorgcore-dashboard', xorgcore_PLUGIN_URL . '/assets/css/admin/reports.min.css' );
				}

				if ( 'listcart' == $action || 'cart_recovery' == $action ) {
					wp_enqueue_style( 'abandoned-orders-list', xorgcore_PLUGIN_URL . '/assets/css/admin/view_xcart_orders_style.min.css' );
				}

				if ( 'cart_recovery' == $action ) {
					wp_register_style( 'bootstrap_css', xorgcore_PLUGIN_URL . '/assets/css/admin/bootstrap.min.css', '', '', 'all' );
					wp_enqueue_style( 'bootstrap_css' );
					wp_enqueue_style( 'xorgcore_template_activate', xorgcore_PLUGIN_URL . '/assets/css/admin/template_activate.min.css' );
					wp_enqueue_style( 'xorgcore_preview_email', xorgcore_PLUGIN_URL . '/assets/css/admin/preview_email.min.css' );
					wp_enqueue_style( 'xorgcore_modal_preview', xorgcore_PLUGIN_URL . '/assets/css/admin/preview_modal.css' );
				}
				if ( 'cart_recovery' === $action && 'emailtemplates' === $section ) {
					wp_enqueue_style( 'xorgcore_template_style', xorgcore_PLUGIN_URL . '/assets/css/admin/email_templates.css' );
				}
				if ( 'listcart' == $action || 'emailstats' == $action ) {
					wp_enqueue_style( 'xorgcore_abandoned_details_modal', xorgcore_PLUGIN_URL . '/assets/css/admin/xcart_modal.min.css' );
					wp_enqueue_style( 'xorgcore_abandoned_details', xorgcore_PLUGIN_URL . '/assets/css/admin/view_order_button.min.css' );
				}
				if ( 'emailsettings' == $action ) {
					wp_enqueue_style( 'xorgcore_add_to_cart_popup_modal', xorgcore_PLUGIN_URL . '/assets/css/admin/add_to_cart_popup_modal.min.css' );
				}
			}

			$action  = isset( $_GET['action'] ) ? $_GET['action'] : '';
			$section = isset( $_GET['section'] ) ? $_GET['section'] : '';

			if ( 'cart_recovery' == $action ) {
				wp_enqueue_style( 'xorgcore_sms_list', xorgcore_PLUGIN_URL . '/assets/css/admin/sms_template_list.css' );
				wp_enqueue_style( 'xorgcore-font-awesome', xorgcore_PLUGIN_URL . '/assets/css/admin/font-awesome.css' );

				wp_enqueue_style( 'xorgcore-font-awesome-min', xorgcore_PLUGIN_URL . '/assets/css/admin/font-awesome.min.css' );
			}
			$xorgcore_section = isset( $_GET['xorgcore_section'] ) ? $_GET['xorgcore_section'] : '';
			if ( 'emailsettings' === $action && 'xorgcore_atc_settings' === $xorgcore_section ) {
				wp_enqueue_style( 'xorgcore-font-awesome', xorgcore_PLUGIN_URL . '/assets/css/admin/font-awesome.css' );
				wp_enqueue_style( 'xorgcore-font-awesome-min', xorgcore_PLUGIN_URL . '/assets/css/admin/font-awesome.min.css' );
			}
		}

		
		public static function xorgcore_atc_localize_params( $xorgcore_atc_modal ) {
			$xorgcore_populate_email_address = null !== xorgcore_get_cart_session( 'xorgcore_populate_email' ) && '' != xorgcore_get_cart_session( 'xorgcore_populate_email' ) ? xorgcore_get_cart_session( 'xorgcore_populate_email' ) : '';

			$atc_coupon_code = '';
			if ( 'on' === get_option( 'xorgcore_atc_auto_apply_coupon_enabled', '' ) && 'pre-selected' === get_option( 'xorgcore_atc_coupon_type', '' ) && 0 < get_option( 'xorgcore_atc_popup_coupon', 0 ) ) {
				$atc_coupon_code = get_the_title( get_option( 'xorgcore_atc_popup_coupon', 0 ) );
			}

			$localize_params = array(
				'xorgcore_atc_modal_data'               => $xorgcore_atc_modal,
				'xorgcore_atc_head'                     => __( get_option( 'xorgcore_heading_section_text_email' ), 'xcart-tr' ),
				'xorgcore_atc_text'                     => __( get_option( 'xorgcore_text_section_text' ), 'xcart-tr' ),
				'xorgcore_atc_email_place'              => __( get_option( 'xorgcore_email_placeholder_section_input_text' ), 'xcart-tr' ),
				'xorgcore_atc_button'                   => __( get_option( 'xorgcore_button_section_input_text' ), 'xcart-tr' ),
				'xorgcore_atc_button_bg_color'          => get_option( 'xorgcore_button_color_picker' ),
				'xorgcore_atc_button_text_color'        => get_option( 'xorgcore_button_text_color_picker' ),
				'xorgcore_atc_popup_text_color'         => get_option( 'xorgcore_popup_text_color_picker' ),
				'xorgcore_atc_popup_heading_color'      => get_option( 'xorgcore_popup_heading_color_picker' ),
				'xorgcore_atc_non_mandatory_input_text' => __( get_option( 'xorgcore_non_mandatory_text' ), 'xcart-tr' ),
				'xorgcore_atc_mandatory_email'          => get_option( 'xorgcore_atc_mandatory_email' ),
				'xorgcore_ajax_add'                     => get_option( 'woocommerce_enable_ajax_add_to_cart' ),
				'xorgcore_populate_email'               => $xorgcore_populate_email_address,
				'xorgcore_ajax_url'                     => xorgcore_ADMIN_URL,
				'xorgcore_mandatory_text'               => __( 'شماره تماس صرفا جهت سبد خرید شماست.', 'xcart-tr' ),
				'xorgcore_mandatory_email_text'         => __( 'لطفا زبان کیبرد را انگلیسی نمایید.', 'xcart-tr' ),
				'xorgcore_atc_coupon_applied_msg'       => __( "با تشکر از شما. کپن $atc_coupon_code برای سبد خرید شما فعال شد.", 'xcart-tr' ),
			);

			$localize_params = apply_filters( 'xorgcore_popup_params', $localize_params );

			return $localize_params;
		}

		public static function xorgcore_template_params() {

			$localized_array = array();

			for ( $temp = 1; $temp < 13; $temp++ ) {
				$temp_obj       = new stdClass();
				$temp_obj->id   = $temp;
				$temp_obj->url  = xorgcore_PLUGIN_URL . '/assets/images/templates/template_' . $temp . '.png';
				$temp_obj->html = xorgcore_PLUGIN_URL . '/assets/html/templates/template_' . $temp . '.html';

				array_push( $localized_array, $temp_obj );
			}

			return $localized_array;
		}
	}
}
