<?php



if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! class_exists( 'xorgcore_Email_Verification' ) ) {

	
	class xorgcore_Email_Verification {

		
		public function __construct() {
			add_action( 'xorgcore_add_new_settings', array( &$this, 'add_verification_settings' ) );

			add_filter( 'xorgcore_popup_params', array( &$this, 'xorgcore_add_api_param' ) );
		}

		
		public function add_verification_settings() {

		

			register_setting(
				'woocommerce_ac_settings',
				'xorgcore_enable_debounce'
			);

			register_setting(
				'woocommerce_ac_settings',
				'ac_debounce_api'
			);
		}

		
		public static function xorgcore_enable_debounce_callback( $args ) {
			$enable_debounce = get_option( 'xorgcore_enable_debounce', '' );
			$debounce_choice = 'on' === $enable_debounce ? 'checked' : '';
			?>

			<input
				type="checkbox"
				id="xorgcore_enable_debounce"
				name="xorgcore_enable_debounce"
				value="on"
				<?php echo esc_attr( $debounce_choice ); ?> />
			<label for="xorgcore_enable_debounce"><?php echo esc_attr( $args[0] ); ?></label>
			<?php
		}

		
		public function xorgcore_debounce_api_callback( $args ) {
			$debounce_key = get_option( 'ac_debounce_api' );
			?>

			<input
				type="text"
				id="ac_debounce_api"
				name="ac_debounce_api"
				value="<?php echo isset( $debounce_key ) ? esc_attr( $debounce_key ) : ''; ?>" />
			<label for="ac_debounce_api"><?php echo esc_attr( $args[0] ); ?></label>
			<?php
		}

		
		public function xorgcore_add_api_param( $localize_params ) {

			if ( 'on' === get_option( 'xorgcore_enable_debounce', '' ) && '' !== get_option( 'ac_debounce_api' ) ) {
				$localize_params['xorgcore_debounce_key'] = get_option( 'ac_debounce_api' );
			}
			return $localize_params;
		}
	}
}

return new xorgcore_Email_Verification();
