<?php


if (!defined('ABSPATH')) {
    exit; 
}
if ( !class_exists('xorgcore_Load_Hooks' ) ) {
    
    class xorgcore_Load_Hooks {
        
        public static function xorgcore_load_hooks_and_filters() {
            
            //add_action( 'init',                         array( 'xorgcore_Load_Hooks',    'xorgcore_load_component_file' ) );
            
            if( is_plugin_active('aelia-currency-switcher-addon-for-abandoned-cart/aelia-currency-switcher-addon-for-abandoned-cart.php') ){
                add_action( 'admin_init', array( 'xorgcore_Load_Hooks', 'xorgcore_deactivate_aelia_addon' ) );
            }

            if ( class_exists( 'xorgcore_Update_Check' ) ) {
                add_action( 'admin_init',  array( 'xorgcore_Update_Check',    'xorgcore_update_db_check' ) );
            }
            
            if ( class_exists( 'xorgcore_Add_Settings' ) ) {
                add_action( 'admin_init',  array( 'xorgcore_Add_Settings', 'xorgcore_initialize_plugin_options' ) );
            }
            
            $xorgcore_plugin_dir  = dirname( dirname( plugin_basename( __FILE__ ) ) );
            $xorgcore_plugin_dir .= '/xcart.php';
            
            add_filter( 'plugin_action_links_' . $xorgcore_plugin_dir,     array( 'xorgcore_Common',         'xorgcore_plugin_action_links' ) );
            //Add plugin doc and forum link in description
            add_filter( 'plugin_row_meta',                             array( 'xorgcore_Common',         'xorgcore_plugin_row_meta' ), 10, 2 );
            
            if ( class_exists( 'xorgcore_Cart_Updated' ) ) {
                //add_action( 'woocommerce_cart_updated',                array( 'xorgcore_Cart_Updated',   'xorgcore_store_cart_timestamp_new' ), 100 );
                if ( 'off' === get_option( 'xorgcore_atc_enable_modal' ) ) {
                    add_action( 'woocommerce_cart_updated', array( 'xorgcore_Cart_Updated', 'xorgcore_update_session_id' ), 100 );
                }

                add_action( 'woocommerce_add_to_cart',                     array( 'xorgcore_Cart_Updated',   'xorgcore_store_cart_timestamp' ), 999 );
                add_action( 'woocommerce_cart_item_removed',               array( 'xorgcore_Cart_Updated',   'xorgcore_store_cart_timestamp' ), 100 );
                add_action( 'woocommerce_cart_item_restored',              array( 'xorgcore_Cart_Updated',   'xorgcore_store_cart_timestamp' ), 100 );
                add_action( 'woocommerce_after_cart_item_quantity_update', array( 'xorgcore_Cart_Updated',   'xorgcore_store_cart_timestamp' ), 100 );
                add_action( 'woocommerce_calculate_totals',                array( 'xorgcore_Cart_Updated',   'xorgcore_store_cart_timestamp' ), 100 );

                
                add_filter( 'woocommerce_login_redirect',              array( 'xorgcore_Cart_Updated',   'xorgcore_delete_non_logged_in_cart' ), 10, 2 );
                add_action( 'woocommerce_before_checkout_form',        array( 'xorgcore_Cart_Updated', 'xorgcore_add_banner' ), 100 );
                if ( 'on' == get_option( 'xorgcore_countdown_cart', '' ) ) {
                    add_action( 'woocommerce_before_cart_table',       array( 'xorgcore_Cart_Updated', 'xorgcore_add_banner' ), 100 );
                }
                add_action( 'woocommerce_removed_coupon',              array( 'xorgcore_Cart_Updated', 'xorgcore_update_coupon_details' ), 99, 1 );
            }
            
            add_action( 'admin_menu',                                  array( 'xorgcore_Menu',            'xorgcore_admin_menu' ) );
            
            add_filter( 'woocommerce_order_details_after_order_table', array( 'xorgcore_Order_Received', 'xorgcore_action_after_delivery_session' ) );
            add_action( 'admin_enqueue_scripts',                       array( 'xorgcore_Load_Scripts',   'xorgcore_enqueue_scripts_js' ) );
            add_action( 'admin_enqueue_scripts',                       array( 'xorgcore_Load_Scripts',   'xorgcore_enqueue_scripts_css' ) );
            
            add_filter( 'template_include',                            array( 'xorgcore_Populate_Cart_Of_User', 'xorgcore_email_track_links' ), 99, 1 );
            
            $sms_setting = get_option( 'xorgcore_enable_sms_reminders' );
            $fb_setting = get_option( 'xorgcore_enable_fb_reminders' );
            if ( ( isset( $sms_setting ) && $sms_setting === 'on' ) ||
                 ( isset( $fb_setting ) && $fb_setting === 'on' ) ) {
                add_filter( 'template_include',                            array( 'xorgcore_Populate_Cart_Of_User', 'xorgcore_shortcode_redirects' ), 100, 1 );
                add_filter( 'template_include',                            array( 'xorgcore_Populate_Cart_Of_User', 'xorgcore_sms_redirects' ), 101, 1 );
            }
            
            if( class_exists( 'xorgcore_Tiny_Mce' ) ) {
                add_action( 'admin_init',                              array( 'xorgcore_Tiny_Mce',              'xorgcore_add_tiny_mce_button_and_plugin' ) );            
            }
            add_action( 'template_include',                            array( 'xorgcore_Populate_Cart_Of_User', 'xorgcore_email_track_open_and_unsubscribe') );
            add_action( 'template_include',                            array( 'xorgcore_Populate_Cart_Of_User', 'xorgcore_if_email_address_exists') );
            
            $display_tracked_coupons = get_option( 'ac_track_coupons' );
            
            if( $display_tracked_coupons == '' || $display_tracked_coupons == null ) {
                update_option( 'ac_track_coupons', 'on' );
                $display_tracked_coupons = 'on';
            }
            if( $display_tracked_coupons == 'on' && class_exists( 'xorgcore_Coupon' ) ) {
                add_action( 'woocommerce_coupon_error',                array( 'xorgcore_Coupon', 'xorgcore_capture_coupon_error' ), 15, 2 );
                add_action( 'woocommerce_applied_coupon',              array( 'xorgcore_Coupon', 'xorgcore_capture_applied_coupon' ), 15, 2 );
            }
            
            if( class_exists( 'xorgcore_Coupon' ) ) {
                
                add_action( 'woocommerce_before_cart_table',               array( 'xorgcore_Coupon', 'xorgcore_apply_direct_coupon_code' ) );
                
                add_action( 'woocommerce_before_checkout_form',            array( 'xorgcore_Coupon', 'xorgcore_apply_direct_coupon_code' ) );
            }
            if( is_admin() ) {
                if( class_exists( 'xorgcore_Dashboard_Widget' ) ) {
                    add_action( 'wp_dashboard_setup',                      array( 'xorgcore_Dashboard_Widget', 'xorgcore_register_dashboard_widget' ), 10 );
                }
                add_filter( 'xorgcore_ts_tracker_data',                         array( 'xorgcore_Common', 'ts_add_plugin_tracking_data' ), 10, 1 );
                add_filter( 'ts_tracker_opt_out_data',                 array( 'xorgcore_Common', 'xorgcore_get_data_for_opt_out' ), 10, 1 );
                
                add_filter ( 'ts_deativate_plugin_questions',          array( 'xorgcore_Common', 'xorgcore_deactivate_add_questions' ), 10, 1 );

                xorgcore_Load_Hooks::xorgcore_load_ajax_function();
            }
            
            add_action( 'init',                                        array( __CLASS__ ,   'xorgcore_update_po_file' ) );
            if ( class_exists( 'xorgcore_Localization' ) ) {
                add_action( 'admin_init',                              array( 'xorgcore_Localization',   'xorgcore_register_template_string_for_wpml' ) );
            }
            if ( class_exists( 'xorgcore_EDD' ) ) {
                add_action( 'admin_init',                              array( 'xorgcore_EDD',            'xorgcore_edd_ac_register_option' ) );
                add_action( 'admin_init',                              array( 'xorgcore_EDD',            'xorgcore_edd_ac_deactivate_license' ) );
                add_action( 'admin_init',                              array( 'xorgcore_EDD',            'xorgcore_edd_ac_activate_license' ) );
            }
            add_action( 'woocommerce_order_status_changed',            array( 'xorgcore_Admin_Recovery', 'xorgcore_email_admin_recovery' ), 11, 3 );
            
            
            $xorgcore_auto_cron = get_option ( 'xorgcore_use_auto_cron' );
            if ( isset( $xorgcore_auto_cron ) && $xorgcore_auto_cron != false && '' != $xorgcore_auto_cron ) {
            }
            //delete abandoned order after X number of days
            if ( class_exists( 'xorgcore_Actions_Handler' ) ) {
                add_action( 'xorgcore_clear_carts',                        array( 'xorgcore_Actions_Handler', 'xorgcore_delete_abandoned_carts_after_x_days' ) );
                add_action( 'woocommerce_ac_delete_coupon_action',     array( 'xorgcore_Actions_Handler', 'xorgcore_delete_coupon_codes_after_x_days' ) );
            }
            add_action('update_option_xorgcore_cron_time_duration',        array( 'xorgcore_Common', 'xorgcore_cron_time_duration' ) );

            if ( class_exists( 'xorgcore_Print_And_CSV' ) ) {
                add_action( 'admin_init',                              array( 'xorgcore_Print_And_CSV', 'xorgcore_print_data' ) );
            }
            if( class_exists( 'xorgcore_On_Placed_Order' ) ) {
                add_action( 'woocommerce_checkout_order_processed',      array( 'xorgcore_On_Placed_Order' , 'xorgcore_order_placed' ), 10, 1 );
                //add_filter( 'woocommerce_payment_complete_order_status', array( 'xorgcore_On_Placed_Order' , 'xorgcore_order_complete_action'), 10, 2 );
                add_action( 'woocommerce_order_status_changed',          array( 'xorgcore_On_Placed_Order', 'xorgcore_cart_details_update' ), 10, 3 );
                add_filter( 'woocommerce_cancel_unpaid_order',           array( 'xorgcore_On_Placed_Order', 'xorgcore_update_cart_status' ), 10, 2 );
            }    
            add_action( 'admin_init',                                  array( 'xorgcore_Common', 'xorgcore_output_buffer') );
            add_action( 'wp_login',                                    array( 'xorgcore_Common', 'xorgcore_remove_action_hook' ), 1 );
            add_filter( 'wc_session_expiring',                         array( 'xorgcore_Common', 'xorgcore_set_session_expiring' ),10,1 );
            add_filter( 'wc_session_expiration',                       array( 'xorgcore_Common', 'xorgcore_set_session_expired' ),10,1 );
            add_filter( 'woocommerce_checkout_fields',                 array( 'xorgcore_Common','guest_checkout_fields' ) );
            if( class_exists( 'xorgcore_Load_Scripts' ) ) {
                
                
                add_action( 'wfacp_footer_before_print_scripts',       array( 'xorgcore_Load_Scripts', 'xorgcore_include_js_for_guest' ) );
                
                add_action( 'wfacp_header_print_in_head',              array( 'xorgcore_Load_Scripts', 'xorgcore_include_js_for_guest' ) );
                add_filter( 'wfacp_default_values',                    array( 'xorgcore_Common','wfacp_guest_checkout_fields' ), 10, 3 );
                
                add_action( 'woocommerce_after_checkout_billing_form', array( 'xorgcore_Load_Scripts', 'xorgcore_include_js_for_guest' ) ) ;
                add_action( 'wp_enqueue_scripts',                      array( 'xorgcore_Load_Scripts', 'xorgcore_include_js_atc_coupon' ), 20 ) ;
                add_action( 'wp_enqueue_scripts',                      array( 'xorgcore_Load_Scripts',   'xorgcore_enqueue_scripts_atc_modal' ), 999 );
                //add_action( 'plugins_loaded',                          array( 'xorgcore_Load_Scripts',   'xorgcore_dequeue_scripts_atc_modal' ) );
                add_action( 'wp_enqueue_scripts',                      array( 'xorgcore_Load_Scripts',   'xorgcore_enqueue_css_atc_modal' ),10, 1 );
            }
            
            if ( in_array( 'xcart//xcart.php', (array) get_option( 'active_plugins', array() ) ) || 
                ( isset( $_GET ['xorgcore_plugin_link'] ) && 'xorgcore-update' == $_GET ['xorgcore_plugin_link'] ) ) {
                
                
                add_action( 'admin_menu',                              array( 'xorgcore_Import_Lite_to_Pro', 'xorgcore_admin_menus' ) );
                add_action( 'admin_init',                              array( 'xorgcore_Import_Lite_to_Pro', 'xorgcore_admin_init' ) );
            }
            xorgcore_Load_Hooks::xorgcore_load_front_end_ajax_function();
            add_action( 'media_buttons', array( 'xorgcore_Load_Hooks', 'xorgcore_add_extra_button' ), 10, 1 );
            
            add_action( 'admin_init', array( 'xorgcore_Load_Hooks', 'xorgcore_load_admin_ajax' ), 20 );

            
            add_action( 'admin_notices', array( 'xorgcore_Common', 'xorgcore_admin_promotions' ) );
            add_action( 'wp_ajax_xorgcore_dismiss_new_feature', array( 'xorgcore_Common', 'xorgcore_hide_notices' ) );
            add_action( 'wp_ajax_xorgcore_dismiss_admin_notice', array( 'xorgcore_Common', 'xorgcore_dismiss_admin_notice' ) );
            
            
            add_filter( 'woocommerce_screen_ids', array( 'xorgcore_Load_Hooks', 'xorgcore_set_wc_screen_ids' ) );

            
            add_action( 'plugins_loaded', array( 'xorgcore_Load_Hooks', 'xorgcore_load_as_library' ) );
            add_action( 'init', array( 'xorgcore_Load_Hooks', 'xorgcore_create_recurring_action' ) );
            add_action( 'update_option_xorgcore_cron_time_duration', array( 'xorgcore_Add_Settings', 'xorgcore_update_cron_interval' ), 10, 2 );
            add_action( 'update_option_xorgcore_use_auto_cron',      array( 'xorgcore_Add_Settings', 'xorgcore_use_auto_cron' ), 10, 2 );
			
			add_action( 'xorgcore_update_coupons', array( 'xorgcore_Update_Check', 'xorgcore_update_postmeta_coupons' ) );
        }

        public static function xorgcore_load_as_library() {
            if ( version_compare( WOOCOMMERCE_VERSION, "4.0.0" ) < 0 ) {
                require_once( 'plugins/action-scheduler/action-scheduler.php' );
            } else {
                require_once( WP_PLUGIN_DIR . '/woocommerce/packages/action-scheduler/action-scheduler.php' );
            }
        }
        
        
        public static function xorgcore_create_recurring_action() {
            $cron_interval = intval( get_option( 'xorgcore_cron_time_duration', 15 ) ) * 60;

            $reminders_list = xorgcore_get_enabled_reminders();
            if ( false === as_next_scheduled_action( 'woocommerce_ac_send_email_action' ) && count( $reminders_list ) > 0 && 'on' == get_option( 'xorgcore_use_auto_cron', '' ) ) {
                wp_clear_scheduled_hook( 'woocommerce_ac_send_email_action' );
                as_schedule_recurring_action( time(), $cron_interval, 'woocommerce_ac_send_email_action' );
            }
			if ( 'yes' !== get_option( 'xorgcore_coupons_data_updated', '' ) && false === as_next_scheduled_action( 'xorgcore_update_coupons' ) ) {
				as_schedule_single_action( time() + 60, 'xorgcore_update_coupons' );
				
				update_option( 'xorgcore_coupons_data_updated', 'yes' );
			}
        }

        
        public static function xorgcore_load_admin_ajax() {
            add_action( 'wp_ajax_xorgcore_delete_sms_template', array( 'xorgcore_SMS', 'xorgcore_delete_sms' ) );
            add_action( 'wp_ajax_xorgcore_save_bulk_sms_template', array( 'xorgcore_SMS', 'xorgcore_save_bulk_sms' ) );
            add_action( 'wp_ajax_xorgcore_test_sms', array( 'xorgcore_SMS_settings', 'xorgcore_send_test_sms' ) );
        }
        
        
        public static function xorgcore_load_ajax_function() {
            add_action( 'wp_ajax_xorgcore_preview_email_sent',             array( 'xorgcore_Ajax', 'xorgcore_preview_email_sent' ) );
            add_action( 'wp_ajax_xorgcore_toggle_template_status',         array( 'xorgcore_Ajax', 'xorgcore_toggle_template_status' ) );
            add_action( 'wp_ajax_xorgcore_abandoned_cart_info',            array( 'xorgcore_Ajax', 'xorgcore_abandoned_cart_info' ) );
            add_action( 'wp_ajax_xorgcore_admin_unsubscribe_cart',         array( 'xorgcore_Ajax', 'xorgcore_admin_unsubscribe_cart' ) );
            add_action( 'wp_ajax_xorgcore_edit_guest_email', array( 'xorgcore_Ajax', 'xorgcore_edit_guest_email' ) );
            add_action( 'wp_ajax_xorgcore_json_find_coupons',              array( 'xorgcore_Ajax', 'xorgcore_json_find_coupons' ) );
            add_action( 'wp_ajax_xorgcore_json_find_products',             array( 'xorgcore_Ajax', 'xorgcore_json_find_products' ) );
			add_action( 'wp_ajax_xorgcore_json_find_product_cat',          array( 'xorgcore_Ajax', 'xorgcore_json_find_product_cat' ) );
            add_action( 'wp_ajax_xorgcore_json_find_product_tag',          array( 'xorgcore_Ajax', 'xorgcore_json_find_product_tag' ) );
            add_action( 'wp_ajax_xorgcore_json_find_cart_status',          array( 'xorgcore_Ajax', 'xorgcore_json_find_cart_status' ) );
            add_action( 'wp_ajax_xorgcore_json_find_send_to',              array( 'xorgcore_Ajax', 'xorgcore_json_find_send_to' ) );
            add_action( 'wp_ajax_xorgcore_json_find_pages',                array( 'xorgcore_Ajax', 'xorgcore_json_find_pages' ) );
            add_action( 'wp_ajax_xorgcore_change_manual_email_data',       array( 'xorgcore_Ajax', 'xorgcore_change_manual_email_data' ) );
            
            if( class_exists( 'xorgcore_Dashboard_Widget' ) ) {
                add_action( 'wp_ajax_xorgcore_dashboard_widget_report',        array( 'xorgcore_Dashboard_Widget', 'xorgcore_dashboard_widget_report' ), 10 );
            }
            
            add_action( 'wp_ajax_xorgcore_toggle_atc_enable_status',       array( 'xorgcore_Ajax', 'xorgcore_toggle_atc_enable_status' ) );
            
            add_action( 'wp_ajax_xorgcore_atc_reset_setting',              array( 'xorgcore_Ajax', 'xorgcore_atc_reset_setting' ) );
            
            add_action( 'wp_ajax_xorgcore_toggle_atc_mandatory_status',    array( 'xorgcore_Ajax', 'xorgcore_toggle_atc_mandatory_status' ) );
            add_action( 'wp_ajax_xorgcore_toggle_atc_auto_coupon_settings', array('xorgcore_Ajax', 'xorgcore_toggle_atc_auto_coupon_settings' ) );
            $guest_cart = get_option( 'ac_disable_guest_cart_email' );
            if ( $guest_cart != "on" ) {
                add_action( 'wp_ajax_nopriv_xorgcore_save_guest_data',     array( 'xorgcore_Ajax','xorgcore_save_guest_data' ) );
                add_action( 'wp_ajax_xorgcore_save_guest_data',            array( 'xorgcore_Ajax','xorgcore_save_guest_data' ) );
                add_action( 'wp_ajax_nopriv_xorgcore_gdpr_refused',        array( 'xorgcore_Ajax', 'xorgcore_gdpr_refused' ) );
                add_action( 'wp_ajax_nopriv_xorgcore_coupon_countdown_dismissed', array( 'xorgcore_Ajax','xorgcore_coupon_countdown_dismissed' ) );
            }
            add_action( 'wp_ajax_xorgcore_gdpr_refused', array( 'xorgcore_Ajax', 'xorgcore_gdpr_refused' ) );
            
            
            add_action( 'wp_ajax_xorgcore_is_atc_enable',                  array( 'xorgcore_Ajax', 'xorgcore_is_atc_enable' ) );
            
            
            add_action( 'wp_ajax_xorgcore_preview_wc_email',               array( 'xorgcore_Ajax', 'xorgcore_preview_wc_email' ) );

            
            add_action( 'wp_ajax_xorgcore_preview_email',                  array( 'xorgcore_Ajax', 'xorgcore_preview_email' ) );

            
            add_action( 'wp_ajax_xorgcore_import_lite_data',               array( 'xorgcore_Ajax', 'xorgcore_import_lite_data' ) );
            add_action( 'wp_ajax_xorgcore_do_not_import_lite_data',        array( 'xorgcore_Ajax', 'xorgcore_do_not_import_lite_data' ) );

            
            add_action( 'wp_ajax_xorgcore_delete_expired_used_coupon_code',array( 'xorgcore_Ajax', 'xorgcore_delete_expired_used_coupon_code' ) );  


            add_action( 'edit_user_profile',                           array( 'xorgcore_Common', 'xorgcore_add_restrict_user_meta_field' ),50 );    
            add_action( 'show_user_profile',                           array( 'xorgcore_Common', 'xorgcore_add_restrict_user_meta_field' ),50  );    

            add_action( 'personal_options_update',                     array( 'xorgcore_Common', 'xorgcore_save_restrict_user_meta_field' ), 50 );
            add_action( 'edit_user_profile_update',                    array( 'xorgcore_Common', 'xorgcore_save_restrict_user_meta_field' ),50  );  
        }

        
        public static function xorgcore_load_component_file (){
            
            $is_admin = is_admin();

            if ( true === $is_admin ) {
                require_once( "x_all_component.php" );
            }
        }

        public static function xorgcore_deactivate_aelia_addon(){
            deactivate_plugins( 'aelia-currency-switcher-addon-for-abandoned-cart/aelia-currency-switcher-addon-for-abandoned-cart.php' );
            add_action( 'admin_notices', array( 'xorgcore_Load_Hooks', 'xorgcore_deactivate_error_notice' ) );
        }

        public static function xorgcore_deactivate_error_notice(){
            $class = 'notice notice-error is-dismissible';
            $message = __( '<b>Aelia Currency Switcher addon for XCart Plugin</b> has been deactivated since the addon is now part of the core module.', 'xcart-tr' );
            printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message );
        }

        
        public static function xorgcore_load_front_end_ajax_function() {
            add_action( 'wp_loaded',                                  array( 'xorgcore_Ajax', 'xorgcore_add_ajax_for_atc'  ) );
            add_action( 'wp_ajax_nopriv_xorgcore_atc_store_guest_email',  array( 'xorgcore_Ajax', 'xorgcore_atc_store_guest_email' ) );
            add_action( 'wc_ajax_xorgcore_track_notice', array( 'xorgcore_Ajax', 'xorgcore_track_carts' ) );

            add_action( 'wp_ajax_nopriv_xorgcore_add_email_to_cart',  array( 'xorgcore_Ajax', 'xorgcore_add_email_to_cart' ) );
            add_action( 'wp_ajax_xorgcore_add_email_to_cart',  array( 'xorgcore_Ajax', 'xorgcore_add_email_to_cart' ) );
        }

        
        Public static function xorgcore_update_po_file() {
            $domain = 'xcart-tr';
            $locale = apply_filters( 'plugin_locale', get_locale(), $domain );
            if ( $loaded = load_textdomain( $domain, trailingslashit( WP_LANG_DIR ) . $domain . '-' . $locale . '.mo' ) ) {
                return $loaded;
            } else {
                load_plugin_textdomain( $domain, FALSE, basename( dirname( __FILE__ ) ) . '/i18n/languages/' );
            }
        }

        public static function xorgcore_add_extra_button( $param ) {
            if ( 'woocommerce_ac_email_body' === $param ) {
                print( '<input type="button" class="button ac-insert-template add_media" data-toggle="modal" data-target=".xorgcore-preview-modal" value="Insert Template" />' );
                print( '<input type="button" class="button ac-import-template add_media" value="Import Template" />' );
            }
        }

        public static function xorgcore_set_wc_screen_ids( $screen ){
            $screen[] = 'woocommerce_page_xcart';
            return $screen;
        }

    }
}
